-- uespLogTradeData.lua -- by Dave Humphrey, dave@uesp.net
-- Code specific to mining skill coefficients.


uespLog.SkillCoefData = {}
uespLog.SkillCoefAbilityData = {}
uespLog.SkillCoefCalcData = {}
uespLog.SkillCoefBadData = {}
uespLog.SkillCoefSavedIds = {}
uespLog.SkillCoefAbilityCount = 0
uespLog.SkillCoefNumValidCoefCount = 0
uespLog.SkillCoefNumBadCoefCount = 0
uespLog.SkillCoefDataPointCount = 0
uespLog.SkillCoefDataIsCalculated = false

uespLog.SkillCoefTryRecalculateTypes = true
uespLog.SKILLCOEF_RECALC_MINR2 = 0.99

uespLog.SkillCoefArmorCountLA = 0
uespLog.SkillCoefArmorCountMA = 0
uespLog.SkillCoefArmorCountHA = 0
uespLog.SkillCoefWeaponCountDagger = 0
uespLog.SkillCoefArmorTypeCount = 0

uespLog.SKILL_COEF_DEBUG = false

uespLog.UESP_POWERTYPE_IGNORE        = -1000
uespLog.UESP_POWERTYPE_SOULTETHER    = -50
uespLog.UESP_POWERTYPE_LIGHTARMOR    = -51
uespLog.UESP_POWERTYPE_MEDIUMARMOR   = -52
uespLog.UESP_POWERTYPE_HEAVYARMOR    = -53
uespLog.UESP_POWERTYPE_WEAPONDAGGER  = -54
uespLog.UESP_POWERTYPE_ARMORTYPE     = -55
uespLog.UESP_POWERTYPE_DAMAGE        = -56
uespLog.UESP_POWERTYPE_ASSASSINATION = -57
uespLog.UESP_POWERTYPE_FIGHTERSGUILD = -58
uespLog.UESP_POWERTYPE_DRACONICPOWER = -59
uespLog.UESP_POWERTYPE_SHADOW = -60
uespLog.UESP_POWERTYPE_SIPHONING = -61
uespLog.UESP_POWERTYPE_SORCERER = -62
uespLog.UESP_POWERTYPE_MAGESGUILD = -63
uespLog.UESP_POWERTYPE_SUPPORT = -64
uespLog.UESP_POWERTYPE_ANIMALCOMPANION = -65
uespLog.UESP_POWERTYPE_GREENBALANCE = -66
uespLog.UESP_POWERTYPE_WINTERSEMBRACE = -67
uespLog.UESP_POWERTYPE_MAGICHEALTHCAP = -68
uespLog.UESP_POWERTYPE_BONETYRANT = -69
uespLog.UESP_POWERTYPE_GRAVELORD = -70
uespLog.UESP_POWERTYPE_SPELLDAMAGECAPPED = -71
uespLog.UESP_POWERTYPE_MAGICKAWITHWD = -72
uespLog.UESP_POWERTYPE_MAGICKACAPPED = -73
uespLog.UESP_POWERTYPE_WEAPONPOWER = -74
uespLog.UESP_POWERTYPE_CONSTANTVALUE = -75
uespLog.UESP_POWERTYPE_HEALTHORSPELLDAMAGE = -76
uespLog.UESP_POWERTYPE_RESISTANCE = -77
uespLog.UESP_POWERTYPE_MAGICLIGHTARMOR = -78
uespLog.UESP_POWERTYPE_HEALTHORDAMAGE = -79

uespLog.SKILLCOEF_CHECK_ABILITYID = 28302
uespLog.SKILLCOEF_CHECK_INDEX = 2
uespLog.SKILLCOEF_CHECK_VALUE = 300

uespLog.SKILLCOEF_BADFIT_MINR2 = 0.99

uespLog.SkillCoefAddAllValidCount = 0
uespLog.SkillCoefAddAllNewCount = 0
uespLog.SKILLCOEF_ADDALL_MAXABILITYID = uespLog.SkillDump_lastAbilityId
uespLog.SKILLCOEF_ADDALL_MAXABILITYCOUNT = 1000
uespLog.SkillCoefAddStartAbilityIndex = 1
uespLog.SKILLCOEF_ADDALL_DELAY = 500


uespLog.SKILLCOEF_MECHANIC_NAMES = {
	[POWERTYPE_ULTIMATE] = "Ultimate",
	[POWERTYPE_HEALTH] = "Health",
	[POWERTYPE_MAGICKA] = "Magicka",
	[POWERTYPE_STAMINA] = "Stamina",
	-- [4] = "Spell + Weapon Damage",	-- Same as UESP_POWERTYPE_DAMAGE, no longer used as of update 34?
	[uespLog.UESP_POWERTYPE_SOULTETHER] = "Ultimate (ignore WD)",
	[uespLog.UESP_POWERTYPE_LIGHTARMOR] = "Light Armor",
	[uespLog.UESP_POWERTYPE_MEDIUMARMOR] = "Medium Armor",
	[uespLog.UESP_POWERTYPE_HEAVYARMOR] = "Heavy Armor",
	[uespLog.UESP_POWERTYPE_WEAPONDAGGER] = "Daggers",
	[uespLog.UESP_POWERTYPE_ARMORTYPE] = "Armor Types",
	[uespLog.UESP_POWERTYPE_DAMAGE] = "Spell + Weapon Damage",
	[uespLog.UESP_POWERTYPE_ASSASSINATION] = "Assassination Skills Slotted",
	[uespLog.UESP_POWERTYPE_FIGHTERSGUILD] = "Fighters Guild Skills Slotted",
	[uespLog.UESP_POWERTYPE_DRACONICPOWER] = "Draconic Power Skills Slotted",
	[uespLog.UESP_POWERTYPE_SHADOW] = "Shadow Skills Slotted",
	[uespLog.UESP_POWERTYPE_SIPHONING] = "Siphoning Skills Slotted",
	[uespLog.UESP_POWERTYPE_SORCERER] = "Sorcerer Skills Slotted",
	[uespLog.UESP_POWERTYPE_MAGESGUILD] = "Mages Guild Skills Slotted",
	[uespLog.UESP_POWERTYPE_SUPPORT] = "Support Skills Slotted",
	[uespLog.UESP_POWERTYPE_ANIMALCOMPANION] = "Animal Companion Skills Slotted",
	[uespLog.UESP_POWERTYPE_GREENBALANCE] = "Green Balance Skills Slotted",
	[uespLog.UESP_POWERTYPE_WINTERSEMBRACE] = "Winter's Embrance Skills Slotted",
	[uespLog.UESP_POWERTYPE_MAGICHEALTHCAP] = "Magicka with Health Cap",
	[uespLog.UESP_POWERTYPE_BONETYRANT] = "Bone Tyrant Skills Slotted",
	[uespLog.UESP_POWERTYPE_GRAVELORD] = "Grave Lord Skills Slotted",
	[uespLog.UESP_POWERTYPE_SPELLDAMAGECAPPED] = "Spell Damage Capped",
	[uespLog.UESP_POWERTYPE_MAGICKAWITHWD] = "Magicka and Weapon Damage",
	[uespLog.UESP_POWERTYPE_MAGICKACAPPED] = "Magicka Capped",
	[uespLog.UESP_POWERTYPE_WEAPONPOWER] = "Weapon Power",
	[uespLog.UESP_POWERTYPE_CONSTANTVALUE] = "Constant Value",
	[uespLog.UESP_POWERTYPE_HEALTHORSPELLDAMAGE] = "Health or Spell Damage",
	[uespLog.UESP_POWERTYPE_RESISTANCE] = "Max Resistance",
	[uespLog.UESP_POWERTYPE_MAGICLIGHTARMOR] = "Magicka and Light Armor (Health Cap)",
}


uespLog.SKILLCOEF_RECALC_TYPES = {
	POWERTYPE_ULTIMATE,
	POWERTYPE_HEALTH,
	POWERTYPE_MAGICKA,
	POWERTYPE_STAMINA,
	uespLog.UESP_POWERTYPE_SOULTETHER,
	uespLog.UESP_POWERTYPE_LIGHTARMOR,
	uespLog.UESP_POWERTYPE_MEDIUMARMOR,
	uespLog.UESP_POWERTYPE_HEAVYARMOR,
	uespLog.UESP_POWERTYPE_ARMORTYPE,
	uespLog.UESP_POWERTYPE_DAMAGE,
	uespLog.UESP_POWERTYPE_MAGICKAWITHWD,
	uespLog.UESP_POWERTYPE_WEAPONPOWER,
	uespLog.UESP_POWERTYPE_RESISTANCE,
}


-- Some skills have different mechanics that what the game data says
uespLog.SKILLCOEF_SPECIALTYPES = {

	--[61503] = POWERTYPE_ULTIMATE,

	-- Sword Dancer set has weird variations with medium armor?
	[85622] = uespLog.UESP_POWERTYPE_IGNORE,

	-- Bash
	[21970] = POWERTYPE_ULTIMATE,

	-- NightBlade Grim Focus/Merciless Resolve/Relentless Focus
	[61919] = POWERTYPE_MAGICKA,
	[62111] = POWERTYPE_MAGICKA,
	[62114] = POWERTYPE_MAGICKA,
	[62117] = POWERTYPE_MAGICKA,
	
	[61927] = POWERTYPE_STAMAINA,
	[62099] = POWERTYPE_STAMAINA,
	[62103] = POWERTYPE_STAMAINA,
	[62107] = POWERTYPE_STAMAINA,
	
	[61902] = POWERTYPE_MAGICKA,
	[62090] = POWERTYPE_MAGICKA,
	[64176] = POWERTYPE_MAGICKA,
	[62096] = POWERTYPE_MAGICKA,
	
	-- NightBlade Soul Shred/Soul Tether/Soul Siphon
	-- The health stealing portion seems to always use Spell Damage
	-- Fixed sometime around update 29 or prior
	--[25091] = { [3] = uespLog.UESP_POWERTYPE_SOULTETHER },
	--[36154] = { [3] = uespLog.UESP_POWERTYPE_SOULTETHER },
	--[36160] = { [3] = uespLog.UESP_POWERTYPE_SOULTETHER },
	--[36166] = { [3] = uespLog.UESP_POWERTYPE_SOULTETHER },
	
	--[35508] = { [6] = uespLog.UESP_POWERTYPE_SOULTETHER },
	--[36172] = { [6] = uespLog.UESP_POWERTYPE_SOULTETHER },
	--[36179] = { [6] = uespLog.UESP_POWERTYPE_SOULTETHER },
	--[36186] = { [6] = uespLog.UESP_POWERTYPE_SOULTETHER },
	
	--[35460] = { [5] = uespLog.UESP_POWERTYPE_SOULTETHER },
	--[36193] = { [5] = uespLog.UESP_POWERTYPE_SOULTETHER },
	--[36200] = { [5] = uespLog.UESP_POWERTYPE_SOULTETHER },
	--[36207] = { [5] = uespLog.UESP_POWERTYPE_SOULTETHER },
	
	-- NightBlade Dark Cloak
	[25377] = POWERTYPE_HEALTH,
	[36341] = POWERTYPE_HEALTH,
	[36346] = POWERTYPE_HEALTH,
	[36351] = POWERTYPE_HEALTH,
	
	-- NightBlade Summon Shade
	[33211] = POWERTYPE_ULTIMATE,
	[36267] = POWERTYPE_ULTIMATE,
	[36271] = POWERTYPE_ULTIMATE,
	[36313] = POWERTYPE_ULTIMATE,
	
	-- NightBlade Dark Shade
	[35434] = POWERTYPE_ULTIMATE,
	[36273] = POWERTYPE_ULTIMATE,
	[36278] = POWERTYPE_ULTIMATE,
	[36283] = POWERTYPE_ULTIMATE,
	
	-- NightBlade Shadow Image
	[35441] = POWERTYPE_ULTIMATE,
	[36288] = POWERTYPE_ULTIMATE,
	[36293] = POWERTYPE_ULTIMATE,
	[36298] = POWERTYPE_ULTIMATE,
	
	-- NightBlade Mark Target
	[33357] = POWERTYPE_HEALTH,
	[37587] = POWERTYPE_HEALTH,
	[37595] = POWERTYPE_HEALTH,
	[37603] = POWERTYPE_HEALTH,
	
	-- NightBlade Repear's Mark
	[36967] = POWERTYPE_HEALTH,
	[37640] = POWERTYPE_HEALTH,
	[37649] = POWERTYPE_HEALTH,
	[37658] = POWERTYPE_HEALTH,
	
	-- NightBlade Piercing Mark
	[36968] = POWERTYPE_HEALTH,
	[37613] = POWERTYPE_HEALTH,
	[37622] = POWERTYPE_HEALTH,
	[37631] = POWERTYPE_HEALTH,
	
	-- NightBlade Killer's Blade
	[34843] = { [4] = POWERTYPE_HEALTH },
	[35586] = { [4] = POWERTYPE_HEALTH },
	[35588] = { [4] = POWERTYPE_HEALTH },
	[35590] = { [4] = POWERTYPE_HEALTH },
	
	-- Leeching Strikes
	[36908] = { [1] = POWERTYPE_MAGICKA, [2] = POWERTYPE_STAMINA, },
	[37989] = { [1] = POWERTYPE_MAGICKA, [2] = POWERTYPE_STAMINA, },
	[38002] = { [1] = POWERTYPE_MAGICKA, [2] = POWERTYPE_STAMINA, },
	[38015] = { [1] = POWERTYPE_MAGICKA, [2] = POWERTYPE_STAMINA, },
	
	-- Malevolent Offering / Shrewd Offering / Healthy Offering
	[33308] = POWERTYPE_MAGICKA,
	[36098] = POWERTYPE_MAGICKA,
	[36104] = POWERTYPE_MAGICKA,
	[36109] = POWERTYPE_MAGICKA,
	
	[34721] = POWERTYPE_MAGICKA,
	[36118] = POWERTYPE_MAGICKA,
	[36124] = POWERTYPE_MAGICKA,
	[36129] = POWERTYPE_MAGICKA,
	
	[34727] = POWERTYPE_MAGICKA,
	[36134] = POWERTYPE_MAGICKA,
	[36139] = POWERTYPE_MAGICKA,
	[36144] = POWERTYPE_MAGICKA,
	
	-- Defensive Posture
	[28727] = POWERTYPE_HEALTH,
	[41349] = POWERTYPE_HEALTH,
	[41350] = POWERTYPE_HEALTH,
	[41351] = POWERTYPE_HEALTH,
	
	-- Defensive Stance
	[38312] = POWERTYPE_HEALTH,
	[41352] = POWERTYPE_HEALTH,
	[41355] = POWERTYPE_HEALTH,
	[41358] = POWERTYPE_HEALTH,
		
	-- 1H+Shield Absorb Magic/Missle
	[38317] = POWERTYPE_HEALTH,
	[41370] = POWERTYPE_HEALTH,
	[41375] = POWERTYPE_HEALTH,
	[41380] = POWERTYPE_HEALTH,	
	
	-- Mages Guild Equilibrium/Spell Symmetry/Balance
	-- Are magicka abilities but scale off of health
	[31642] = POWERTYPE_HEALTH,
	[42247] = POWERTYPE_HEALTH,
	[42249] = POWERTYPE_HEALTH,
	[42251] = POWERTYPE_HEALTH,
	
	[40445] = POWERTYPE_HEALTH,
	[42253] = POWERTYPE_HEALTH,
	[42258] = POWERTYPE_HEALTH,
	[42263] = POWERTYPE_HEALTH,
	
	[40441] = POWERTYPE_HEALTH,
	[42268] = POWERTYPE_HEALTH,
	[42273] = POWERTYPE_HEALTH,
	[42278] = POWERTYPE_HEALTH,
	
	-- Mages Guild Magicka Controller
	[40438] = uespLog.UESP_POWERTYPE_MAGESGUILD,
	[45603] = uespLog.UESP_POWERTYPE_MAGESGUILD,
	
	-- Undaunted: Bone Shield
	[39369] = POWERTYPE_HEALTH,
	[43304] = POWERTYPE_HEALTH,
	[43307] = POWERTYPE_HEALTH,
	[43310] = POWERTYPE_HEALTH,
	
	-- Undaunted: Spiked Bone Shield
	[42138] = POWERTYPE_HEALTH,
	[43313] = POWERTYPE_HEALTH,
	[43318] = POWERTYPE_HEALTH,
	[43323] = POWERTYPE_HEALTH,
	
	-- Undaunted: Bone Surge
	[42176] = POWERTYPE_HEALTH,
	[43328] = POWERTYPE_HEALTH,
	[43331] = POWERTYPE_HEALTH,
	[43334] = POWERTYPE_HEALTH,
	
	
	-- Undaunted Inner Fire/Inner Rage/Inner Beast
	-- Numbers 4/6 seem to work like ultimates
	[39475] = { [4] = POWERTYPE_ULTIMATE, [6] = POWERTYPE_ULTIMATE },
	[43353] = { [4] = POWERTYPE_ULTIMATE, [6] = POWERTYPE_ULTIMATE },
	[43358] = { [4] = POWERTYPE_ULTIMATE, [6] = POWERTYPE_ULTIMATE },
	[43363] = { [4] = POWERTYPE_ULTIMATE, [6] = POWERTYPE_ULTIMATE },

	[42060] = { [5] = POWERTYPE_ULTIMATE, [7] = POWERTYPE_ULTIMATE },
	[43383] = { [5] = POWERTYPE_ULTIMATE, [7] = POWERTYPE_ULTIMATE },
	[43388] = { [5] = POWERTYPE_ULTIMATE, [7] = POWERTYPE_ULTIMATE },
	[43393] = { [5] = POWERTYPE_ULTIMATE, [7] = POWERTYPE_ULTIMATE },

	[42056] = { [3] = POWERTYPE_ULTIMATE, [5] = POWERTYPE_ULTIMATE },
	[43368] = { [3] = POWERTYPE_ULTIMATE, [5] = POWERTYPE_ULTIMATE },
	[43373] = { [3] = POWERTYPE_ULTIMATE, [5] = POWERTYPE_ULTIMATE },
	[43378] = { [3] = POWERTYPE_ULTIMATE, [5] = POWERTYPE_ULTIMATE },
	
	-- Undaunted Necrotic Orb/Mystic Orb/Energy Orb
	-- Number 2 acts like an ultimate
	[39298] = { [2] = POWERTYPE_ULTIMATE },
	[43400] = { [2] = POWERTYPE_ULTIMATE },
	[43403] = { [2] = POWERTYPE_ULTIMATE },
	[43406] = { [2] = POWERTYPE_ULTIMATE },
	
	[42028] = { [2] = POWERTYPE_ULTIMATE },
	[43409] = { [2] = POWERTYPE_ULTIMATE },
	[43412] = { [2] = POWERTYPE_ULTIMATE },
	[43415] = { [2] = POWERTYPE_ULTIMATE },
	
	[42038] = { [2] = POWERTYPE_ULTIMATE },
	[43439] = { [2] = POWERTYPE_ULTIMATE },
	[43443] = { [2] = POWERTYPE_ULTIMATE },
	[43447] = { [2] = POWERTYPE_ULTIMATE },
	
	-- Undaunted Trapping Webs/Tangling Webs/Shadow Silk	
	[39425] = { [5] = POWERTYPE_ULTIMATE, [7] = POWERTYPE_ULTIMATE },
	[43533] = { [5] = POWERTYPE_ULTIMATE, [7] = POWERTYPE_ULTIMATE },
	[43537] = { [5] = POWERTYPE_ULTIMATE, [7] = POWERTYPE_ULTIMATE },
	[43541] = { [5] = POWERTYPE_ULTIMATE, [7] = POWERTYPE_ULTIMATE },
	
	[42012] = { [5] = POWERTYPE_ULTIMATE, [8] = POWERTYPE_ULTIMATE },
	[43469] = { [5] = POWERTYPE_ULTIMATE, [8] = POWERTYPE_ULTIMATE },
	[43473] = { [5] = POWERTYPE_ULTIMATE, [8] = POWERTYPE_ULTIMATE },
	[43477] = { [5] = POWERTYPE_ULTIMATE, [8] = POWERTYPE_ULTIMATE },
	
	[41990] = { [5] = POWERTYPE_ULTIMATE, [7] = POWERTYPE_ULTIMATE, [8] = POWERTYPE_ULTIMATE },
	[43481] = { [5] = POWERTYPE_ULTIMATE, [7] = POWERTYPE_ULTIMATE, [8] = POWERTYPE_ULTIMATE },
	[43485] = { [5] = POWERTYPE_ULTIMATE, [7] = POWERTYPE_ULTIMATE, [8] = POWERTYPE_ULTIMATE },
	[43489] = { [5] = POWERTYPE_ULTIMATE, [7] = POWERTYPE_ULTIMATE, [8] = POWERTYPE_ULTIMATE },
	
	-- 1H & Shield Shielded Assault	
	-- Number 3 is based on health
	[38401] = { [3] = POWERTYPE_HEALTH },
	[41518] = { [3] = POWERTYPE_HEALTH },
	[41522] = { [3] = POWERTYPE_HEALTH },
	[41526] = { [3] = POWERTYPE_HEALTH },
	
	-- Fighters Guild Silver Shards/Silver Leash/Silver Bolts
	-- Its a stamina ability but number 4/5 scales on health
	--[40300] = { [1] = POWERTYPE_STAMINA },
	--[42659] = { [1] = POWERTYPE_HEALTH },
	--[42665] = { [1] = POWERTYPE_HEALTH },
	--[42671] = { [1] = POWERTYPE_HEALTH },

	--[40336] = { [1] = POWERTYPE_HEALTH },
	--[42677] = { [1] = POWERTYPE_HEALTH },
	--[42687] = { [1] = POWERTYPE_HEALTH },
	--[42696] = { [1] = POWERTYPE_HEALTH },
	
	--[35721] = { [4] = POWERTYPE_HEALTH },
	--[42647] = { [4] = POWERTYPE_HEALTH },
	--[42651] = { [4] = POWERTYPE_HEALTH },
	--[42655] = { [4] = POWERTYPE_HEALTH },
	
	-- Fighters Guild Slayer
	[35803] = { [2] = uespLog.UESP_POWERTYPE_FIGHTERSGUILD },
	[45595] = { [2] = uespLog.UESP_POWERTYPE_FIGHTERSGUILD },
	[45596] = { [2] = uespLog.UESP_POWERTYPE_FIGHTERSGUILD },	
	
	-- Templar Living Dark
	[22006] = uespLog.UESP_POWERTYPE_HEALTHORSPELLDAMAGE,
	[27313] = uespLog.UESP_POWERTYPE_HEALTHORSPELLDAMAGE,
	[27316] = uespLog.UESP_POWERTYPE_HEALTHORSPELLDAMAGE,
	[27324] = uespLog.UESP_POWERTYPE_HEALTHORSPELLDAMAGE,
	
	-- Templar Repentance
	[26821] = POWERTYPE_ULTIMATE,
	[27036] = POWERTYPE_ULTIMATE,
	[27040] = POWERTYPE_ULTIMATE,
	[27043] = POWERTYPE_ULTIMATE,
	
	-- Templar Sun Shield
	[22178] = { [1] = POWERTYPE_HEALTH },
	[27493] = { [1] = POWERTYPE_HEALTH },
	[27497] = { [1] = POWERTYPE_HEALTH },
	[27501] = { [1] = POWERTYPE_HEALTH },
	
	-- Templar Blazing Shield
	[22180] = { [1] = POWERTYPE_HEALTH },
	[27520] = { [1] = POWERTYPE_HEALTH },
	[27526] = { [1] = POWERTYPE_HEALTH },
	[27530] = { [1] = POWERTYPE_HEALTH },
	
	-- Templar Radiant Ward
	[22182] = { [1] = POWERTYPE_HEALTH },
	[27506] = { [1] = POWERTYPE_HEALTH },
	[27510] = { [1] = POWERTYPE_HEALTH },
	[27514] = { [1] = POWERTYPE_HEALTH },
	
	-- Templar Cleansing Ritual
	[22265] = POWERTYPE_ULTIMATE,
	[27243] = POWERTYPE_ULTIMATE,
	[27249] = POWERTYPE_ULTIMATE,
	[27255] = POWERTYPE_ULTIMATE,
	
	-- Templar Purifying Ritual/Ritual of Retribution
	[22259] = POWERTYPE_ULTIMATE,
	[27261] = POWERTYPE_ULTIMATE,
	[27269] = POWERTYPE_ULTIMATE,
	[27275] = POWERTYPE_ULTIMATE,
	
	-- Templar Extended Ritual
	[22262] = POWERTYPE_ULTIMATE,
	[27281] = POWERTYPE_ULTIMATE,
	[27288] = POWERTYPE_ULTIMATE,
	[27295] = POWERTYPE_ULTIMATE,
	
	-- Sorcerer Streak
	[23236] = POWERTYPE_ULTIMATE,
	[30208] = POWERTYPE_ULTIMATE,
	[30211] = POWERTYPE_ULTIMATE,
	[30215] = POWERTYPE_ULTIMATE,
	
	-- Sorcerer Encase
	[28025] = POWERTYPE_ULTIMATE,
	[30083] = POWERTYPE_ULTIMATE,
	[30085] = POWERTYPE_ULTIMATE,
	[30087] = POWERTYPE_ULTIMATE,
	
	-- Sorcerer Shattering Prison
	[28308] = { [3] = POWERTYPE_ULTIMATE },
	[30089] = { [3] = POWERTYPE_ULTIMATE },
	[30092] = { [3] = POWERTYPE_ULTIMATE },
	[30095] = { [3] = POWERTYPE_ULTIMATE },
	
	-- Sorcerer Restraining Prison
	[28311] = POWERTYPE_ULTIMATE,
	[30098] = POWERTYPE_ULTIMATE,
	[30103] = POWERTYPE_ULTIMATE,
	[30107] = POWERTYPE_ULTIMATE,
	
	-- Sorcerer Summon Unstable Familiar
	--[23304] = { [1] = POWERTYPE_STAMINA },
	--[30631] = { [1] = POWERTYPE_STAMINA },
	--[30636] = { [1] = POWERTYPE_STAMINA },
	--[30641] = { [1] = POWERTYPE_STAMINA },
	
	-- Sorcerer Summon Unstable Clannfear
	[23319] = { [1] = POWERTYPE_STAMINA, [2] = POWERTYPE_STAMINA, [5] = POWERTYPE_HEALTH, [6] = POWERTYPE_HEALTH },
	[30647] = { [1] = POWERTYPE_STAMINA, [2] = POWERTYPE_STAMINA, [5] = POWERTYPE_HEALTH, [6] = POWERTYPE_HEALTH },
	[30652] = { [1] = POWERTYPE_STAMINA, [2] = POWERTYPE_STAMINA, [5] = POWERTYPE_HEALTH, [6] = POWERTYPE_HEALTH },
	[30657] = { [1] = POWERTYPE_STAMINA, [2] = POWERTYPE_STAMINA, [5] = POWERTYPE_HEALTH, [6] = POWERTYPE_HEALTH },
	
	-- Sorcerer Lightning Splash
	[23182] = { [3] = POWERTYPE_ULTIMATE, [4] = POWERTYPE_ULTIMATE },
	[30259] = { [3] = POWERTYPE_ULTIMATE, [4] = POWERTYPE_ULTIMATE },
	[30264] = { [3] = POWERTYPE_ULTIMATE, [4] = POWERTYPE_ULTIMATE },
	[30269] = { [3] = POWERTYPE_ULTIMATE, [4] = POWERTYPE_ULTIMATE },
	
	-- Sorcerer Liquid Lightning
	[23200] = { [3] = POWERTYPE_ULTIMATE, [4] = POWERTYPE_ULTIMATE },
	[30274] = { [3] = POWERTYPE_ULTIMATE, [4] = POWERTYPE_ULTIMATE },
	[30280] = { [3] = POWERTYPE_ULTIMATE, [4] = POWERTYPE_ULTIMATE },
	[30286] = { [3] = POWERTYPE_ULTIMATE, [4] = POWERTYPE_ULTIMATE },
	
	-- Sorcerer Lightning Flood
	[23205] = { [3] = POWERTYPE_ULTIMATE, [4] = POWERTYPE_ULTIMATE },
	[30292] = { [3] = POWERTYPE_ULTIMATE, [4] = POWERTYPE_ULTIMATE },
	[30297] = { [3] = POWERTYPE_ULTIMATE, [4] = POWERTYPE_ULTIMATE },
	[30302] = { [3] = POWERTYPE_ULTIMATE, [4] = POWERTYPE_ULTIMATE },
	
	-- Sorcerer Conjured Ward
	[28418] = { [1] = uespLog.UESP_POWERTYPE_MAGICHEALTHCAP },
	[30457] = { [1] = uespLog.UESP_POWERTYPE_MAGICHEALTHCAP },
	[30460] = { [1] = uespLog.UESP_POWERTYPE_MAGICHEALTHCAP },
	[30463] = { [1] = uespLog.UESP_POWERTYPE_MAGICHEALTHCAP },
	
	-- Sorcerer Hardened Ward
	[29489] = { [1] = uespLog.UESP_POWERTYPE_MAGICHEALTHCAP },
	[30466] = { [1] = uespLog.UESP_POWERTYPE_MAGICHEALTHCAP },
	[30470] = { [1] = uespLog.UESP_POWERTYPE_MAGICHEALTHCAP },
	[30474] = { [1] = uespLog.UESP_POWERTYPE_MAGICHEALTHCAP },
	
	-- Sorcerer Empowered Ward
	[29482] = { [1] = uespLog.UESP_POWERTYPE_MAGICHEALTHCAP },
	[30478] = { [1] = uespLog.UESP_POWERTYPE_MAGICHEALTHCAP },
	[30482] = { [1] = uespLog.UESP_POWERTYPE_MAGICHEALTHCAP },
	[30486] = { [1] = uespLog.UESP_POWERTYPE_MAGICHEALTHCAP },
		
	-- Dragonknight Obsidian Shield	
	[29071] = { [1] = POWERTYPE_HEALTH },
	[33862] = { [1] = POWERTYPE_HEALTH },
	[33864] = { [1] = POWERTYPE_HEALTH },
	[33866] = { [1] = POWERTYPE_HEALTH },
	
	-- Dragonknight Igneous Shield	
	[29224] = { [1] = POWERTYPE_HEALTH, [2] = POWERTYPE_HEALTH },
	[33868] = { [1] = POWERTYPE_HEALTH, [2] = POWERTYPE_HEALTH },
	[33870] = { [1] = POWERTYPE_HEALTH, [2] = POWERTYPE_HEALTH },
	[33872] = { [1] = POWERTYPE_HEALTH, [2] = POWERTYPE_HEALTH },
	
	-- Dragonknight Fragmented Shield	
	[32673] = { [1] = POWERTYPE_HEALTH },
	[33875] = { [1] = POWERTYPE_HEALTH },
	[33878] = { [1] = POWERTYPE_HEALTH },
	[33881] = { [1] = POWERTYPE_HEALTH },
	
	-- Dragonknight Ferocious Leap
	[32715] = { [3] = POWERTYPE_HEALTH },
	[33671] = { [3] = POWERTYPE_HEALTH },
	[33675] = { [3] = POWERTYPE_HEALTH },
	[33679] = { [3] = POWERTYPE_HEALTH },
	
	-- Dragonknight Inferno
	[28967] = POWERTYPE_ULTIMATE,
	[34051] = POWERTYPE_ULTIMATE,
	[34056] = POWERTYPE_ULTIMATE,
	[34061] = POWERTYPE_ULTIMATE,
	
	-- Dragonknight Engulfing Flames
	[20930] = { [5] = uespLog.UESP_POWERTYPE_MAGICKACAPPED },
	[34042] = { [5] = uespLog.UESP_POWERTYPE_MAGICKACAPPED },
	[34045] = { [5] = uespLog.UESP_POWERTYPE_MAGICKACAPPED },
	[34048] = { [5] = uespLog.UESP_POWERTYPE_MAGICKACAPPED },
	
	-- Dragonknight Flames of Oblivion
	[32853] = POWERTYPE_ULTIMATE,
	[34066] = POWERTYPE_ULTIMATE,
	[34073] = POWERTYPE_ULTIMATE,
	[34080] = POWERTYPE_ULTIMATE,
	
	-- Dragonknight Cauterize
	[32881] = POWERTYPE_ULTIMATE,
	[34088] = POWERTYPE_ULTIMATE,
	[34094] = POWERTYPE_ULTIMATE,
	[34100] = POWERTYPE_ULTIMATE,
		
	-- Dragonknight Hardened Armor
	[20328] = { [3] = POWERTYPE_HEALTH },
	[23846] = { [3] = POWERTYPE_HEALTH },
	[23851] = { [3] = POWERTYPE_HEALTH },
	[23856] = { [3] = POWERTYPE_HEALTH },
	
	-- Dragonknight Standard
	--[28988] = { [5] = POWERTYPE_HEALTH },
	--[33955] = { [5] = POWERTYPE_HEALTH },
	--[33959] = { [5] = POWERTYPE_HEALTH },
	--[33963] = { [5] = POWERTYPE_HEALTH },
	
	-- Dragonknight Standard of Might	
	--[32947] = { [6] = POWERTYPE_HEALTH },
	--[34009] = { [6] = POWERTYPE_HEALTH },
	--[34015] = { [6] = POWERTYPE_HEALTH },
	--[34021] = { [6] = POWERTYPE_HEALTH },
	
	-- Dragonknight Shifting Standard	
	--[32958] = { [5] = POWERTYPE_HEALTH },	
	--[33967] = { [5] = POWERTYPE_HEALTH },
	--[33977] = { [5] = POWERTYPE_HEALTH },
	--[33987] = { [5] = POWERTYPE_HEALTH },
	
	-- Dragonknight Choking Talons	
	[20251] = { [5] = POWERTYPE_ULTIMATE },
	[32127] = { [5] = POWERTYPE_ULTIMATE },
	[32131] = { [5] = POWERTYPE_ULTIMATE },
	[32135] = { [5] = POWERTYPE_ULTIMATE },
	
	-- Dragonknight Dark Talons	
	[20245] = { [3] = POWERTYPE_ULTIMATE },
	[32105] = { [3] = POWERTYPE_ULTIMATE },
	[32108] = { [3] = POWERTYPE_ULTIMATE },
	[32111] = { [3] = POWERTYPE_ULTIMATE },
	
	-- Dragonknight Burning Talons	
	[20252] = { [5] = POWERTYPE_ULTIMATE },
	[32114] = { [5] = POWERTYPE_ULTIMATE },
	[32119] = { [5] = POWERTYPE_ULTIMATE },
	[32123] = { [5] = POWERTYPE_ULTIMATE },
	
	-- Dragonknight Battle Roar
	[29463] = { [1] = POWERTYPE_HEALTH, [2] = POWERTYPE_MAGICKA, [3] = POWERTYPE_STAMINA },
	[44984] = { [1] = POWERTYPE_HEALTH, [2] = POWERTYPE_MAGICKA, [3] = POWERTYPE_STAMINA },
	
	-- Dragonknight Elder Dragon
	[29460] = { [2] = uespLog.UESP_POWERTYPE_DRACONICPOWER },
	[44951] = { [2] = uespLog.UESP_POWERTYPE_DRACONICPOWER },
		
	-- Vampire Devouring Swarm
	[38931] = { [4] = uespLog.UESP_POWERTYPE_SOULTETHER },
	[41933] = { [4] = uespLog.UESP_POWERTYPE_SOULTETHER },
	[41936] = { [4] = uespLog.UESP_POWERTYPE_SOULTETHER },
	[41937] = { [4] = uespLog.UESP_POWERTYPE_SOULTETHER },
	
	-- Vampire Blood for Blood
	[38949] = POWERTYPE_MAGICKA,
	[41900] = POWERTYPE_MAGICKA,
	[41901] = POWERTYPE_MAGICKA,
	[41902] = POWERTYPE_MAGICKA,
	
	-- Werewolf Werewolf Transformation
	[32455] = POWERTYPE_STAMINA,
	[42356] = POWERTYPE_STAMINA,
	[42357] = POWERTYPE_STAMINA,
	[42358] = POWERTYPE_STAMINA,
	
	-- Werewolf Werewolf Berserker
	[39076] = POWERTYPE_ULTIMATE,	-- Change from Stamina to Ultimate in update 28
	[42377] = POWERTYPE_ULTIMATE,
	[42378] = POWERTYPE_ULTIMATE,
	[42379] = POWERTYPE_ULTIMATE,

	-- Werewolf Pack Leader
	[39075] = POWERTYPE_STAMINA,
	[42365] = POWERTYPE_STAMINA,
	[42366] = POWERTYPE_STAMINA,
	[42367] = POWERTYPE_STAMINA,
	
	-- Werewolf Hircine's Bounty
	[58310] = POWERTYPE_HEALTH,
	[58314] = POWERTYPE_HEALTH,
	[58315] = POWERTYPE_HEALTH,
	[58316] = POWERTYPE_HEALTH,
	
	-- Werewolf Hircine's Rage
	[58317] = POWERTYPE_HEALTH,
	[58319] = POWERTYPE_HEALTH,
	[58321] = POWERTYPE_HEALTH,
	[58323] = POWERTYPE_HEALTH,
	
	-- Werewolf Hircine's Fortitude
	[58325] = POWERTYPE_HEALTH,
	[58329] = POWERTYPE_HEALTH,
	[58332] = POWERTYPE_HEALTH,
	[58334] = POWERTYPE_HEALTH,
	
	-- Soul Trap
	[26768] = { [2] = POWERTYPE_STAMINA },
	[43050] = { [2] = POWERTYPE_STAMINA },
	[43053] = { [2] = POWERTYPE_STAMINA },
	[43056] = { [2] = POWERTYPE_STAMINA },
	
	-- Consuming Trap
	[40317] = { [2] = POWERTYPE_STAMINA, [4] = POWERTYPE_HEALTH, [6] = POWERTYPE_STAMINA },
	[43071] = { [2] = POWERTYPE_STAMINA, [4] = POWERTYPE_HEALTH, [6] = POWERTYPE_STAMINA },
	[43077] = { [2] = POWERTYPE_STAMINA, [4] = POWERTYPE_HEALTH, [6] = POWERTYPE_STAMINA },
	[43083] = { [2] = POWERTYPE_STAMINA, [4] = POWERTYPE_HEALTH, [6] = POWERTYPE_STAMINA },
	
	-- Soul Splitting Trap
	[40328] = { [2] = POWERTYPE_STAMINA },
	[43059] = { [2] = POWERTYPE_STAMINA },
	[43063] = { [2] = POWERTYPE_STAMINA },
	[43067] = { [2] = POWERTYPE_STAMINA },
	
	-- Alliance Support Replenishing Barrier	
	-- Although it's an ultimate the 3rd number seems to be only based off of magic
	[40239] = { [3] = POWERTYPE_MAGICKA },
	[46616] = { [3] = POWERTYPE_MAGICKA },
	[46619] = { [3] = POWERTYPE_MAGICKA },
	[46622] = { [3] = POWERTYPE_MAGICKA },
	
	-- Alliance Support Magicka Aid
	[39255] = { [2] = uespLog.UESP_POWERTYPE_SUPPORT },
	[45622] = { [2] = uespLog.UESP_POWERTYPE_SUPPORT },
	
	-- Light Armor: Annulment
	[29338] = uespLog.UESP_POWERTYPE_MAGICHEALTHCAP,
	[41106] = uespLog.UESP_POWERTYPE_MAGICHEALTHCAP,
	[41107] = uespLog.UESP_POWERTYPE_MAGICHEALTHCAP,
	[41108] = uespLog.UESP_POWERTYPE_MAGICHEALTHCAP,
	
	-- Light Armor Dampen Magic
	[39186] = { [2] = uespLog.UESP_POWERTYPE_MAGICHEALTHCAP, [5] = uespLog.UESP_POWERTYPE_LIGHTARMOR },
	[41109] = { [2] = uespLog.UESP_POWERTYPE_MAGICHEALTHCAP, [5] = uespLog.UESP_POWERTYPE_LIGHTARMOR },
	[41111] = { [2] = uespLog.UESP_POWERTYPE_MAGICHEALTHCAP, [5] = uespLog.UESP_POWERTYPE_LIGHTARMOR },
	[41113] = { [2] = uespLog.UESP_POWERTYPE_MAGICHEALTHCAP, [5] = uespLog.UESP_POWERTYPE_LIGHTARMOR },
	
	-- Light Armor Harness Magicka
	[39182] = { [2] = uespLog.UESP_POWERTYPE_MAGICHEALTHCAP, [5] = uespLog.UESP_POWERTYPE_LIGHTARMOR },
	[41115] = { [2] = uespLog.UESP_POWERTYPE_MAGICHEALTHCAP, [5] = uespLog.UESP_POWERTYPE_LIGHTARMOR },
	[41118] = { [2] = uespLog.UESP_POWERTYPE_MAGICHEALTHCAP, [5] = uespLog.UESP_POWERTYPE_LIGHTARMOR },
	[41121] = { [2] = uespLog.UESP_POWERTYPE_MAGICHEALTHCAP, [5] = uespLog.UESP_POWERTYPE_LIGHTARMOR },
	
	-- Medium Armor: Elude
	[39192] = { [3] = uespLog.UESP_POWERTYPE_MEDIUMARMOR, [4] = uespLog.UESP_POWERTYPE_MEDIUMARMOR },
	[41133] = { [3] = uespLog.UESP_POWERTYPE_MEDIUMARMOR, [4] = uespLog.UESP_POWERTYPE_MEDIUMARMOR },
	[41135] = { [3] = uespLog.UESP_POWERTYPE_MEDIUMARMOR, [4] = uespLog.UESP_POWERTYPE_MEDIUMARMOR },
	[41136] = { [3] = uespLog.UESP_POWERTYPE_MEDIUMARMOR, [4] = uespLog.UESP_POWERTYPE_MEDIUMARMOR }, -- ?
	[41137] = { [3] = uespLog.UESP_POWERTYPE_MEDIUMARMOR, [4] = uespLog.UESP_POWERTYPE_MEDIUMARMOR }, 
	
	--Heavy Armor Immovable Brute
	--[39205] = { [3] = uespLog.UESP_POWERTYPE_HEAVYARMOR },
	--[41085] = { [3] = uespLog.UESP_POWERTYPE_HEAVYARMOR },
	--[41088] = { [3] = uespLog.UESP_POWERTYPE_HEAVYARMOR },
	--[41091] = { [3] = uespLog.UESP_POWERTYPE_HEAVYARMOR },
	
	--Heavy Armor Unstoppable/Immovable
	[39197] = uespLog.UESP_POWERTYPE_HEAVYARMOR,
	[41097] = uespLog.UESP_POWERTYPE_HEAVYARMOR,
	[41100] = uespLog.UESP_POWERTYPE_HEAVYARMOR,
	[41103] = uespLog.UESP_POWERTYPE_HEAVYARMOR,
			
	-- Destruction: Destructive Reach (Broken on update 24pts)
	[38937] = { [1] = uespLog.UESP_POWERTYPE_MAGICKAWITHWD },
	[41029] = { [1] = uespLog.UESP_POWERTYPE_MAGICKAWITHWD },
	[41038] = { [1] = uespLog.UESP_POWERTYPE_MAGICKAWITHWD },
	[41047] = { [1] = uespLog.UESP_POWERTYPE_MAGICKAWITHWD }, 
	
	-- Destruction: Destructive Clench (Broken on update 24pts)
	[38984] = { [1] = uespLog.UESP_POWERTYPE_MAGICKAWITHWD },
	[40977] = { [1] = uespLog.UESP_POWERTYPE_MAGICKAWITHWD },
	[40995] = { [1] = uespLog.UESP_POWERTYPE_MAGICKAWITHWD },
	[41006] = { [1] = uespLog.UESP_POWERTYPE_MAGICKAWITHWD }, 
	
	-- Destruction: Wall of Frost
	[28849] = { [4] = POWERTYPE_HEALTH },
	[41637] = { [4] = POWERTYPE_HEALTH },
	[41652] = { [4] = POWERTYPE_HEALTH },
	[41668] = { [4] = POWERTYPE_HEALTH },
	
	-- Destruction: Blockade of Frost
	[39028] = { [4] = POWERTYPE_HEALTH },
	[41743] = { [4] = POWERTYPE_HEALTH },
	[41756] = { [4] = POWERTYPE_HEALTH },
	[41771] = { [4] = POWERTYPE_HEALTH },
	
	-- Destruction: Unstable Wall of Frost
	[39067] = { [4] = POWERTYPE_HEALTH, [8] = POWERTYPE_HEALTH },
	[41679] = { [4] = POWERTYPE_HEALTH, [8] = POWERTYPE_HEALTH },
	[41697] = { [4] = POWERTYPE_HEALTH, [8] = POWERTYPE_HEALTH },
	[41717] = { [4] = POWERTYPE_HEALTH, [8] = POWERTYPE_HEALTH },
	
	-- Warden: Nature's Grasp
	[85564] = POWERTYPE_ULTIMATE,
	[93932] = POWERTYPE_ULTIMATE,
	[93933] = POWERTYPE_ULTIMATE,
	[93934] = POWERTYPE_ULTIMATE,
	
	-- Warden: Bursting Vines
	[85859] = POWERTYPE_ULTIMATE,
	[93935] = POWERTYPE_ULTIMATE,
	[93936] = POWERTYPE_ULTIMATE,
	[93937] = POWERTYPE_ULTIMATE,
	
	-- Warden: Nature's Embrace
	[85858] = POWERTYPE_ULTIMATE,
	[93938] = POWERTYPE_ULTIMATE,
	[93939] = POWERTYPE_ULTIMATE,
	[93940] = POWERTYPE_ULTIMATE,
		
	-- Warden: Budding Seeds
	[85840] = { [3] = POWERTYPE_MAGICKA, [5] = POWERTYPE_ULTIMATE },
	[93805] = { [3] = POWERTYPE_MAGICKA, [5] = POWERTYPE_ULTIMATE },
	[93806] = { [3] = POWERTYPE_MAGICKA, [5] = POWERTYPE_ULTIMATE },
	[93807] = { [3] = POWERTYPE_MAGICKA, [5] = POWERTYPE_ULTIMATE },
	
	-- Warden: Healing Seed
	[85578] = { [3] = POWERTYPE_ULTIMATE },
	[93802] = { [3] = POWERTYPE_ULTIMATE },
	[93803] = { [3] = POWERTYPE_ULTIMATE },
	[93804] = { [3] = POWERTYPE_ULTIMATE },
	
	-- Warden: Corrupting Pollen
	[85845] = { [4] = POWERTYPE_ULTIMATE, [5] = POWERTYPE_ULTIMATE, [6] = POWERTYPE_ULTIMATE },
	[93808] = { [4] = POWERTYPE_ULTIMATE, [5] = POWERTYPE_ULTIMATE, [6] = POWERTYPE_ULTIMATE },
	[93809] = { [4] = POWERTYPE_ULTIMATE, [5] = POWERTYPE_ULTIMATE, [6] = POWERTYPE_ULTIMATE },
	[93810] = { [4] = POWERTYPE_ULTIMATE, [5] = POWERTYPE_ULTIMATE, [6] = POWERTYPE_ULTIMATE },
	
	[93859] = { [4] = POWERTYPE_ULTIMATE, [5] = POWERTYPE_ULTIMATE, [6] = POWERTYPE_ULTIMATE },
	[90241] = { [4] = POWERTYPE_ULTIMATE, [5] = POWERTYPE_ULTIMATE, [6] = POWERTYPE_ULTIMATE },
	[93865] = { [4] = POWERTYPE_ULTIMATE, [5] = POWERTYPE_ULTIMATE, [6] = POWERTYPE_ULTIMATE },
	[93871] = { [4] = POWERTYPE_ULTIMATE, [5] = POWERTYPE_ULTIMATE, [6] = POWERTYPE_ULTIMATE },	
	
	-- Warden: Impaling Shards
	[86161] = POWERTYPE_HEALTH,
	[86162] = POWERTYPE_HEALTH,
	[86163] = POWERTYPE_HEALTH,
	[86164] = POWERTYPE_HEALTH,
	
	[86165] = POWERTYPE_HEALTH,
	[86166] = POWERTYPE_HEALTH,
	[86167] = POWERTYPE_HEALTH,
	[86168] = POWERTYPE_HEALTH,
	
	-- Warden: Artic Wind
	[86148] = { [1] = POWERTYPE_HEALTH, [2] = POWERTYPE_HEALTH, [5] = POWERTYPE_MAGICKA, },
	[86149] = { [1] = POWERTYPE_HEALTH, [2] = POWERTYPE_HEALTH, [5] = POWERTYPE_MAGICKA, },
	[86150] = { [1] = POWERTYPE_HEALTH, [2] = POWERTYPE_HEALTH, [5] = POWERTYPE_MAGICKA, },
	[86151] = { [1] = POWERTYPE_HEALTH, [2] = POWERTYPE_HEALTH, [5] = POWERTYPE_MAGICKA, },
		
	-- Warden: Polar Wind
	[86152] = { [1] = POWERTYPE_HEALTH, [2] = POWERTYPE_HEALTH, [6] = POWERTYPE_HEALTH, [7] = POWERTYPE_MAGICKA, },
	[86153] = { [1] = POWERTYPE_HEALTH, [2] = POWERTYPE_HEALTH, [6] = POWERTYPE_HEALTH, [7] = POWERTYPE_MAGICKA, },
	[86154] = { [1] = POWERTYPE_HEALTH, [2] = POWERTYPE_HEALTH, [6] = POWERTYPE_HEALTH, [7] = POWERTYPE_MAGICKA, },
	[86155] = { [1] = POWERTYPE_HEALTH, [2] = POWERTYPE_HEALTH, [6] = POWERTYPE_HEALTH, [7] = POWERTYPE_MAGICKA, },
	
	-- Warden: Artic Blast
	[86156] = { [1] = POWERTYPE_HEALTH, [2] = POWERTYPE_HEALTH, [5] = POWERTYPE_MAGICKA, },
	[86157] = { [1] = POWERTYPE_HEALTH, [2] = POWERTYPE_HEALTH, [5] = POWERTYPE_MAGICKA, },
	[86158] = { [1] = POWERTYPE_HEALTH, [2] = POWERTYPE_HEALTH, [5] = POWERTYPE_MAGICKA, },
	[86159] = { [1] = POWERTYPE_HEALTH, [2] = POWERTYPE_HEALTH, [5] = POWERTYPE_MAGICKA, },
	
	-- Warden: Crystallized Shield
	[86135] = { [1] = POWERTYPE_HEALTH, [3] = POWERTYPE_ULTIMATE },
	[86136] = { [1] = POWERTYPE_HEALTH, [3] = POWERTYPE_ULTIMATE },
	[86137] = { [1] = POWERTYPE_HEALTH, [3] = POWERTYPE_ULTIMATE },
	[86138] = { [1] = POWERTYPE_HEALTH, [3] = POWERTYPE_ULTIMATE },
	
	[86139] = { [1] = POWERTYPE_HEALTH, [3] = POWERTYPE_ULTIMATE, [4] = POWERTYPE_MAGICKA },
	[86140] = { [1] = POWERTYPE_HEALTH, [3] = POWERTYPE_ULTIMATE, [4] = POWERTYPE_MAGICKA },
	[86141] = { [1] = POWERTYPE_HEALTH, [3] = POWERTYPE_ULTIMATE, [4] = POWERTYPE_MAGICKA },
	[86142] = { [1] = POWERTYPE_HEALTH, [3] = POWERTYPE_ULTIMATE, [4] = POWERTYPE_MAGICKA },
	
	[86143] = { [1] = POWERTYPE_HEALTH, [3] = POWERTYPE_ULTIMATE },
	[86144] = { [1] = POWERTYPE_HEALTH, [3] = POWERTYPE_ULTIMATE },
	[86145] = { [1] = POWERTYPE_HEALTH, [3] = POWERTYPE_ULTIMATE },
	[86146] = { [1] = POWERTYPE_HEALTH, [3] = POWERTYPE_ULTIMATE },
	
	-- Necromancer: Bone Goliath Transformation
	[115001] = POWERTYPE_HEALTH,
	[20115001] = POWERTYPE_HEALTH,
	[30115001] = POWERTYPE_HEALTH,
	[40115001] = POWERTYPE_HEALTH,
	
	-- Necromancer: Ravenous Goliath
	[118279] = POWERTYPE_HEALTH,
	[20118279] = POWERTYPE_HEALTH,
	[30118279] = POWERTYPE_HEALTH,
	[40118279] = POWERTYPE_HEALTH,
	
	-- Necromancer: Pummeling Goliath (numbers off by 1 due to header)
	[118664]   = { [5] = POWERTYPE_HEALTH, [6] = POWERTYPE_HEALTH, [7] = POWERTYPE_ULTIMATE },
	[20118664] = { [5] = POWERTYPE_HEALTH, [6] = POWERTYPE_HEALTH, [7] = POWERTYPE_ULTIMATE },
	[30118664] = { [5] = POWERTYPE_HEALTH, [6] = POWERTYPE_HEALTH, [7] = POWERTYPE_ULTIMATE },
	[40118664] = { [5] = POWERTYPE_HEALTH, [6] = POWERTYPE_HEALTH, [7] = POWERTYPE_ULTIMATE },
	
	-- Necromancer: Shocking Siphon
	[115924] = POWERTYPE_ULTIMATE,
	[20115924] = POWERTYPE_ULTIMATE,
	[30115924] = POWERTYPE_ULTIMATE,
	[40115924] = POWERTYPE_ULTIMATE,
	
	-- Necromancer: Mystic Siphon
	[118008] = POWERTYPE_ULTIMATE,
	[20118008] = POWERTYPE_ULTIMATE,
	[30118008] = POWERTYPE_ULTIMATE,
	[40118008] = POWERTYPE_ULTIMATE,
	
	-- Necromancer: Detonating Siphon
	[118763] = POWERTYPE_ULTIMATE,
	[20118763] = POWERTYPE_ULTIMATE,
	[30118763] = POWERTYPE_ULTIMATE,
	[40118763] = POWERTYPE_ULTIMATE,
	
	-- Necromancer: Restoring Tether
	[115926] = POWERTYPE_ULTIMATE,
	[20115926] = POWERTYPE_ULTIMATE,
	[30115926] = POWERTYPE_ULTIMATE,
	[40115926] = POWERTYPE_ULTIMATE,
	
	-- Necromancer: Braided Tether
	[118070] = POWERTYPE_ULTIMATE,
	[20118070] = POWERTYPE_ULTIMATE,
	[30118070] = POWERTYPE_ULTIMATE,
	[40118070] = POWERTYPE_ULTIMATE,
	
	-- Necromancer: Mortal Coil
	[118122] = POWERTYPE_ULTIMATE,
	[20118122] = POWERTYPE_ULTIMATE,
	[30118122] = POWERTYPE_ULTIMATE,
	[40118122] = POWERTYPE_ULTIMATE,
	
	-- Necromancer: Bitter Harvest
	[115238] = POWERTYPE_HEALTH,
	[20115238] = POWERTYPE_HEALTH,
	[30115238] = POWERTYPE_HEALTH,
	[40115238] = POWERTYPE_HEALTH,
	
	-- Necromancer: Deaden Pain
	[118623] = POWERTYPE_HEALTH,
	[20118623] = POWERTYPE_HEALTH,
	[30118623] = POWERTYPE_HEALTH,
	[40118623] = POWERTYPE_HEALTH,
	
	-- Necromancer: Necrotic Potency
	[118639] = POWERTYPE_HEALTH,
	[20118639] = POWERTYPE_HEALTH,
	[30118639] = POWERTYPE_HEALTH,
	[40118639] = POWERTYPE_HEALTH,
	
	-- Necromancer: Agony Totem
	[118404] = POWERTYPE_ULTIMATE,
	[20118404] = POWERTYPE_ULTIMATE,
	[30118404] = POWERTYPE_ULTIMATE,
	[40118404] = POWERTYPE_ULTIMATE,

	-- Necromancer: Death Scythe
	[115115]   = { [2] = POWERTYPE_HEALTH, [3] = POWERTYPE_HEALTH },
	[20115115] = { [2] = POWERTYPE_HEALTH, [3] = POWERTYPE_HEALTH },
	[30115115] = { [2] = POWERTYPE_HEALTH, [3] = POWERTYPE_HEALTH },
	[40115115] = { [2] = POWERTYPE_HEALTH, [3] = POWERTYPE_HEALTH },	
	
	-- Necromancer: Ruinous Scythe
	[118226]   = { [2] = POWERTYPE_HEALTH, [3] = POWERTYPE_HEALTH },
	[20118226] = { [2] = POWERTYPE_HEALTH, [3] = POWERTYPE_HEALTH },
	[30118226] = { [2] = POWERTYPE_HEALTH, [3] = POWERTYPE_HEALTH },
	[40118226] = { [2] = POWERTYPE_HEALTH, [3] = POWERTYPE_HEALTH },	
	
	-- Necromancer: Hungry Scythe
	[118223]   = { [2] = POWERTYPE_HEALTH, [3] = POWERTYPE_HEALTH, [4] = POWERTYPE_HEALTH },
	[20118223] = { [2] = POWERTYPE_HEALTH, [3] = POWERTYPE_HEALTH, [4] = POWERTYPE_HEALTH },
	[30118223] = { [2] = POWERTYPE_HEALTH, [3] = POWERTYPE_HEALTH, [4] = POWERTYPE_HEALTH },
	[40118223] = { [2] = POWERTYPE_HEALTH, [3] = POWERTYPE_HEALTH, [4] = POWERTYPE_HEALTH },	
	
	-- Necromancer: Boneyard
	[115252]   = { [4] = POWERTYPE_ULTIMATE	},
	[20115252] = { [4] = POWERTYPE_ULTIMATE },
	[30115252] = { [4] = POWERTYPE_ULTIMATE },
	[40115252] = { [4] = POWERTYPE_ULTIMATE },	
	
	-- Necromancer: Avid Boneyard
	[117850]   = { [4] = POWERTYPE_ULTIMATE	},
	[20117850] = { [4] = POWERTYPE_ULTIMATE },
	[30117850] = { [4] = POWERTYPE_ULTIMATE },
	[40117850] = { [4] = POWERTYPE_ULTIMATE },	
	
	-- Necromancer: Unnerving Boneyard
	[117805]   = { [5] = POWERTYPE_ULTIMATE	},
	[20117805] = { [5] = POWERTYPE_ULTIMATE },
	[30117805] = { [5] = POWERTYPE_ULTIMATE },
	[40117805] = { [5] = POWERTYPE_ULTIMATE },
	
	-- Psjiic Order: Elemental Weapon
	[103571]   = { [3] = POWERTYPE_ULTIMATE },
	[20103571] = { [3] = POWERTYPE_ULTIMATE },
	[30103571] = { [3] = POWERTYPE_ULTIMATE },
	[40103571] = { [3] = POWERTYPE_ULTIMATE },

	-- Light Attacks (Changed to Ultimate in update 28)
	[15435] = POWERTYPE_ULTIMATE,
	[16037] = POWERTYPE_ULTIMATE,
	[16145] = POWERTYPE_ULTIMATE,
	[16165] = POWERTYPE_ULTIMATE,
	[16277] = POWERTYPE_ULTIMATE,
	[16499] = POWERTYPE_ULTIMATE,
	[16688] = POWERTYPE_ULTIMATE,
	[18350] = POWERTYPE_ULTIMATE,
	[23604] = POWERTYPE_ULTIMATE,
	[24792] = POWERTYPE_ULTIMATE,
	[29368] = POWERTYPE_ULTIMATE,
	[32464] = POWERTYPE_ULTIMATE,
	[55885] = POWERTYPE_ULTIMATE,
	[60774] = POWERTYPE_ULTIMATE,
	[60776] = POWERTYPE_ULTIMATE,
	[60778] = POWERTYPE_ULTIMATE,
	[60782] = POWERTYPE_ULTIMATE,
	[60785] = POWERTYPE_ULTIMATE,
	[60794] = POWERTYPE_ULTIMATE,
	[62426] = POWERTYPE_ULTIMATE,
	[63754] = POWERTYPE_ULTIMATE,
	[114769] = POWERTYPE_ULTIMATE,
	[114773] = POWERTYPE_ULTIMATE,
	[116762] = POWERTYPE_ULTIMATE,
	[132249] = POWERTYPE_ULTIMATE,
	
	-- Heavy Attacks (Changed to Ultimate in update 28)
	[15279] = POWERTYPE_ULTIMATE,
	[15383] = POWERTYPE_ULTIMATE,
	[16041] = POWERTYPE_ULTIMATE,
	[16212] = POWERTYPE_ULTIMATE,
	[16220] = POWERTYPE_ULTIMATE,
	[16261] = POWERTYPE_ULTIMATE,
	[16420] = POWERTYPE_ULTIMATE,
	[16691] = POWERTYPE_ULTIMATE,
	[18396] = POWERTYPE_ULTIMATE,
	[18429] = POWERTYPE_ULTIMATE,	-- Unarmed: Was Stamina, Fixed in update 29?
	[24794] = POWERTYPE_ULTIMATE,
	[24810] = POWERTYPE_ULTIMATE,
	[29365] = POWERTYPE_ULTIMATE,
	[32477] = POWERTYPE_ULTIMATE,	
	[53659] = POWERTYPE_ULTIMATE,
	[55886] = POWERTYPE_ULTIMATE,
	[60775] = POWERTYPE_ULTIMATE,
	[60777] = POWERTYPE_ULTIMATE,
	[60779] = POWERTYPE_ULTIMATE,
	[60783] = POWERTYPE_ULTIMATE,
	[60786] = POWERTYPE_ULTIMATE,
	[60796] = POWERTYPE_ULTIMATE,
	[114797] = POWERTYPE_ULTIMATE,
	[126038] = POWERTYPE_ULTIMATE,
	[126040] = POWERTYPE_ULTIMATE,
	[126095] = POWERTYPE_ULTIMATE,
	[126039] = POWERTYPE_ULTIMATE,
	[133380] = POWERTYPE_ULTIMATE,

	
-- Passives 

	-- Dual Wield Twin Blade and Blunt	
	[30893] = { [2] = POWERTYPE_STAMINA, [6] = uespLog.UESP_POWERTYPE_WEAPONDAGGER },
	[45482] = { [2] = POWERTYPE_STAMINA, [6] = uespLog.UESP_POWERTYPE_WEAPONDAGGER },
	
		-- Light Armor: Penalties/Bonuses
	[152778] = uespLog.UESP_POWERTYPE_LIGHTARMOR,
	[150185] = uespLog.UESP_POWERTYPE_LIGHTARMOR,
	
	-- Light Armor Prodigy
	[29668] = uespLog.UESP_POWERTYPE_LIGHTARMOR,
	[45561] = uespLog.UESP_POWERTYPE_LIGHTARMOR,
	
	-- Light Armor Concentration
	[29667] = uespLog.UESP_POWERTYPE_LIGHTARMOR,
	[45562] = uespLog.UESP_POWERTYPE_LIGHTARMOR,
	
	-- Light Armor Spell Warding	
	[29663] = { [2] = uespLog.UESP_POWERTYPE_LIGHTARMOR },
	[45559] = { [2] = uespLog.UESP_POWERTYPE_LIGHTARMOR },
	
	-- Light Armor Grace
	[29639] = { [2] = uespLog.UESP_POWERTYPE_LIGHTARMOR, [4] = uespLog.UESP_POWERTYPE_LIGHTARMOR },
	[45548] = { [2] = uespLog.UESP_POWERTYPE_LIGHTARMOR, [4] = uespLog.UESP_POWERTYPE_LIGHTARMOR },
	[45549] = { [2] = uespLog.UESP_POWERTYPE_LIGHTARMOR, [4] = uespLog.UESP_POWERTYPE_LIGHTARMOR },
	
	-- Light Armor Evocation
	[29665] = { [2] = uespLog.UESP_POWERTYPE_LIGHTARMOR, [4] = uespLog.UESP_POWERTYPE_LIGHTARMOR },
	[45557] = { [2] = uespLog.UESP_POWERTYPE_LIGHTARMOR, [4] = uespLog.UESP_POWERTYPE_LIGHTARMOR },
	
	-- Medium Armor: Penalties/Bonuses
	[150181] = uespLog.UESP_POWERTYPE_MEDIUMARMOR,
		
	-- Medium Armor Dexterity	
	[29743] = { [2] = uespLog.UESP_POWERTYPE_MEDIUMARMOR},
	[45563] = { [2] = uespLog.UESP_POWERTYPE_MEDIUMARMOR},
	[45564] = { [2] = uespLog.UESP_POWERTYPE_MEDIUMARMOR},
	
	-- Medium Armor Wind Walker	
	[29687] = { [2] = uespLog.UESP_POWERTYPE_MEDIUMARMOR, [4] = uespLog.UESP_POWERTYPE_MEDIUMARMOR  },
	[45565] = { [2] = uespLog.UESP_POWERTYPE_MEDIUMARMOR, [4] = uespLog.UESP_POWERTYPE_MEDIUMARMOR  },
		
	-- Medium Armor Improved Sneak	
	[29738] = { [2] = uespLog.UESP_POWERTYPE_MEDIUMARMOR, [4] = uespLog.UESP_POWERTYPE_MEDIUMARMOR  },
	[45567] = { [2] = uespLog.UESP_POWERTYPE_MEDIUMARMOR, [4] = uespLog.UESP_POWERTYPE_MEDIUMARMOR  },
	
	-- Medium Armor Agility
	[29686] = { [2] = uespLog.UESP_POWERTYPE_MEDIUMARMOR, [4] = uespLog.UESP_POWERTYPE_MEDIUMARMOR },
	[45572] = { [2] = uespLog.UESP_POWERTYPE_MEDIUMARMOR, [4] = uespLog.UESP_POWERTYPE_MEDIUMARMOR },
	
	-- Medium Armor Athletics	
	[29742] = { [2] = uespLog.UESP_POWERTYPE_MEDIUMARMOR, [4] = uespLog.UESP_POWERTYPE_MEDIUMARMOR },
	[45574] = { [2] = uespLog.UESP_POWERTYPE_MEDIUMARMOR, [4] = uespLog.UESP_POWERTYPE_MEDIUMARMOR },
	
	-- Heavy Armor: Penalties/Bonuses
	[152780] = uespLog.UESP_POWERTYPE_HEAVYARMOR,
	[150184] = uespLog.UESP_POWERTYPE_HEAVYARMOR,
		
	-- Heavy Armor Resolve
	[29825] = { [2] = uespLog.UESP_POWERTYPE_HEAVYARMOR },
	[45531] = { [2] = uespLog.UESP_POWERTYPE_HEAVYARMOR },
	[45533] = { [2] = uespLog.UESP_POWERTYPE_HEAVYARMOR },
		
	-- Heavy Armor Constitution
	[29769] = { [2] = uespLog.UESP_POWERTYPE_HEAVYARMOR, [5] = uespLog.UESP_POWERTYPE_HEAVYARMOR },
	[45526] = { [2] = uespLog.UESP_POWERTYPE_HEAVYARMOR, [5] = uespLog.UESP_POWERTYPE_HEAVYARMOR },
		
	-- Heavy Armor Juggernaut
	-- Note that skill output is truncated to integer values so fit accuracy may be low
	[29804] = { [2] = uespLog.UESP_POWERTYPE_HEAVYARMOR },
	[45546] = { [2] = uespLog.UESP_POWERTYPE_HEAVYARMOR },
	
	-- Heavy Armor Revitalize
	[29773] = { [2] = uespLog.UESP_POWERTYPE_HEAVYARMOR },
	[45528] = { [2] = uespLog.UESP_POWERTYPE_HEAVYARMOR },
	
	-- Heavy Armor Rapid Mending
	-- Note that skill output is truncated to integer values so fit accuracy may be low
	[29791] = uespLog.UESP_POWERTYPE_HEAVYARMOR,
	[45529] = uespLog.UESP_POWERTYPE_HEAVYARMOR,
	
	-- Nightblade Pressure Points
	[36636] = uespLog.UESP_POWERTYPE_ASSASSINATION,
	[45053] = uespLog.UESP_POWERTYPE_ASSASSINATION,
	
	-- Nightblade Shadow Barrier	
	[18866] = uespLog.UESP_POWERTYPE_HEAVYARMOR,
	[45071] = uespLog.UESP_POWERTYPE_HEAVYARMOR,
	
	-- Nightblade Dark Vigor
	[36532] = { [2] = uespLog.UESP_POWERTYPE_SHADOW },
	[45084] = { [2] = uespLog.UESP_POWERTYPE_SHADOW },
	
	-- Nightblade Soul Siphoner
	[36603] = { [2] = uespLog.UESP_POWERTYPE_SIPHONING },
	[45155] = { [2] = uespLog.UESP_POWERTYPE_SIPHONING },
	
	-- Soul Magic Soul Shatter
	[39266] = { [2] = POWERTYPE_HEALTH},
	[45583] = { [2] = POWERTYPE_HEALTH},
	
	-- Undaunted Undaunted Mettle
	[55366] = { [2] = uespLog.UESP_POWERTYPE_ARMORTYPE },	
	[55386] = { [2] = uespLog.UESP_POWERTYPE_ARMORTYPE },	
	
	-- Undaunted Undaunted Command
	[55584] = { [2] = POWERTYPE_HEALTH, [3] = POWERTYPE_STAMINA, [4] = POWERTYPE_MAGICKA },
	[55676] = { [2] = POWERTYPE_HEALTH, [3] = POWERTYPE_STAMINA, [4] = POWERTYPE_MAGICKA },
	
	-- Destruction Tri Focus
	[30948] = { [3] = POWERTYPE_HEALTH, [4] = POWERTYPE_HEALTH },
	[45500] = { [3] = POWERTYPE_HEALTH, [4] = POWERTYPE_HEALTH },	
	
	-- Two Handed Heavy Weapons
	[29375] = { [3] = POWERTYPE_STAMINA },
	[45430] = { [3] = POWERTYPE_STAMINA },
	
	-- Sorcerer Disintegrate/Implosion
	[31422] = { [3] = POWERTYPE_HEALTH, [6] = POWERTYPE_HEALTH },
	[45192] = { [3] = POWERTYPE_HEALTH, [6] = POWERTYPE_HEALTH },
	
	-- Sorcerer Expert Mage
	[31425] = { [2] = uespLog.UESP_POWERTYPE_SORCERER },
	[45195] = { [2] = uespLog.UESP_POWERTYPE_SORCERER },
	
	-- Templar Burning Light	
	--[31718] = { [2] = POWERTYPE_ULTIMATE },
	--[44730] = { [2] = POWERTYPE_ULTIMATE },
	[31718] = { [2] = POWERTYPE_STAMINA },		-- Temporary fix as the tooltip is bugged
	[44730] = { [2] = POWERTYPE_STAMINA },
	
	-- Psijic Order Spell Orb
	[103819] = { [3] = POWERTYPE_STAMINA },
	[103878] = { [3] = POWERTYPE_STAMINA },
	
	-- Imperial Red Diamond
	[36155] = { [2] = POWERTYPE_HEALTH },
	[45291] = { [2] = POWERTYPE_HEALTH },
	[45293] = { [2] = POWERTYPE_HEALTH },
	
	-- Redguard Adrenaline Rush
	[36546] = { [1] = POWERTYPE_STAMINA },
	[45313] = { [1] = POWERTYPE_STAMINA },
	[45315] = { [1] = POWERTYPE_STAMINA },
	
	--Materialize (unknown)
	[88158] = POWERTYPE_ULTIMATE,
	[88174] = POWERTYPE_ULTIMATE,
	[88176] = POWERTYPE_ULTIMATE,
	[88178] = POWERTYPE_ULTIMATE,
	
	-- Psjiic Order: Mend Wounds
	[103543] = POWERTYPE_ULTIMATE,
	[20103543] = POWERTYPE_ULTIMATE,
	[30103543] = POWERTYPE_ULTIMATE,
	[40103543] = POWERTYPE_ULTIMATE,
	
	-- Psjiic Order: Mend Spirit
	[103747] = POWERTYPE_ULTIMATE,
	[20103747] = POWERTYPE_ULTIMATE,
	[30103747] = POWERTYPE_ULTIMATE,
	[40103747] = POWERTYPE_ULTIMATE,
	
	-- Psjiic Order: Symbiosis
	[103755] = POWERTYPE_ULTIMATE,
	[20103755] = POWERTYPE_ULTIMATE,
	[30103755] = POWERTYPE_ULTIMATE,
	[40103755] = POWERTYPE_ULTIMATE,
	
	-- Sprint
	[973] = POWERTYPE_STAMINA,
	
	-- Block
	[14890] = POWERTYPE_STAMINA,
	
	-- Sneak
	[20299] = POWERTYPE_STAMINA,
	
	-- Warden
	[86068] = uespLog.UESP_POWERTYPE_ANIMALCOMPANION,
	[86069] = uespLog.UESP_POWERTYPE_ANIMALCOMPANION,
	
	[85876] = uespLog.UESP_POWERTYPE_GREENBALANCE,
	[85877] = uespLog.UESP_POWERTYPE_GREENBALANCE,
	
	[86189] = uespLog.UESP_POWERTYPE_WINTERSEMBRACE,
	[86190] = uespLog.UESP_POWERTYPE_WINTERSEMBRACE,
	
	-- Necromancer
	[116269] = uespLog.UESP_POWERTYPE_BONETYRANT,
	[116270] = uespLog.UESP_POWERTYPE_BONETYRANT,
	
	[116197] = uespLog.UESP_POWERTYPE_GRAVELORD,
	[116198] = uespLog.UESP_POWERTYPE_GRAVELORD,
	
	[31383] = POWERTYPE_HEALTH,
	[45172] = POWERTYPE_HEALTH,
	
-- CP

	-- Resilient
	[61660] = POWERTYPE_HEALTH,
	
	-- Riposte
	[60229] = { [2] = uespLog.UESP_POWERTYPE_DAMAGE },
	
	-- Invigorating bash
	[60407] = POWERTYPE_HEALTH,
		
	-- Attack/Weapon Power	
	[15998] = uespLog.UESP_POWERTYPE_WEAPONPOWER,
	[16353] = uespLog.UESP_POWERTYPE_WEAPONPOWER,
	[16357] = uespLog.UESP_POWERTYPE_WEAPONPOWER,
	[16368] = uespLog.UESP_POWERTYPE_WEAPONPOWER,
	
	[132249] = uespLog.UESP_POWERTYPE_WEAPONPOWER,
	[132251] = uespLog.UESP_POWERTYPE_WEAPONPOWER,
	[132322] = uespLog.UESP_POWERTYPE_WEAPONPOWER,
	[132354] = uespLog.UESP_POWERTYPE_WEAPONPOWER,
	[132372] = uespLog.UESP_POWERTYPE_WEAPONPOWER,
	[133116] = uespLog.UESP_POWERTYPE_WEAPONPOWER,
	[133119] = uespLog.UESP_POWERTYPE_WEAPONPOWER,
	[133507] = uespLog.UESP_POWERTYPE_WEAPONPOWER,
	
	-- Damage
	[75673] = uespLog.UESP_POWERTYPE_DAMAGE,
		
}


uespLog.OTHER_MISSING_SKILL_DATA = 
{
	-- Heavy Attacks
	15279,
	15383,
	16041,
	16212,
	16220,
	16261,
	16420,
	16691,
	18396,
	18429,
	29365,
	32477,
	55886,
	60775,
	60777,
	60779,
	60783,
	60786,
	60796,

		-- Light Attacks
	15435,
	16037,
	16145,
	16165,
	16277,
	16499,
	16688,
	18350,
	23604,
	29368,
	32464,
	55885,
	60774,
	60776,
	60778,
	60782,
	60785,
	60794,
	62426,
	63754,
	
		-- Pounce
	32632,     
	42108,
	42109,
	42110,
		-- Brutal Pounce
	39105,     
	42117,
	42118,
	42119,
		-- Feral Pounce
	39104,     
	42126,
	42127,
	42128,
		-- Hircine's Bounty
	58310,		
	58314,
	58315,
	58316,
		-- Hircine's Rage
	58317,		
	58319,
	58321,
	58323,
		-- Hircine's Fortitude
	58325,		
	58329,
	58332,
	58334,
	    -- Roar
	32633, 
	42143,
	42144,
	42145,
		-- Ferocious Roar
	39113,     
	42155,
	42156,
	42157,
		-- Rousing Roar
	39114,     
	42177,
	42178,
	42179,
		-- Piercing Howl
	58405,		
	58736,
	58738,
	58740,
		-- Howl of Despair
	58742,		
	58786,
	58790,
	58794,
		-- Howl of Agony
	58798,		
	58802,
	58805,
	58808,
		-- Infectious Claws
	58855,		
	58857,
	58859,
	58862,
		-- Claws of Anguish
	58864,		
	58870,
	58873,
	58876,
		-- Claws of Life
	58879,		
	58901,
	58904,
	58907,
}


uespLog.BASESKILL_RANKDATA = {
	[38932] = { 38932, 41924, 41925, 41926 },
	[38931] = { 38931, 41933, 41936, 41937 },
	[38949] = { 38949, 41900, 41901, 41902 },
	[38956] = { 38956, 41879, 41880, 41881 },
	[38963] = { 38963, 41813, 41814, 41815 },
	[38965] = { 38965, 41822, 41823, 41824 },
	[58864] = { 58864, 58870, 58873, 58876 },
	[58879] = { 58879, 58901, 58904, 58907 },
	[39105] = { 39105, 42117, 42118, 42119 },
	[39104] = { 39104, 42126, 42127, 42128 },
	[39113] = { 39113, 42155, 42156, 42157 },
	[39114] = { 39114, 42177, 42178, 42179 },
	[58317] = { 58317, 58319, 58321, 58323 },
	[58325] = { 58325, 58329, 58332, 58334 },
	[58742] = { 58742, 58786, 58790, 58794 },
	[58798] = { 58798, 58802, 58805, 58808 },
	[15540] = { 15540, 23864, 23869, 23870 },
	[15957] = { 15957, 19976, 19979, 19982 },
	[16536] = { 16536, 42461, 42464, 42467 },
	[17874] = { 17874, 33835, 33838, 33841 },
	[17878] = { 17878, 33844, 33848, 33852 },
	[18342] = { 18342, 35864, 35868, 35871 },
	[18718] = { 18718, 30311, 30315, 30319 },
	[19109] = { 19109, 30335, 30339, 30343 },
	[19123] = { 19123, 30323, 30327, 30331 },
	[20245] = { 20245, 32105, 32108, 32111 },
	[20251] = { 20251, 32127, 32131, 32135 },
	[20252] = { 20252, 32114, 32119, 32123 },
	[20319] = { 20319, 23822, 23825, 23828 },
	[20323] = { 20323, 23834, 23838, 23842 },
	[20328] = { 20328, 23846, 23851, 23856 },
	[20492] = { 20492, 23736, 23740, 23744 },
	[20496] = { 20496, 23770, 23774, 23778 },
	[20499] = { 20499, 32215, 32222, 32229 },
	[20657] = { 20657, 23882, 23884, 23886 },
	[20660] = { 20660, 23888, 23893, 23898 },
	[20668] = { 20668, 23907, 23911, 23915 },
	[20779] = { 20779, 33783, 33790, 33797 },
	[23806] = { 23806, 20803, 23809, 23811 },
	[20805] = { 20805, 23813, 23816, 23819 },
	[20816] = { 20816, 23831, 23916, 23924 },
	[20917] = { 20917, 34027, 34029, 34031 },
	[20919] = { 20919, 39742, 39744, 39746 },
	[20930] = { 20930, 34042, 34045, 34048 },
	[20944] = { 20944, 34033, 34036, 34039 },
	[21007] = { 21007, 33741, 33742, 33743 },
	[21014] = { 21014, 33745, 33747, 33749 },
	[21017] = { 21017, 33753, 33757, 33759 },
	[21157] = { 21157, 40604, 40607, 40610 },
	[21726] = { 21726, 24160, 24167, 24171 },
	[21729] = { 21729, 24174, 24177, 24180 },
	[21732] = { 21732, 24184, 24187, 24195 },
	[21752] = { 21752, 24044, 24052, 24063 },
	[21755] = { 21755, 24288, 24295, 24301 },
	[21758] = { 21758, 24308, 24314, 24320 },
	[21761] = { 21761, 27211, 27219, 27227 },
	[21763] = { 21763, 27569, 27578, 27587 },
	[21765] = { 21765, 27534, 27549, 27558 },
	[21776] = { 21776, 27303, 27304, 27306 },
	[22004] = { 22004, 27307, 27309, 27311 },
	[22006] = { 22006, 27313, 27316, 27324 },
	[22057] = { 22057, 24080, 24101, 24110 },
	[22095] = { 22095, 24155, 24156, 24157 },
	[22110] = { 22110, 24129, 24139, 24147 },
	[22138] = { 22138, 23782, 23783, 23784 },
	[22139] = { 22139, 23785, 23787, 23788 },
	[22144] = { 22144, 23792, 23793, 23794 },
	[22149] = { 22149, 23709, 23713, 23716 },
	[22161] = { 22161, 23719, 23722, 23726 },
	[22178] = { 22178, 27493, 27497, 27501 },
	[22180] = { 22180, 27520, 27526, 27530 },
	[22182] = { 22182, 27506, 27510, 27514 },
	[22223] = { 22223, 27388, 27392, 27396 },
	[22226] = { 22226, 27419, 27423, 27427 },
	[22229] = { 22229, 27401, 27407, 27413 },
	[22234] = { 22234, 23968, 23969, 23970 },
	[22237] = { 22237, 23983, 23984, 23985 },
	[22240] = { 22240, 23996, 23997, 23998 },
	[22250] = { 22250, 24198, 24201, 24204 },
	[22253] = { 22253, 24207, 24210, 24213 },
	[22256] = { 22256, 24216, 24219, 24222 },
	[22259] = { 22259, 27261, 27269, 27275 },
	[22262] = { 22262, 27281, 27288, 27295 },
	[22265] = { 22265, 27243, 27249, 27255 },
	[22304] = { 22304, 27334, 27340, 27342 },
	[22314] = { 22314, 27368, 27372, 27376 },
	[22327] = { 22327, 27346, 27349, 27352 },
	[23182] = { 23182, 30259, 30264, 30269 },
	[23200] = { 23200, 30274, 30280, 30286 },
	[23205] = { 23205, 30292, 30297, 30302 },
	[23210] = { 23210, 30229, 30232, 30235 },
	[23213] = { 23213, 30247, 30251, 30255 },
	[23231] = { 23231, 30238, 30241, 30244 },
	[23234] = { 23234, 30201, 30203, 30205 },
	[23236] = { 23236, 30208, 30211, 30215 },
	[23277] = { 23277, 30218, 30221, 30224 },
	[23304] = { 23304, 30631, 30636, 30641 },
	[23316] = { 23316, 30664, 30669, 30674 },
	[23319] = { 23319, 30647, 30652, 30657 },
	[23492] = { 23492, 30564, 30569, 30575 },
	[23495] = { 23495, 30543, 30548, 30553 },
	[23634] = { 23634, 30528, 30533, 30538 },
	[23670] = { 23670, 30386, 30388, 30390 },
	[23674] = { 23674, 30392, 30394, 30396 },
	[23678] = { 23678, 30398, 30402, 30406 },
	[24158] = { 24158, 30410, 30414, 30418 },
	[24163] = { 24163, 30437, 30441, 30445 },
	[24165] = { 24165, 30422, 30427, 30432 },
	[24326] = { 24326, 30491, 30495, 30499 },
	[24328] = { 24328, 30503, 30507, 30511 },
	[24330] = { 24330, 30515, 30519, 30523 },
	[24371] = { 24371, 30152, 30157, 30162 },
	[24574] = { 24574, 30182, 30188, 30194 },
	[24578] = { 24578, 30167, 30172, 30177 },
	[24584] = { 24584, 29995, 30004, 30012 },
	[24589] = { 24589, 30056, 30064, 30072 },
	[24595] = { 24595, 30022, 30033, 30043 },
	[24613] = { 24613, 30581, 30584, 30587 },
	[24636] = { 24636, 30592, 30595, 30598 },
	[24639] = { 24639, 30618, 30622, 30626 },
	[24785] = { 24785, 30348, 30351, 30354 },
	[24804] = { 24804, 30371, 30376, 30381 },
	[24806] = { 24806, 30358, 30362, 30366 },
	[24828] = { 24828, 29889, 29899, 29909 },
	[24834] = { 24834, 29949, 29961, 29973 },
	[24842] = { 24842, 29919, 29929, 29939 },
	[25091] = { 25091, 36154, 36160, 36166 },
	[25255] = { 25255, 36217, 36220, 36223 },
	[25260] = { 25260, 36226, 36230, 36234 },
	[25267] = { 25267, 36238, 36241, 36244 },
	[25352] = { 25352, 38061, 38063, 38065 },
	[25375] = { 25375, 36329, 36333, 36337 },
	[25377] = { 25377, 36341, 36346, 36351 },
	[25380] = { 25380, 36356, 36362, 36368 },
	[25411] = { 25411, 37686, 37691, 37696 },
	[25484] = { 25484, 35886, 35892, 35898 },
	[25493] = { 25493, 35874, 35878, 35882 },
	[26114] = { 26114, 27179, 27182, 27186 },
	[26158] = { 26158, 26971, 26973, 26975 },
	[26188] = { 26188, 27046, 27059, 27090 },
	[26209] = { 26209, 26995, 27001, 27007 },
	[26768] = { 26768, 43050, 43053, 43056 },
	[26792] = { 26792, 27189, 27193, 27197 },
	[26797] = { 26797, 27201, 27204, 27207 },
	[26800] = { 26800, 26977, 26980, 26983 },
	[26804] = { 26804, 26986, 26989, 26992 },
	[26807] = { 26807, 27013, 27024, 27030 },
	[26821] = { 26821, 27036, 27040, 27043 },
	[26858] = { 26858, 27102, 27112, 27122 },
	[26869] = { 26869, 27145, 27156, 27167 },
	[27706] = { 27706, 29833, 29839, 29844 },
	[28025] = { 28025, 30083, 30085, 30087 },
	[28279] = { 28279, 39962, 39965, 39968 },
	[28297] = { 28297, 39868, 39871, 39881 },
	[28302] = { 28302, 39919, 39925, 39928 },
	[28304] = { 28304, 41387, 41391, 41394 },
	[28306] = { 28306, 41473, 41475, 41477 },
	[28308] = { 28308, 30089, 30092, 30095 },
	[28311] = { 28311, 30098, 30103, 30107 },
	[28341] = { 28341, 29849, 29855, 29861 },
	[28348] = { 28348, 29867, 29874, 29881 },
	[28365] = { 28365, 41429, 41432, 41435 },
	[28379] = { 28379, 40658, 40661, 40664 },
	[28385] = { 28385, 41244, 41246, 41248 },
	[28418] = { 28418, 30457, 30460, 30463 },
	[28448] = { 28448, 39785, 39789, 39793 },
	[28536] = { 28536, 41269, 41270, 41271 },
	[28567] = { 28567, 42199, 42203, 42207 },
	[28591] = { 28591, 40708, 40711, 40714 },
	[28607] = { 28607, 40578, 40580, 40582 },
	[28613] = { 28613, 40631, 40632, 40633 },
	[28719] = { 28719, 41506, 41509, 41512 },
	[28727] = { 28727, 41349, 41350, 41351 },
	[28800] = { 28800, 42949, 42953, 42957 },
	[28858] = { 28858, 41627, 41642, 41658 },
	[28869] = { 28869, 40796, 40801, 40806 },
	[28876] = { 28876, 40911, 40914, 40917 },
	[28879] = { 28879, 40852, 40855, 40858 },
	[28882] = { 28882, 40890, 40891, 40892 },
	[28967] = { 28967, 34051, 34056, 34061 },
	[28988] = { 28988, 33955, 33959, 33963 },
	[29004] = { 29004, 33405, 33616, 33619 },
	[29012] = { 29012, 33652, 33655, 33658 },
	[29032] = { 29032, 32190, 32192, 32194 },
	[29037] = { 29037, 33888, 33893, 33898 },
	[29043] = { 29043, 32151, 32154, 32156 },
	[29059] = { 29059, 33768, 33773, 33778 },
	[29071] = { 29071, 33862, 33864, 33866 },
	[29091] = { 29091, 40947, 40956, 40964 },
	[29173] = { 29173, 41544, 41546, 41548 },
	[29224] = { 29224, 33868, 33870, 33872 },
	[29338] = { 29338, 41106, 41107, 41108 },
	[29482] = { 29482, 30478, 30482, 30486 },
	[29489] = { 29489, 30466, 30470, 30474 },
	[29552] = { 29552, 41078, 41080, 41082 },
	[29556] = { 29556, 41124, 41125, 41126 },
	[30920] = { 30920, 42410, 42414, 42418 },
	[31271] = { 31271, 40759, 40762, 40765 },
	[31531] = { 31531, 41199, 41203, 41207 },
	[31632] = { 31632, 42293, 42299, 42305 },
	[31642] = { 31642, 42247, 42249, 42251 },
	[31816] = { 31816, 32203, 32204, 32205 },
	[31820] = { 31820, 32197, 32198, 32199 },
	[31837] = { 31837, 33687, 33693, 33697 },
	[31874] = { 31874, 32158, 32162, 32166 },
	[31888] = { 31888, 32171, 32172, 32173 },
	[32455] = { 32455, 42356, 42357, 42358 },
	[32624] = { 32624, 41918, 41919, 41920 },
	[32632] = { 32632, 42108, 42109, 42110 },
	[32633] = { 32633, 42143, 42144, 42145 },
	[32673] = { 32673, 33875, 33878, 33881 },
	[32678] = { 32678, 33930, 33937, 33944 },
	[32685] = { 32685, 33903, 33912, 33921 },
	[32710] = { 32710, 33804, 33810, 33816 },
	[32715] = { 32715, 33671, 33675, 33679 },
	[32719] = { 32719, 33662, 33665, 33668 },
	[32722] = { 32722, 33638, 33642, 33646 },
	[32744] = { 32744, 33622, 33627, 33632 },
	[32785] = { 32785, 33721, 33726, 33732 },
	[32792] = { 32792, 33702, 33708, 33715 },
	[32853] = { 32853, 34066, 34073, 34080 },
	[32881] = { 32881, 34088, 34094, 34100 },
	[32893] = { 32893, 41864, 41865, 41866 },
	[32947] = { 32947, 34009, 34015, 34021 },
	[32958] = { 32958, 33967, 33977, 33987 },
	[32986] = { 32986, 41807, 41808, 41809 },
	[33195] = { 33195, 37751, 37757, 37764 },
	[33211] = { 33211, 36267, 36271, 36313 },
	[33291] = { 33291, 35927, 35929, 35931 },
	[33308] = { 33308, 36098, 36104, 36109 },
	[33316] = { 33316, 37922, 37925, 37928 },
	[33319] = { 33319, 37955, 37966, 37977 },
	[33326] = { 33326, 37850, 37857, 37864 },
	[33357] = { 33357, 37587, 37595, 37603 },
	[33375] = { 33375, 35907, 35908, 35909 },
	[33376] = { 33376, 46363, 46374, 46385 },
	[33386] = { 33386, 35580, 35582, 35584 },
	[33398] = { 33398, 37510, 37514, 37518 },
	[34721] = { 34721, 36118, 36124, 36129 },
	[34727] = { 34727, 36134, 36139, 36144 },
	[34835] = { 34835, 35945, 35947, 35949 },
	[34838] = { 34838, 35933, 35937, 35941 },
	[34843] = { 34843, 35586, 35588, 35590 },
	[34851] = { 34851, 35592, 35594, 35596 },
	[35414] = { 35414, 35910, 35913, 35916 },
	[35419] = { 35419, 35920, 35922, 35924 },
	[35434] = { 35434, 36273, 36278, 36283 },
	[35441] = { 35441, 36288, 36293, 36298 },
	[35460] = { 35460, 36193, 36200, 36207 },
	[35508] = { 35508, 36172, 36179, 36186 },
	[35713] = { 35713, 42554, 42560, 42566 },
	[35721] = { 35721, 42647, 42651, 42655 },
	[35737] = { 35737, 42501, 42505, 42509 },
	[35750] = { 35750, 42706, 42713, 42720 },
	[35762] = { 35762, 42602, 42606, 42610 },
	[36028] = { 36028, 37800, 37808, 37816 },
	[36049] = { 36049, 37788, 37792, 37796 },
	[36485] = { 36485, 37701, 37707, 37713 },
	[36493] = { 36493, 37734, 37739, 37744 },
	[36508] = { 36508, 37522, 37527, 37532 },
	[36514] = { 36514, 37537, 37541, 37545 },
	[36891] = { 36891, 37940, 37945, 37950 },
	[36901] = { 36901, 37931, 37934, 37937 },
	[36908] = { 36908, 37989, 38002, 38015 },
	[36935] = { 36935, 38028, 38039, 38050 },
	[36943] = { 36943, 37871, 37879, 37887 },
	[36957] = { 36957, 37895, 37904, 37913 },
	[36967] = { 36967, 37640, 37649, 37658 },
	[36968] = { 36968, 37613, 37622, 37631 },
	[37232] = { 37232, 41306, 41308, 41310 },
	[37243] = { 37243, 41139, 41145, 41151 },
	[37470] = { 37470, 38067, 38071, 38075 },
	[37475] = { 37475, 38080, 38088, 38096 },
	[38250] = { 38250, 41491, 41494, 41497 },
	[38256] = { 38256, 41479, 41483, 41487 },
	[38264] = { 38264, 41406, 41410, 41414 },
	[38268] = { 38268, 41397, 41398, 41403 },
	[38312] = { 38312, 41352, 41355, 41358 },
	[38317] = { 38317, 41370, 41375, 41380 },
	[38401] = { 38401, 41518, 41522, 41526 },
	[38405] = { 38405, 41530, 41534, 41538 },
	[38452] = { 38452, 41453, 41456, 41459 },
	[38455] = { 38455, 41438, 41443, 41448 },
	[38563] = { 38563, 46525, 46527, 46529 },
	[38566] = { 38566, 46484, 46488, 46492 },
	[38570] = { 38570, 46649, 46651, 46653 },
	[38571] = { 38571, 46626, 46628, 46630 },
	[38573] = { 38573, 46607, 46608, 46609 },
	[38645] = { 38645, 40813, 40818, 40823 },
	[38660] = { 38660, 40830, 40836, 40842 },
	[38669] = { 38669, 40873, 40878, 40883 },
	[38672] = { 38672, 40861, 40865, 40869 },
	[38685] = { 38685, 40893, 40895, 40897 },
	[38687] = { 38687, 40899, 40903, 40907 },
	[38689] = { 38689, 40920, 40926, 40932 },
	[38695] = { 38695, 40938, 40941, 40944 },
	[38701] = { 38701, 40781, 40785, 40789 },
	[38705] = { 38705, 40769, 40773, 40777 },
	[38745] = { 38745, 39748, 39751, 39754 },
	[38754] = { 38754, 39757, 39763, 39769 },
	[38778] = { 38778, 39812, 39817, 39822 },
	[38788] = { 38788, 39797, 39802, 39807 },
	[38794] = { 38794, 39884, 39888, 39892 },
	[38802] = { 38802, 39896, 39900, 39904 },
	[38807] = { 38807, 40000, 40004, 40008 },
	[38814] = { 38814, 39976, 39980, 39984 },
	[38819] = { 38819, 39948, 39952, 39957 },
	[38823] = { 38823, 39932, 39937, 39942 },
	[38839] = { 38839, 40667, 40671, 40675 },
	[38845] = { 38845, 40679, 40683, 40687 },
	[38846] = { 38846, 40593, 40596, 40599 },
	[38857] = { 38857, 40584, 40587, 40590 },
	[38861] = { 38861, 40738, 40741, 40744 },
	[38891] = { 38891, 40717, 40724, 40731 },
	[38901] = { 38901, 40634, 40638, 40642 },
	[38906] = { 38906, 40646, 40649, 40651 },
	[38910] = { 38910, 40622, 40625, 40628 },
	[38914] = { 38914, 40613, 40616, 40619 },
	[41937] = { 41937, 38931, 41933, 41936 },
	[41926] = { 41926, 38932, 41924, 41925 },
	[38937] = { 38937, 41029, 41038, 41047 },
	[41902] = { 41902, 38949, 41900, 41901 },
	[41881] = { 41881, 38956, 41879, 41880 },
	[41815] = { 41815, 38963, 41813, 41814 },
	[41824] = { 41824, 38965, 41822, 41823 },
	[38984] = { 38984, 40977, 40995, 41006 },
	[39011] = { 39011, 41738, 41754, 41769 },
	[39052] = { 39052, 41673, 41691, 41711 },
	[39075] = { 39075, 42365, 42366, 42367 },
	[39076] = { 39076, 42377, 42378, 42379 },
	[39089] = { 39089, 41550, 41553, 41556 },
	[39095] = { 39095, 41559, 41563, 41567 },
	[42128] = { 42128, 39104, 42126, 42127 },
	[42119] = { 42119, 39105, 42117, 42118 },
	[42157] = { 42157, 39113, 42155, 42156 },
	[42179] = { 42179, 39114, 42177, 42178 },
	[39143] = { 39143, 42961, 42968, 42975 },
	[39161] = { 39161, 42982, 42989, 42996 },
	[39182] = { 39182, 41115, 41118, 41121 },
	[39186] = { 39186, 41109, 41111, 41113 },
	[39192] = { 39192, 41133, 41135, 41137 },
	[39195] = { 39195, 41127, 41129, 41131 },
	[39197] = { 39197, 41097, 41100, 41103 },
	[39205] = { 39205, 41085, 41088, 41091 },
	[39270] = { 39270, 43089, 43091, 43093 },
	[39298] = { 39298, 43400, 43403, 43406 },
	[39369] = { 39369, 43304, 43307, 43310 },
	[39425] = { 39425, 43533, 43537, 43541 },
	[39475] = { 39475, 43353, 43358, 43363 },
	[39489] = { 39489, 43241, 43246, 43251 },
	[40058] = { 40058, 41251, 41253, 41255 },
	[40060] = { 40060, 41257, 41261, 41265 },
	[40076] = { 40076, 41272, 41274, 41276 },
	[40079] = { 40079, 41278, 41283, 41288 },
	[40094] = { 40094, 41175, 41182, 41189 },
	[40103] = { 40103, 41157, 41163, 41169 },
	[40109] = { 40109, 41211, 41220, 41225 },
	[40116] = { 40116, 41230, 41234, 41239 },
	[40126] = { 40126, 41312, 41316, 41320 },
	[40130] = { 40130, 41294, 41298, 41302 },
	[40158] = { 40158, 42592, 42595, 42598 },
	[40161] = { 40161, 42575, 42581, 42586 },
	[40169] = { 40169, 42536, 42542, 42548 },
	[40181] = { 40181, 42515, 42522, 42529 },
	[40194] = { 40194, 42614, 42619, 42624 },
	[40195] = { 40195, 42629, 42635, 42641 },
	[40211] = { 40211, 46497, 46501, 46505 },
	[40215] = { 40215, 46509, 46514, 46519 },
	[40220] = { 40220, 46540, 46543, 46546 },
	[40223] = { 40223, 46531, 46534, 46537 },
	[40226] = { 40226, 46664, 46667, 46670 },
	[40229] = { 40229, 46655, 46658, 46661 },
	[40232] = { 40232, 46632, 46634, 46636 },
	[40234] = { 40234, 46638, 46641, 46644 },
	[40237] = { 40237, 46610, 46612, 46614 },
	[40239] = { 40239, 46616, 46619, 46622 },
	[40242] = { 40242, 46440, 46453, 46466 },
	[40255] = { 40255, 46396, 46408, 46420 },
	[40300] = { 40300, 42659, 42665, 42671 },
	[40317] = { 40317, 43071, 43077, 43083 },
	[40328] = { 40328, 43059, 43063, 43067 },
	[40336] = { 40336, 42677, 42687, 42696 },
	[40372] = { 40372, 42757, 42764, 42771 },
	[40382] = { 40382, 42727, 42737, 42747 },
	[40414] = { 40414, 43101, 43105, 43109 },
	[40420] = { 40420, 43095, 43097, 43099 },
	[40441] = { 40441, 42268, 42273, 42278 },
	[40445] = { 40445, 42253, 42258, 42263 },
	[40452] = { 40452, 42230, 42235, 42240 },
	[40457] = { 40457, 42212, 42218, 42224 },
	[40465] = { 40465, 42335, 42342, 42349 },
	[40470] = { 40470, 42311, 42319, 42327 },
	[40478] = { 40478, 42422, 42426, 42430 },
	[40483] = { 40483, 42443, 42449, 42455 },
	[40489] = { 40489, 42470, 42474, 42478 },
	[40493] = { 40493, 42482, 42487, 42492 },
	[41958] = { 41958, 43271, 43277, 43287 },
	[41967] = { 41967, 43256, 43261, 43266 },
	[41990] = { 41990, 43481, 43485, 43489 },
	[42012] = { 42012, 43469, 43473, 43477 },
	[42028] = { 42028, 43409, 43412, 43415 },
	[42038] = { 42038, 43439, 43443, 43447 },
	[42056] = { 42056, 43368, 43373, 43378 },
	[42060] = { 42060, 43383, 43388, 43393 },
	[42138] = { 42138, 43313, 43318, 43323 },
	[42176] = { 42176, 43328, 43331, 43334 },
	[43714] = { 43714, 47548, 47550, 47552 },
	[46324] = { 46324, 47565, 47567, 47569 },
	[46331] = { 46331, 47554, 47557, 47560 },
	[46340] = { 46340, 48950, 48953, 48956 },
	[46348] = { 46348, 48959, 48965, 48971 },
	[46356] = { 46356, 48977, 48984, 48991 },
	[58310] = { 58310, 58314, 58315, 58316 },
	[58323] = { 58323, 58317, 58319, 58321 },
	[58334] = { 58334, 58325, 58329, 58332 },
	[58405] = { 58405, 58736, 58738, 58740 },
	[58794] = { 58794, 58742, 58786, 58790 },
	[58808] = { 58808, 58798, 58802, 58805 },
	[58855] = { 58855, 58857, 58859, 58862 },
	[58876] = { 58876, 58864, 58870, 58873 },
	[58907] = { 58907, 58879, 58901, 58904 },
	[61487] = { 61487, 63278, 63281, 63284 },
	[61489] = { 61489, 63356, 63363, 63370 },
	[61491] = { 61491, 63287, 63290, 63293 },
	[61500] = { 61500, 63296, 63299, 63302 },
	[61503] = { 61503, 63236, 63238, 63240 },
	[61505] = { 61505, 63243, 63245, 63247 },
	[61507] = { 61507, 63249, 63252, 63255 },
	[61511] = { 61511, 63308, 63313, 63318 },
	[61519] = { 61519, 63377, 63384, 63391 },
	[61524] = { 61524, 63399, 63407, 63415 },
	[61529] = { 61529, 63341, 63346, 63351 },
	[61536] = { 61536, 63323, 63329, 63335 },
	[61902] = { 61902, 62090, 64176, 62096 },
	[61919] = { 61919, 62111, 62114, 62117 },
	[61927] = { 61927, 62099, 62103, 62107 },
	[63029] = { 63029, 63054, 63056, 63058 },
	[63044] = { 63044, 63060, 63063, 63066 },
	[63046] = { 63046, 63069, 63072, 63075 },
	[83216] = { 83216, 86269, 86272, 86275 },
	[83229] = { 83229, 86278, 86281, 86284 },
	[83238] = { 83238, 86287, 86291, 86295 },
	[83272] = { 83272, 86316, 86319, 86322 },
	[83292] = { 83292, 86325, 86329, 86333 },
	[83310] = { 83310, 86337, 86341, 86345 },
	[83465] = { 83465, 86582, 86584, 86586 },
	[83552] = { 83552, 86421, 86423, 86425 },
	[83600] = { 83600, 86360, 86365, 86370 },
	[83619] = { 83619, 86481, 86483, 86485 },
	[83642] = { 83642, 86530, 86532, 86534 },
	[83850] = { 83850, 86428, 86441, 86454 },
	[84434] = { 84434, 86506, 86508, 86510 },
	[85132] = { 85132, 86467, 86471, 86475 },
	[85179] = { 85179, 86398, 86404, 86410 },
	[85187] = { 85187, 86383, 86388, 86393 },
	[85257] = { 85257, 86597, 86600, 86603 },
	[85451] = { 85451, 86614, 86617, 86620 },
	[85532] = { 85532, 93966, 93967, 93968 },
	[85536] = { 85536, 93769, 93770, 93771 },
	[85539] = { 85539, 93906, 93907, 93908 },
	[85552] = { 85552, 93875, 93876, 93877 },
	[85564] = { 85564, 93932, 93933, 93934 },
	[85578] = { 85578, 93802, 93803, 93804 },
	[85804] = { 85804, 93969, 93970, 93971 },
	[85807] = { 85807, 93972, 93973, 93974 },
	[85840] = { 85840, 93805, 93806, 93807 },
	[85845] = { 85845, 93808, 93809, 93810 },
	[85850] = { 85850, 93878, 93879, 93880 },
	[85851] = { 85851, 93881, 93882, 93883 },
	[85854] = { 85854, 93909, 93910, 93911 },
	[85855] = { 85855, 93912, 93913, 93914 },
	[85858] = { 85858, 93938, 93939, 93940 },
	[85859] = { 85859, 93935, 93936, 93937 },
	[85862] = { 85862, 93772, 93773, 93774 },
	[85863] = { 85863, 93775, 93776, 93777 },
	[85982] = { 85982, 85983, 85984, 85985 },
	[85986] = { 85986, 85987, 85988, 85989 },
	[85990] = { 85990, 85991, 85992, 85993 },
	[85995] = { 85995, 85996, 85997, 85998 },
	[85999] = { 85999, 86000, 86001, 86002 },
	[86003] = { 86003, 86004, 86005, 86006 },
	[86009] = { 86009, 86012, 86013, 93593 },
	[86015] = { 86015, 86016, 86017, 93778 },
	[86019] = { 86019, 86020, 86021, 93791 },
	[86023] = { 86023, 86024, 86025, 86026 },
	[86027] = { 86027, 86028, 86029, 86030 },
	[86031] = { 86031, 86032, 86033, 86034 },
	[86037] = { 86037, 86038, 86039, 86040 },
	[86041] = { 86041, 86042, 86043, 86044 },
	[86045] = { 86045, 86046, 86047, 86048 },
	[86050] = { 86050, 86051, 86052, 86053 },
	[86054] = { 86054, 86055, 86056, 86057 },
	[86058] = { 86058, 86059, 86060, 86061 },
	[86109] = { 86109, 86110, 86111, 86112 },
	[86113] = { 86113, 86114, 86115, 86116 },
	[86117] = { 86117, 86118, 86119, 86120 },
	[86122] = { 86122, 86123, 86124, 86125 },
	[86126] = { 86126, 86127, 86128, 86129 },
	[86130] = { 86130, 86131, 86132, 86133 },
	[86135] = { 86135, 86136, 86137, 86138 },
	[86139] = { 86139, 86140, 86141, 86142 },
	[86143] = { 86143, 86144, 86145, 86146 },
	[86148] = { 86148, 86149, 86150, 86151 },
	[86152] = { 86152, 86153, 86154, 86155 },
	[86156] = { 86156, 86157, 86158, 86159 },
	[86161] = { 86161, 86162, 86163, 86164 },
	[86165] = { 86165, 86166, 86167, 86168 },
	[86169] = { 86169, 86170, 86171, 86172 },
	[86175] = { 86175, 86176, 86177, 86178 },
	[86179] = { 86179, 86180, 86181, 86182 },
	[86183] = { 86183, 86184, 86185, 86186 },
	[39012] = { 39012, 41739, 41755, 41770 },
	[39018] = { 39018, 41748, 41757, 41772 },
	[39028] = { 39028, 41743, 41756, 41771 },
	[29073] = { 29073, 40948, 40957, 40965 },
	[29089] = { 29089, 40953, 40962, 40970 },
	[29078] = { 29078, 40950, 40959, 40967 },
	[38944] = { 38944, 41030, 41039, 41048 },
	[38978] = { 38978, 41036, 41045, 41054 },
	[38970] = { 38970, 41033, 41042, 41051 },
	[38985] = { 38985, 40984, 40996, 41009 },
	[38993] = { 38993, 40991, 41003, 41016 },
	[38989] = { 38989, 40988, 41000, 41013 },
	[28794] = { 28794, 42950, 42954, 42958 },
	[28799] = { 28799, 42952, 42956, 42960 },
	[28798] = { 28798, 42951, 42955, 42959 },
	[28807] = { 28807, 41628, 41643, 41659 },
	[28849] = { 28849, 41637, 41652, 41668 },
	[28854] = { 28854, 41632, 41647, 41663 },
	[39053] = { 39053, 41674, 41692, 41712 },
	[39073] = { 39073, 41685, 41705, 41723 },
	[39067] = { 39067, 41679, 41697, 41717 },
	[39145] = { 39145, 42962, 42969, 42976 },
	[39147] = { 39147, 42966, 42973, 42980 },
	[39146] = { 39146, 42964, 42971, 42978 },
	[39162] = { 39162, 42983, 42990, 42997 },
	[39167] = { 39167, 42987, 42994, 43001 },
	[39163] = { 39163, 42985, 42992, 42999 },
	[83625] = { 83625, 86488, 86490, 86492 },
	[83630] = { 83630, 86500, 86502, 86504 },
	[83628] = { 83628, 86494, 86495, 86496 },
	[85126] = { 85126, 86512, 86513, 86515 },
	[85130] = { 85130, 86524, 86526, 86528 },
	[85128] = { 85128, 86518, 86520, 86522 },
	[83682] = { 83682, 86536, 86538, 86540 },
	[83686] = { 83686, 86548, 86550, 86552 },
	[83684] = { 83684, 86542, 86544, 86546 },
}
uespLog.SKILL_RANKDATA = {
	[15540] = { 15540, 1 },
	[15957] = { 15957, 1 },
	[16536] = { 16536, 1 },
	[17874] = { 17874, 1 },
	[17878] = { 17878, 1 },
	[18342] = { 18342, 1 },
	[18718] = { 18718, 1 },
	[19109] = { 19109, 1 },
	[19123] = { 19123, 1 },
	[19976] = { 15957, 2 },
	[19979] = { 15957, 3 },
	[19982] = { 15957, 4 },
	[20245] = { 20245, 1 },
	[20251] = { 20251, 1 },
	[20252] = { 20252, 1 },
	[20319] = { 20319, 1 },
	[20323] = { 20323, 1 },
	[20328] = { 20328, 1 },
	[20492] = { 20492, 1 },
	[20496] = { 20496, 1 },
	[20499] = { 20499, 1 },
	[20657] = { 20657, 1 },
	[20660] = { 20660, 1 },
	[20668] = { 20668, 1 },
	[20779] = { 20779, 1 },
	[20803] = { 23806, 2 },
	[20805] = { 20805, 1 },
	[20816] = { 20816, 1 },
	[20917] = { 20917, 1 },
	[20919] = { 20919, 1 },
	[20930] = { 20930, 1 },
	[20944] = { 20944, 1 },
	[21007] = { 21007, 1 },
	[21014] = { 21014, 1 },
	[21017] = { 21017, 1 },
	[21157] = { 21157, 1 },
	[21726] = { 21726, 1 },
	[21729] = { 21729, 1 },
	[21732] = { 21732, 1 },
	[21752] = { 21752, 1 },
	[21755] = { 21755, 1 },
	[21758] = { 21758, 1 },
	[21761] = { 21761, 1 },
	[21763] = { 21763, 1 },
	[21765] = { 21765, 1 },
	[21776] = { 21776, 1 },
	[22004] = { 22004, 1 },
	[22006] = { 22006, 1 },
	[22057] = { 22057, 1 },
	[22095] = { 22095, 1 },
	[22110] = { 22110, 1 },
	[22138] = { 22138, 1 },
	[22139] = { 22139, 1 },
	[22144] = { 22144, 1 },
	[22149] = { 22149, 1 },
	[22161] = { 22161, 1 },
	[22178] = { 22178, 1 },
	[22180] = { 22180, 1 },
	[22182] = { 22182, 1 },
	[22223] = { 22223, 1 },
	[22226] = { 22226, 1 },
	[22229] = { 22229, 1 },
	[22234] = { 22234, 1 },
	[22237] = { 22237, 1 },
	[22240] = { 22240, 1 },
	[22250] = { 22250, 1 },
	[22253] = { 22253, 1 },
	[22256] = { 22256, 1 },
	[22259] = { 22259, 1 },
	[22262] = { 22262, 1 },
	[22265] = { 22265, 1 },
	[22304] = { 22304, 1 },
	[22314] = { 22314, 1 },
	[22327] = { 22327, 1 },
	[23182] = { 23182, 1 },
	[23200] = { 23200, 1 },
	[23205] = { 23205, 1 },
	[23210] = { 23210, 1 },
	[23213] = { 23213, 1 },
	[23231] = { 23231, 1 },
	[23234] = { 23234, 1 },
	[23236] = { 23236, 1 },
	[23277] = { 23277, 1 },
	[23304] = { 23304, 1 },
	[23316] = { 23316, 1 },
	[23319] = { 23319, 1 },
	[23492] = { 23492, 1 },
	[23495] = { 23495, 1 },
	[23634] = { 23634, 1 },
	[23670] = { 23670, 1 },
	[23674] = { 23674, 1 },
	[23678] = { 23678, 1 },
	[23709] = { 22149, 2 },
	[23713] = { 22149, 3 },
	[23716] = { 22149, 4 },
	[23719] = { 22161, 2 },
	[23722] = { 22161, 3 },
	[23726] = { 22161, 4 },
	[23736] = { 20492, 2 },
	[23740] = { 20492, 3 },
	[23744] = { 20492, 4 },
	[23770] = { 20496, 2 },
	[23774] = { 20496, 3 },
	[23778] = { 20496, 4 },
	[23782] = { 22138, 2 },
	[23783] = { 22138, 3 },
	[23784] = { 22138, 4 },
	[23785] = { 22139, 2 },
	[23787] = { 22139, 3 },
	[23788] = { 22139, 4 },
	[23792] = { 22144, 2 },
	[23793] = { 22144, 3 },
	[23794] = { 22144, 4 },
	[23806] = { 23806, 1 },
	[23809] = { 23806, 3 },
	[23811] = { 23806, 4 },
	[23813] = { 20805, 2 },
	[23816] = { 20805, 3 },
	[23819] = { 20805, 4 },
	[23822] = { 20319, 2 },
	[23825] = { 20319, 3 },
	[23828] = { 20319, 4 },
	[23831] = { 20816, 2 },
	[23834] = { 20323, 2 },
	[23838] = { 20323, 3 },
	[23842] = { 20323, 4 },
	[23846] = { 20328, 2 },
	[23851] = { 20328, 3 },
	[23856] = { 20328, 4 },
	[23864] = { 15540, 2 },
	[23869] = { 15540, 3 },
	[23870] = { 15540, 4 },
	[23882] = { 20657, 2 },
	[23884] = { 20657, 3 },
	[23886] = { 20657, 4 },
	[23888] = { 20660, 2 },
	[23893] = { 20660, 3 },
	[23898] = { 20660, 4 },
	[23907] = { 20668, 2 },
	[23911] = { 20668, 3 },
	[23915] = { 20668, 4 },
	[23916] = { 20816, 3 },
	[23924] = { 20816, 4 },
	[23968] = { 22234, 2 },
	[23969] = { 22234, 3 },
	[23970] = { 22234, 4 },
	[23983] = { 22237, 2 },
	[23984] = { 22237, 3 },
	[23985] = { 22237, 4 },
	[23996] = { 22240, 2 },
	[23997] = { 22240, 3 },
	[23998] = { 22240, 4 },
	[24044] = { 21752, 2 },
	[24052] = { 21752, 3 },
	[24063] = { 21752, 4 },
	[24080] = { 22057, 2 },
	[24101] = { 22057, 3 },
	[24110] = { 22057, 4 },
	[24129] = { 22110, 2 },
	[24139] = { 22110, 3 },
	[24147] = { 22110, 4 },
	[24155] = { 22095, 2 },
	[24156] = { 22095, 3 },
	[24157] = { 22095, 4 },
	[24158] = { 24158, 1 },
	[24160] = { 21726, 2 },
	[24163] = { 24163, 1 },
	[24165] = { 24165, 1 },
	[24167] = { 21726, 3 },
	[24171] = { 21726, 4 },
	[24174] = { 21729, 2 },
	[24177] = { 21729, 3 },
	[24180] = { 21729, 4 },
	[24184] = { 21732, 2 },
	[24187] = { 21732, 3 },
	[24195] = { 21732, 4 },
	[24198] = { 22250, 2 },
	[24201] = { 22250, 3 },
	[24204] = { 22250, 4 },
	[24207] = { 22253, 2 },
	[24210] = { 22253, 3 },
	[24213] = { 22253, 4 },
	[24216] = { 22256, 2 },
	[24219] = { 22256, 3 },
	[24222] = { 22256, 4 },
	[24288] = { 21755, 2 },
	[24295] = { 21755, 3 },
	[24301] = { 21755, 4 },
	[24308] = { 21758, 2 },
	[24314] = { 21758, 3 },
	[24320] = { 21758, 4 },
	[24326] = { 24326, 1 },
	[24328] = { 24328, 1 },
	[24330] = { 24330, 1 },
	[24371] = { 24371, 1 },
	[24574] = { 24574, 1 },
	[24578] = { 24578, 1 },
	[24584] = { 24584, 1 },
	[24589] = { 24589, 1 },
	[24595] = { 24595, 1 },
	[24613] = { 24613, 1 },
	[24636] = { 24636, 1 },
	[24639] = { 24639, 1 },
	[24785] = { 24785, 1 },
	[24804] = { 24804, 1 },
	[24806] = { 24806, 1 },
	[24828] = { 24828, 1 },
	[24834] = { 24834, 1 },
	[24842] = { 24842, 1 },
	[25091] = { 25091, 1 },
	[25255] = { 25255, 1 },
	[25260] = { 25260, 1 },
	[25267] = { 25267, 1 },
	[25352] = { 25352, 1 },
	[25375] = { 25375, 1 },
	[25377] = { 25377, 1 },
	[25380] = { 25380, 1 },
	[25411] = { 25411, 1 },
	[25484] = { 25484, 1 },
	[25493] = { 25493, 1 },
	[26114] = { 26114, 1 },
	[26158] = { 26158, 1 },
	[26188] = { 26188, 1 },
	[26209] = { 26209, 1 },
	[26768] = { 26768, 1 },
	[26792] = { 26792, 1 },
	[26797] = { 26797, 1 },
	[26800] = { 26800, 1 },
	[26804] = { 26804, 1 },
	[26807] = { 26807, 1 },
	[26821] = { 26821, 1 },
	[26858] = { 26858, 1 },
	[26869] = { 26869, 1 },
	[26971] = { 26158, 2 },
	[26973] = { 26158, 3 },
	[26975] = { 26158, 4 },
	[26977] = { 26800, 2 },
	[26980] = { 26800, 3 },
	[26983] = { 26800, 4 },
	[26986] = { 26804, 2 },
	[26989] = { 26804, 3 },
	[26992] = { 26804, 4 },
	[26995] = { 26209, 2 },
	[27001] = { 26209, 3 },
	[27007] = { 26209, 4 },
	[27013] = { 26807, 2 },
	[27024] = { 26807, 3 },
	[27030] = { 26807, 4 },
	[27036] = { 26821, 2 },
	[27040] = { 26821, 3 },
	[27043] = { 26821, 4 },
	[27046] = { 26188, 2 },
	[27059] = { 26188, 3 },
	[27090] = { 26188, 4 },
	[27102] = { 26858, 2 },
	[27112] = { 26858, 3 },
	[27122] = { 26858, 4 },
	[27145] = { 26869, 2 },
	[27156] = { 26869, 3 },
	[27167] = { 26869, 4 },
	[27179] = { 26114, 2 },
	[27182] = { 26114, 3 },
	[27186] = { 26114, 4 },
	[27189] = { 26792, 2 },
	[27193] = { 26792, 3 },
	[27197] = { 26792, 4 },
	[27201] = { 26797, 2 },
	[27204] = { 26797, 3 },
	[27207] = { 26797, 4 },
	[27211] = { 21761, 2 },
	[27219] = { 21761, 3 },
	[27227] = { 21761, 4 },
	[27243] = { 22265, 2 },
	[27249] = { 22265, 3 },
	[27255] = { 22265, 4 },
	[27261] = { 22259, 2 },
	[27269] = { 22259, 3 },
	[27275] = { 22259, 4 },
	[27281] = { 22262, 2 },
	[27288] = { 22262, 3 },
	[27295] = { 22262, 4 },
	[27303] = { 21776, 2 },
	[27304] = { 21776, 3 },
	[27306] = { 21776, 4 },
	[27307] = { 22004, 2 },
	[27309] = { 22004, 3 },
	[27311] = { 22004, 4 },
	[27313] = { 22006, 2 },
	[27316] = { 22006, 3 },
	[27324] = { 22006, 4 },
	[27334] = { 22304, 2 },
	[27340] = { 22304, 3 },
	[27342] = { 22304, 4 },
	[27346] = { 22327, 2 },
	[27349] = { 22327, 3 },
	[27352] = { 22327, 4 },
	[27368] = { 22314, 2 },
	[27372] = { 22314, 3 },
	[27376] = { 22314, 4 },
	[27388] = { 22223, 2 },
	[27392] = { 22223, 3 },
	[27396] = { 22223, 4 },
	[27401] = { 22229, 2 },
	[27407] = { 22229, 3 },
	[27413] = { 22229, 4 },
	[27419] = { 22226, 2 },
	[27423] = { 22226, 3 },
	[27427] = { 22226, 4 },
	[27493] = { 22178, 2 },
	[27497] = { 22178, 3 },
	[27501] = { 22178, 4 },
	[27506] = { 22182, 2 },
	[27510] = { 22182, 3 },
	[27514] = { 22182, 4 },
	[27520] = { 22180, 2 },
	[27526] = { 22180, 3 },
	[27530] = { 22180, 4 },
	[27534] = { 21765, 2 },
	[27549] = { 21765, 3 },
	[27558] = { 21765, 4 },
	[27569] = { 21763, 2 },
	[27578] = { 21763, 3 },
	[27587] = { 21763, 4 },
	[27706] = { 27706, 1 },
	[28025] = { 28025, 1 },
	[28279] = { 28279, 1 },
	[28297] = { 28297, 1 },
	[28302] = { 28302, 1 },
	[28304] = { 28304, 1 },
	[28306] = { 28306, 1 },
	[28308] = { 28308, 1 },
	[28311] = { 28311, 1 },
	[28341] = { 28341, 1 },
	[28348] = { 28348, 1 },
	[28365] = { 28365, 1 },
	[28379] = { 28379, 1 },
	[28385] = { 28385, 1 },
	[28418] = { 28418, 1 },
	[28448] = { 28448, 1 },
	[28536] = { 28536, 1 },
	[28567] = { 28567, 1 },
	[28591] = { 28591, 1 },
	[28607] = { 28607, 1 },
	[28613] = { 28613, 1 },
	[28719] = { 28719, 1 },
	[28727] = { 28727, 1 },
	[28800] = { 28800, 1 },
	[28858] = { 28858, 1 },
	[28869] = { 28869, 1 },
	[28876] = { 28876, 1 },
	[28879] = { 28879, 1 },
	[28882] = { 28882, 1 },
	[28967] = { 28967, 1 },
	[28988] = { 28988, 1 },
	[29004] = { 29004, 1 },
	[29012] = { 29012, 1 },
	[29032] = { 29032, 1 },
	[29037] = { 29037, 1 },
	[29043] = { 29043, 1 },
	[29059] = { 29059, 1 },
	[29071] = { 29071, 1 },
	[29091] = { 29091, 1 },
	[29173] = { 29173, 1 },
	[29224] = { 29224, 1 },
	[29338] = { 29338, 1 },
	[29482] = { 29482, 1 },
	[29489] = { 29489, 1 },
	[29552] = { 29552, 1 },
	[29556] = { 29556, 1 },
	[29833] = { 27706, 2 },
	[29839] = { 27706, 3 },
	[29844] = { 27706, 4 },
	[29849] = { 28341, 2 },
	[29855] = { 28341, 3 },
	[29861] = { 28341, 4 },
	[29867] = { 28348, 2 },
	[29874] = { 28348, 3 },
	[29881] = { 28348, 4 },
	[29889] = { 24828, 2 },
	[29899] = { 24828, 3 },
	[29909] = { 24828, 4 },
	[29919] = { 24842, 2 },
	[29929] = { 24842, 3 },
	[29939] = { 24842, 4 },
	[29949] = { 24834, 2 },
	[29961] = { 24834, 3 },
	[29973] = { 24834, 4 },
	[29995] = { 24584, 2 },
	[30004] = { 24584, 3 },
	[30012] = { 24584, 4 },
	[30022] = { 24595, 2 },
	[30033] = { 24595, 3 },
	[30043] = { 24595, 4 },
	[30056] = { 24589, 2 },
	[30064] = { 24589, 3 },
	[30072] = { 24589, 4 },
	[30083] = { 28025, 2 },
	[30085] = { 28025, 3 },
	[30087] = { 28025, 4 },
	[30089] = { 28308, 2 },
	[30092] = { 28308, 3 },
	[30095] = { 28308, 4 },
	[30098] = { 28311, 2 },
	[30103] = { 28311, 3 },
	[30107] = { 28311, 4 },
	[30152] = { 24371, 2 },
	[30157] = { 24371, 3 },
	[30162] = { 24371, 4 },
	[30167] = { 24578, 2 },
	[30172] = { 24578, 3 },
	[30177] = { 24578, 4 },
	[30182] = { 24574, 2 },
	[30188] = { 24574, 3 },
	[30194] = { 24574, 4 },
	[30201] = { 23234, 2 },
	[30203] = { 23234, 3 },
	[30205] = { 23234, 4 },
	[30208] = { 23236, 2 },
	[30211] = { 23236, 3 },
	[30215] = { 23236, 4 },
	[30218] = { 23277, 2 },
	[30221] = { 23277, 3 },
	[30224] = { 23277, 4 },
	[30229] = { 23210, 2 },
	[30232] = { 23210, 3 },
	[30235] = { 23210, 4 },
	[30238] = { 23231, 2 },
	[30241] = { 23231, 3 },
	[30244] = { 23231, 4 },
	[30247] = { 23213, 2 },
	[30251] = { 23213, 3 },
	[30255] = { 23213, 4 },
	[30259] = { 23182, 2 },
	[30264] = { 23182, 3 },
	[30269] = { 23182, 4 },
	[30274] = { 23200, 2 },
	[30280] = { 23200, 3 },
	[30286] = { 23200, 4 },
	[30292] = { 23205, 2 },
	[30297] = { 23205, 3 },
	[30302] = { 23205, 4 },
	[30311] = { 18718, 2 },
	[30315] = { 18718, 3 },
	[30319] = { 18718, 4 },
	[30323] = { 19123, 2 },
	[30327] = { 19123, 3 },
	[30331] = { 19123, 4 },
	[30335] = { 19109, 2 },
	[30339] = { 19109, 3 },
	[30343] = { 19109, 4 },
	[30348] = { 24785, 2 },
	[30351] = { 24785, 3 },
	[30354] = { 24785, 4 },
	[30358] = { 24806, 2 },
	[30362] = { 24806, 3 },
	[30366] = { 24806, 4 },
	[30371] = { 24804, 2 },
	[30376] = { 24804, 3 },
	[30381] = { 24804, 4 },
	[30386] = { 23670, 2 },
	[30388] = { 23670, 3 },
	[30390] = { 23670, 4 },
	[30392] = { 23674, 2 },
	[30394] = { 23674, 3 },
	[30396] = { 23674, 4 },
	[30398] = { 23678, 2 },
	[30402] = { 23678, 3 },
	[30406] = { 23678, 4 },
	[30410] = { 24158, 2 },
	[30414] = { 24158, 3 },
	[30418] = { 24158, 4 },
	[30422] = { 24165, 2 },
	[30427] = { 24165, 3 },
	[30432] = { 24165, 4 },
	[30437] = { 24163, 2 },
	[30441] = { 24163, 3 },
	[30445] = { 24163, 4 },
	[30457] = { 28418, 2 },
	[30460] = { 28418, 3 },
	[30463] = { 28418, 4 },
	[30466] = { 29489, 2 },
	[30470] = { 29489, 3 },
	[30474] = { 29489, 4 },
	[30478] = { 29482, 2 },
	[30482] = { 29482, 3 },
	[30486] = { 29482, 4 },
	[30491] = { 24326, 2 },
	[30495] = { 24326, 3 },
	[30499] = { 24326, 4 },
	[30503] = { 24328, 2 },
	[30507] = { 24328, 3 },
	[30511] = { 24328, 4 },
	[30515] = { 24330, 2 },
	[30519] = { 24330, 3 },
	[30523] = { 24330, 4 },
	[30528] = { 23634, 2 },
	[30533] = { 23634, 3 },
	[30538] = { 23634, 4 },
	[30543] = { 23495, 2 },
	[30548] = { 23495, 3 },
	[30553] = { 23495, 4 },
	[30564] = { 23492, 2 },
	[30569] = { 23492, 3 },
	[30575] = { 23492, 4 },
	[30581] = { 24613, 2 },
	[30584] = { 24613, 3 },
	[30587] = { 24613, 4 },
	[30592] = { 24636, 2 },
	[30595] = { 24636, 3 },
	[30598] = { 24636, 4 },
	[30618] = { 24639, 2 },
	[30622] = { 24639, 3 },
	[30626] = { 24639, 4 },
	[30631] = { 23304, 2 },
	[30636] = { 23304, 3 },
	[30641] = { 23304, 4 },
	[30647] = { 23319, 2 },
	[30652] = { 23319, 3 },
	[30657] = { 23319, 4 },
	[30664] = { 23316, 2 },
	[30669] = { 23316, 3 },
	[30674] = { 23316, 4 },
	[30920] = { 30920, 1 },
	[31271] = { 31271, 1 },
	[31531] = { 31531, 1 },
	[31632] = { 31632, 1 },
	[31642] = { 31642, 1 },
	[31816] = { 31816, 1 },
	[31820] = { 31820, 1 },
	[31837] = { 31837, 1 },
	[31874] = { 31874, 1 },
	[31888] = { 31888, 1 },
	[32105] = { 20245, 2 },
	[32108] = { 20245, 3 },
	[32111] = { 20245, 4 },
	[32114] = { 20252, 2 },
	[32119] = { 20252, 3 },
	[32123] = { 20252, 4 },
	[32127] = { 20251, 2 },
	[32131] = { 20251, 3 },
	[32135] = { 20251, 4 },
	[32151] = { 29043, 2 },
	[32154] = { 29043, 3 },
	[32156] = { 29043, 4 },
	[32158] = { 31874, 2 },
	[32162] = { 31874, 3 },
	[32166] = { 31874, 4 },
	[32171] = { 31888, 2 },
	[32172] = { 31888, 3 },
	[32173] = { 31888, 4 },
	[32190] = { 29032, 2 },
	[32192] = { 29032, 3 },
	[32194] = { 29032, 4 },
	[32197] = { 31820, 2 },
	[32198] = { 31820, 3 },
	[32199] = { 31820, 4 },
	[32203] = { 31816, 2 },
	[32204] = { 31816, 3 },
	[32205] = { 31816, 4 },
	[32215] = { 20499, 2 },
	[32222] = { 20499, 3 },
	[32229] = { 20499, 4 },
	[32455] = { 32455, 1 },
	[32624] = { 32624, 1 },
	[32632] = { 32632, 1 },
	[32633] = { 32633, 1 },
	[32673] = { 32673, 1 },
	[32678] = { 32678, 1 },
	[32685] = { 32685, 1 },
	[32710] = { 32710, 1 },
	[32715] = { 32715, 1 },
	[32719] = { 32719, 1 },
	[32722] = { 32722, 1 },
	[32744] = { 32744, 1 },
	[32785] = { 32785, 1 },
	[32792] = { 32792, 1 },
	[32853] = { 32853, 1 },
	[32881] = { 32881, 1 },
	[32893] = { 32893, 1 },
	[32947] = { 32947, 1 },
	[32958] = { 32958, 1 },
	[32986] = { 32986, 1 },
	[33195] = { 33195, 1 },
	[33211] = { 33211, 1 },
	[33291] = { 33291, 1 },
	[33308] = { 33308, 1 },
	[33316] = { 33316, 1 },
	[33319] = { 33319, 1 },
	[33326] = { 33326, 1 },
	[33357] = { 33357, 1 },
	[33375] = { 33375, 1 },
	[33376] = { 33376, 1 },
	[33386] = { 33386, 1 },
	[33398] = { 33398, 1 },
	[33405] = { 29004, 2 },
	[33616] = { 29004, 3 },
	[33619] = { 29004, 4 },
	[33622] = { 32744, 2 },
	[33627] = { 32744, 3 },
	[33632] = { 32744, 4 },
	[33638] = { 32722, 2 },
	[33642] = { 32722, 3 },
	[33646] = { 32722, 4 },
	[33652] = { 29012, 2 },
	[33655] = { 29012, 3 },
	[33658] = { 29012, 4 },
	[33662] = { 32719, 2 },
	[33665] = { 32719, 3 },
	[33668] = { 32719, 4 },
	[33671] = { 32715, 2 },
	[33675] = { 32715, 3 },
	[33679] = { 32715, 4 },
	[33687] = { 31837, 2 },
	[33693] = { 31837, 3 },
	[33697] = { 31837, 4 },
	[33702] = { 32792, 2 },
	[33708] = { 32792, 3 },
	[33715] = { 32792, 4 },
	[33721] = { 32785, 2 },
	[33726] = { 32785, 3 },
	[33732] = { 32785, 4 },
	[33741] = { 21007, 2 },
	[33742] = { 21007, 3 },
	[33743] = { 21007, 4 },
	[33745] = { 21014, 2 },
	[33747] = { 21014, 3 },
	[33749] = { 21014, 4 },
	[33753] = { 21017, 2 },
	[33757] = { 21017, 3 },
	[33759] = { 21017, 4 },
	[33768] = { 29059, 2 },
	[33773] = { 29059, 3 },
	[33778] = { 29059, 4 },
	[33783] = { 20779, 2 },
	[33790] = { 20779, 3 },
	[33797] = { 20779, 4 },
	[33804] = { 32710, 2 },
	[33810] = { 32710, 3 },
	[33816] = { 32710, 4 },
	[33835] = { 17874, 2 },
	[33838] = { 17874, 3 },
	[33841] = { 17874, 4 },
	[33844] = { 17878, 2 },
	[33848] = { 17878, 3 },
	[33852] = { 17878, 4 },
	[33862] = { 29071, 2 },
	[33864] = { 29071, 3 },
	[33866] = { 29071, 4 },
	[33868] = { 29224, 2 },
	[33870] = { 29224, 3 },
	[33872] = { 29224, 4 },
	[33875] = { 32673, 2 },
	[33878] = { 32673, 3 },
	[33881] = { 32673, 4 },
	[33888] = { 29037, 2 },
	[33893] = { 29037, 3 },
	[33898] = { 29037, 4 },
	[33903] = { 32685, 2 },
	[33912] = { 32685, 3 },
	[33921] = { 32685, 4 },
	[33930] = { 32678, 2 },
	[33937] = { 32678, 3 },
	[33944] = { 32678, 4 },
	[33955] = { 28988, 2 },
	[33959] = { 28988, 3 },
	[33963] = { 28988, 4 },
	[33967] = { 32958, 2 },
	[33977] = { 32958, 3 },
	[33987] = { 32958, 4 },
	[34009] = { 32947, 2 },
	[34015] = { 32947, 3 },
	[34021] = { 32947, 4 },
	[34027] = { 20917, 2 },
	[34029] = { 20917, 3 },
	[34031] = { 20917, 4 },
	[34033] = { 20944, 2 },
	[34036] = { 20944, 3 },
	[34039] = { 20944, 4 },
	[34042] = { 20930, 2 },
	[34045] = { 20930, 3 },
	[34048] = { 20930, 4 },
	[34051] = { 28967, 2 },
	[34056] = { 28967, 3 },
	[34061] = { 28967, 4 },
	[34066] = { 32853, 2 },
	[34073] = { 32853, 3 },
	[34080] = { 32853, 4 },
	[34088] = { 32881, 2 },
	[34094] = { 32881, 3 },
	[34100] = { 32881, 4 },
	[34721] = { 34721, 1 },
	[34727] = { 34727, 1 },
	[34835] = { 34835, 1 },
	[34838] = { 34838, 1 },
	[34843] = { 34843, 1 },
	[34851] = { 34851, 1 },
	[35414] = { 35414, 1 },
	[35419] = { 35419, 1 },
	[35434] = { 35434, 1 },
	[35441] = { 35441, 1 },
	[35460] = { 35460, 1 },
	[35508] = { 35508, 1 },
	[35580] = { 33386, 2 },
	[35582] = { 33386, 3 },
	[35584] = { 33386, 4 },
	[35586] = { 34843, 2 },
	[35588] = { 34843, 3 },
	[35590] = { 34843, 4 },
	[35592] = { 34851, 2 },
	[35594] = { 34851, 3 },
	[35596] = { 34851, 4 },
	[35713] = { 35713, 1 },
	[35721] = { 35721, 1 },
	[35737] = { 35737, 1 },
	[35750] = { 35750, 1 },
	[35762] = { 35762, 1 },
	[35864] = { 18342, 2 },
	[35868] = { 18342, 3 },
	[35871] = { 18342, 4 },
	[35874] = { 25493, 2 },
	[35878] = { 25493, 3 },
	[35882] = { 25493, 4 },
	[35886] = { 25484, 2 },
	[35892] = { 25484, 3 },
	[35898] = { 25484, 4 },
	[35907] = { 33375, 2 },
	[35908] = { 33375, 3 },
	[35909] = { 33375, 4 },
	[35910] = { 35414, 2 },
	[35913] = { 35414, 3 },
	[35916] = { 35414, 4 },
	[35920] = { 35419, 2 },
	[35922] = { 35419, 3 },
	[35924] = { 35419, 4 },
	[35927] = { 33291, 2 },
	[35929] = { 33291, 3 },
	[35931] = { 33291, 4 },
	[35933] = { 34838, 2 },
	[35937] = { 34838, 3 },
	[35941] = { 34838, 4 },
	[35945] = { 34835, 2 },
	[35947] = { 34835, 3 },
	[35949] = { 34835, 4 },
	[36028] = { 36028, 1 },
	[36049] = { 36049, 1 },
	[36098] = { 33308, 2 },
	[36104] = { 33308, 3 },
	[36109] = { 33308, 4 },
	[36118] = { 34721, 2 },
	[36124] = { 34721, 3 },
	[36129] = { 34721, 4 },
	[36134] = { 34727, 2 },
	[36139] = { 34727, 3 },
	[36144] = { 34727, 4 },
	[36154] = { 25091, 2 },
	[36160] = { 25091, 3 },
	[36166] = { 25091, 4 },
	[36172] = { 35508, 2 },
	[36179] = { 35508, 3 },
	[36186] = { 35508, 4 },
	[36193] = { 35460, 2 },
	[36200] = { 35460, 3 },
	[36207] = { 35460, 4 },
	[36217] = { 25255, 2 },
	[36220] = { 25255, 3 },
	[36223] = { 25255, 4 },
	[36226] = { 25260, 2 },
	[36230] = { 25260, 3 },
	[36234] = { 25260, 4 },
	[36238] = { 25267, 2 },
	[36241] = { 25267, 3 },
	[36244] = { 25267, 4 },
	[36267] = { 33211, 2 },
	[36271] = { 33211, 3 },
	[36273] = { 35434, 2 },
	[36278] = { 35434, 3 },
	[36283] = { 35434, 4 },
	[36288] = { 35441, 2 },
	[36293] = { 35441, 3 },
	[36298] = { 35441, 4 },
	[36313] = { 33211, 4 },
	[36329] = { 25375, 2 },
	[36333] = { 25375, 3 },
	[36337] = { 25375, 4 },
	[36341] = { 25377, 2 },
	[36346] = { 25377, 3 },
	[36351] = { 25377, 4 },
	[36356] = { 25380, 2 },
	[36362] = { 25380, 3 },
	[36368] = { 25380, 4 },
	[36485] = { 36485, 1 },
	[36493] = { 36493, 1 },
	[36508] = { 36508, 1 },
	[36514] = { 36514, 1 },
	[36891] = { 36891, 1 },
	[36901] = { 36901, 1 },
	[36908] = { 36908, 1 },
	[36935] = { 36935, 1 },
	[36943] = { 36943, 1 },
	[36957] = { 36957, 1 },
	[36967] = { 36967, 1 },
	[36968] = { 36968, 1 },
	[37232] = { 37232, 1 },
	[37243] = { 37243, 1 },
	[37470] = { 37470, 1 },
	[37475] = { 37475, 1 },
	[37510] = { 33398, 2 },
	[37514] = { 33398, 3 },
	[37518] = { 33398, 4 },
	[37522] = { 36508, 2 },
	[37527] = { 36508, 3 },
	[37532] = { 36508, 4 },
	[37537] = { 36514, 2 },
	[37541] = { 36514, 3 },
	[37545] = { 36514, 4 },
	[37587] = { 33357, 2 },
	[37595] = { 33357, 3 },
	[37603] = { 33357, 4 },
	[37613] = { 36968, 2 },
	[37622] = { 36968, 3 },
	[37631] = { 36968, 4 },
	[37640] = { 36967, 2 },
	[37649] = { 36967, 3 },
	[37658] = { 36967, 4 },
	[37686] = { 25411, 2 },
	[37691] = { 25411, 3 },
	[37696] = { 25411, 4 },
	[37701] = { 36485, 2 },
	[37707] = { 36485, 3 },
	[37713] = { 36485, 4 },
	[37734] = { 36493, 2 },
	[37739] = { 36493, 3 },
	[37744] = { 36493, 4 },
	[37751] = { 33195, 2 },
	[37757] = { 33195, 3 },
	[37764] = { 33195, 4 },
	[37788] = { 36049, 2 },
	[37792] = { 36049, 3 },
	[37796] = { 36049, 4 },
	[37800] = { 36028, 2 },
	[37808] = { 36028, 3 },
	[37816] = { 36028, 4 },
	[37850] = { 33326, 2 },
	[37857] = { 33326, 3 },
	[37864] = { 33326, 4 },
	[37871] = { 36943, 2 },
	[37879] = { 36943, 3 },
	[37887] = { 36943, 4 },
	[37895] = { 36957, 2 },
	[37904] = { 36957, 3 },
	[37913] = { 36957, 4 },
	[37922] = { 33316, 2 },
	[37925] = { 33316, 3 },
	[37928] = { 33316, 4 },
	[37931] = { 36901, 2 },
	[37934] = { 36901, 3 },
	[37937] = { 36901, 4 },
	[37940] = { 36891, 2 },
	[37945] = { 36891, 3 },
	[37950] = { 36891, 4 },
	[37955] = { 33319, 2 },
	[37966] = { 33319, 3 },
	[37977] = { 33319, 4 },
	[37989] = { 36908, 2 },
	[38002] = { 36908, 3 },
	[38015] = { 36908, 4 },
	[38028] = { 36935, 2 },
	[38039] = { 36935, 3 },
	[38050] = { 36935, 4 },
	[38061] = { 25352, 2 },
	[38063] = { 25352, 3 },
	[38065] = { 25352, 4 },
	[38067] = { 37470, 2 },
	[38071] = { 37470, 3 },
	[38075] = { 37470, 4 },
	[38080] = { 37475, 2 },
	[38088] = { 37475, 3 },
	[38096] = { 37475, 4 },
	[38250] = { 38250, 1 },
	[38256] = { 38256, 1 },
	[38264] = { 38264, 1 },
	[38268] = { 38268, 1 },
	[38312] = { 38312, 1 },
	[38317] = { 38317, 1 },
	[38401] = { 38401, 1 },
	[38405] = { 38405, 1 },
	[38452] = { 38452, 1 },
	[38455] = { 38455, 1 },
	[38563] = { 38563, 1 },
	[38566] = { 38566, 1 },
	[38570] = { 38570, 1 },
	[38571] = { 38571, 1 },
	[38573] = { 38573, 1 },
	[38645] = { 38645, 1 },
	[38660] = { 38660, 1 },
	[38669] = { 38669, 1 },
	[38672] = { 38672, 1 },
	[38685] = { 38685, 1 },
	[38687] = { 38687, 1 },
	[38689] = { 38689, 1 },
	[38695] = { 38695, 1 },
	[38701] = { 38701, 1 },
	[38705] = { 38705, 1 },
	[38745] = { 38745, 1 },
	[38754] = { 38754, 1 },
	[38778] = { 38778, 1 },
	[38788] = { 38788, 1 },
	[38794] = { 38794, 1 },
	[38802] = { 38802, 1 },
	[38807] = { 38807, 1 },
	[38814] = { 38814, 1 },
	[38819] = { 38819, 1 },
	[38823] = { 38823, 1 },
	[38839] = { 38839, 1 },
	[38845] = { 38845, 1 },
	[38846] = { 38846, 1 },
	[38857] = { 38857, 1 },
	[38861] = { 38861, 1 },
	[38891] = { 38891, 1 },
	[38901] = { 38901, 1 },
	[38906] = { 38906, 1 },
	[38910] = { 38910, 1 },
	[38914] = { 38914, 1 },
	[38931] = { 41937, 2 },
	[38932] = { 41926, 2 },
	[38937] = { 38937, 1 },
	[38949] = { 41902, 2 },
	[38956] = { 41881, 2 },
	[38963] = { 41815, 2 },
	[38965] = { 41824, 2 },
	[38984] = { 38984, 1 },
	[39011] = { 39011, 1 },
	[39052] = { 39052, 1 },
	[39075] = { 39075, 1 },
	[39076] = { 39076, 1 },
	[39089] = { 39089, 1 },
	[39095] = { 39095, 1 },
	[39104] = { 42128, 2 },
	[39105] = { 42119, 2 },
	[39113] = { 42157, 2 },
	[39114] = { 42179, 2 },
	[39143] = { 39143, 1 },
	[39161] = { 39161, 1 },
	[39182] = { 39182, 1 },
	[39186] = { 39186, 1 },
	[39192] = { 39192, 1 },
	[39195] = { 39195, 1 },
	[39197] = { 39197, 1 },
	[39205] = { 39205, 1 },
	[39270] = { 39270, 1 },
	[39298] = { 39298, 1 },
	[39369] = { 39369, 1 },
	[39425] = { 39425, 1 },
	[39475] = { 39475, 1 },
	[39489] = { 39489, 1 },
	[39742] = { 20919, 2 },
	[39744] = { 20919, 3 },
	[39746] = { 20919, 4 },
	[39748] = { 38745, 2 },
	[39751] = { 38745, 3 },
	[39754] = { 38745, 4 },
	[39757] = { 38754, 2 },
	[39763] = { 38754, 3 },
	[39769] = { 38754, 4 },
	[39785] = { 28448, 2 },
	[39789] = { 28448, 3 },
	[39793] = { 28448, 4 },
	[39797] = { 38788, 2 },
	[39802] = { 38788, 3 },
	[39807] = { 38788, 4 },
	[39812] = { 38778, 2 },
	[39817] = { 38778, 3 },
	[39822] = { 38778, 4 },
	[39868] = { 28297, 2 },
	[39871] = { 28297, 3 },
	[39881] = { 28297, 4 },
	[39884] = { 38794, 2 },
	[39888] = { 38794, 3 },
	[39892] = { 38794, 4 },
	[39896] = { 38802, 2 },
	[39900] = { 38802, 3 },
	[39904] = { 38802, 4 },
	[39919] = { 28302, 2 },
	[39925] = { 28302, 3 },
	[39928] = { 28302, 4 },
	[39932] = { 38823, 2 },
	[39937] = { 38823, 3 },
	[39942] = { 38823, 4 },
	[39948] = { 38819, 2 },
	[39952] = { 38819, 3 },
	[39957] = { 38819, 4 },
	[39962] = { 28279, 2 },
	[39965] = { 28279, 3 },
	[39968] = { 28279, 4 },
	[39976] = { 38814, 2 },
	[39980] = { 38814, 3 },
	[39984] = { 38814, 4 },
	[40000] = { 38807, 2 },
	[40004] = { 38807, 3 },
	[40008] = { 38807, 4 },
	[40058] = { 40058, 1 },
	[40060] = { 40060, 1 },
	[40076] = { 40076, 1 },
	[40079] = { 40079, 1 },
	[40094] = { 40094, 1 },
	[40103] = { 40103, 1 },
	[40109] = { 40109, 1 },
	[40116] = { 40116, 1 },
	[40126] = { 40126, 1 },
	[40130] = { 40130, 1 },
	[40158] = { 40158, 1 },
	[40161] = { 40161, 1 },
	[40169] = { 40169, 1 },
	[40181] = { 40181, 1 },
	[40194] = { 40194, 1 },
	[40195] = { 40195, 1 },
	[40211] = { 40211, 1 },
	[40215] = { 40215, 1 },
	[40220] = { 40220, 1 },
	[40223] = { 40223, 1 },
	[40226] = { 40226, 1 },
	[40229] = { 40229, 1 },
	[40232] = { 40232, 1 },
	[40234] = { 40234, 1 },
	[40237] = { 40237, 1 },
	[40239] = { 40239, 1 },
	[40242] = { 40242, 1 },
	[40255] = { 40255, 1 },
	[40300] = { 40300, 1 },
	[40317] = { 40317, 1 },
	[40328] = { 40328, 1 },
	[40336] = { 40336, 1 },
	[40372] = { 40372, 1 },
	[40382] = { 40382, 1 },
	[40414] = { 40414, 1 },
	[40420] = { 40420, 1 },
	[40441] = { 40441, 1 },
	[40445] = { 40445, 1 },
	[40452] = { 40452, 1 },
	[40457] = { 40457, 1 },
	[40465] = { 40465, 1 },
	[40470] = { 40470, 1 },
	[40478] = { 40478, 1 },
	[40483] = { 40483, 1 },
	[40489] = { 40489, 1 },
	[40493] = { 40493, 1 },
	[40578] = { 28607, 2 },
	[40580] = { 28607, 3 },
	[40582] = { 28607, 4 },
	[40584] = { 38857, 2 },
	[40587] = { 38857, 3 },
	[40590] = { 38857, 4 },
	[40593] = { 38846, 2 },
	[40596] = { 38846, 3 },
	[40599] = { 38846, 4 },
	[40604] = { 21157, 2 },
	[40607] = { 21157, 3 },
	[40610] = { 21157, 4 },
	[40613] = { 38914, 2 },
	[40616] = { 38914, 3 },
	[40619] = { 38914, 4 },
	[40622] = { 38910, 2 },
	[40625] = { 38910, 3 },
	[40628] = { 38910, 4 },
	[40631] = { 28613, 2 },
	[40632] = { 28613, 3 },
	[40633] = { 28613, 4 },
	[40634] = { 38901, 2 },
	[40638] = { 38901, 3 },
	[40642] = { 38901, 4 },
	[40646] = { 38906, 2 },
	[40649] = { 38906, 3 },
	[40651] = { 38906, 4 },
	[40658] = { 28379, 2 },
	[40661] = { 28379, 3 },
	[40664] = { 28379, 4 },
	[40667] = { 38839, 2 },
	[40671] = { 38839, 3 },
	[40675] = { 38839, 4 },
	[40679] = { 38845, 2 },
	[40683] = { 38845, 3 },
	[40687] = { 38845, 4 },
	[40708] = { 28591, 2 },
	[40711] = { 28591, 3 },
	[40714] = { 28591, 4 },
	[40717] = { 38891, 2 },
	[40724] = { 38891, 3 },
	[40731] = { 38891, 4 },
	[40738] = { 38861, 2 },
	[40741] = { 38861, 3 },
	[40744] = { 38861, 4 },
	[40759] = { 31271, 2 },
	[40762] = { 31271, 3 },
	[40765] = { 31271, 4 },
	[40769] = { 38705, 2 },
	[40773] = { 38705, 3 },
	[40777] = { 38705, 4 },
	[40781] = { 38701, 2 },
	[40785] = { 38701, 3 },
	[40789] = { 38701, 4 },
	[40796] = { 28869, 2 },
	[40801] = { 28869, 3 },
	[40806] = { 28869, 4 },
	[40813] = { 38645, 2 },
	[40818] = { 38645, 3 },
	[40823] = { 38645, 4 },
	[40830] = { 38660, 2 },
	[40836] = { 38660, 3 },
	[40842] = { 38660, 4 },
	[40852] = { 28879, 2 },
	[40855] = { 28879, 3 },
	[40858] = { 28879, 4 },
	[40861] = { 38672, 2 },
	[40865] = { 38672, 3 },
	[40869] = { 38672, 4 },
	[40873] = { 38669, 2 },
	[40878] = { 38669, 3 },
	[40883] = { 38669, 4 },
	[40890] = { 28882, 2 },
	[40891] = { 28882, 3 },
	[40892] = { 28882, 4 },
	[40893] = { 38685, 2 },
	[40895] = { 38685, 3 },
	[40897] = { 38685, 4 },
	[40899] = { 38687, 2 },
	[40903] = { 38687, 3 },
	[40907] = { 38687, 4 },
	[40911] = { 28876, 2 },
	[40914] = { 28876, 3 },
	[40917] = { 28876, 4 },
	[40920] = { 38689, 2 },
	[40926] = { 38689, 3 },
	[40932] = { 38689, 4 },
	[40938] = { 38695, 2 },
	[40941] = { 38695, 3 },
	[40944] = { 38695, 4 },
	[40947] = { 29091, 2 },
	[40956] = { 29091, 3 },
	[40964] = { 29091, 4 },
	[40977] = { 38984, 2 },
	[40995] = { 38984, 3 },
	[41006] = { 38984, 4 },
	[41029] = { 38937, 2 },
	[41038] = { 38937, 3 },
	[41047] = { 38937, 4 },
	[41078] = { 29552, 2 },
	[41080] = { 29552, 3 },
	[41082] = { 29552, 4 },
	[41085] = { 39205, 2 },
	[41088] = { 39205, 3 },
	[41091] = { 39205, 4 },
	[41097] = { 39197, 2 },
	[41100] = { 39197, 3 },
	[41103] = { 39197, 4 },
	[41106] = { 29338, 2 },
	[41107] = { 29338, 3 },
	[41108] = { 29338, 4 },
	[41109] = { 39186, 2 },
	[41111] = { 39186, 3 },
	[41113] = { 39186, 4 },
	[41115] = { 39182, 2 },
	[41118] = { 39182, 3 },
	[41121] = { 39182, 4 },
	[41124] = { 29556, 2 },
	[41125] = { 29556, 3 },
	[41126] = { 29556, 4 },
	[41127] = { 39195, 2 },
	[41129] = { 39195, 3 },
	[41131] = { 39195, 4 },
	[41133] = { 39192, 2 },
	[41135] = { 39192, 3 },
	[41137] = { 39192, 4 },
	[41139] = { 37243, 2 },
	[41145] = { 37243, 3 },
	[41151] = { 37243, 4 },
	[41157] = { 40103, 2 },
	[41163] = { 40103, 3 },
	[41169] = { 40103, 4 },
	[41175] = { 40094, 2 },
	[41182] = { 40094, 3 },
	[41189] = { 40094, 4 },
	[41199] = { 31531, 2 },
	[41203] = { 31531, 3 },
	[41207] = { 31531, 4 },
	[41211] = { 40109, 2 },
	[41220] = { 40109, 3 },
	[41225] = { 40109, 4 },
	[41230] = { 40116, 2 },
	[41234] = { 40116, 3 },
	[41239] = { 40116, 4 },
	[41244] = { 28385, 2 },
	[41246] = { 28385, 3 },
	[41248] = { 28385, 4 },
	[41251] = { 40058, 2 },
	[41253] = { 40058, 3 },
	[41255] = { 40058, 4 },
	[41257] = { 40060, 2 },
	[41261] = { 40060, 3 },
	[41265] = { 40060, 4 },
	[41269] = { 28536, 2 },
	[41270] = { 28536, 3 },
	[41271] = { 28536, 4 },
	[41272] = { 40076, 2 },
	[41274] = { 40076, 3 },
	[41276] = { 40076, 4 },
	[41278] = { 40079, 2 },
	[41283] = { 40079, 3 },
	[41288] = { 40079, 4 },
	[41294] = { 40130, 2 },
	[41298] = { 40130, 3 },
	[41302] = { 40130, 4 },
	[41306] = { 37232, 2 },
	[41308] = { 37232, 3 },
	[41310] = { 37232, 4 },
	[41312] = { 40126, 2 },
	[41316] = { 40126, 3 },
	[41320] = { 40126, 4 },
	[41349] = { 28727, 2 },
	[41350] = { 28727, 3 },
	[41351] = { 28727, 4 },
	[41352] = { 38312, 2 },
	[41355] = { 38312, 3 },
	[41358] = { 38312, 4 },
	[41370] = { 38317, 2 },
	[41375] = { 38317, 3 },
	[41380] = { 38317, 4 },
	[41387] = { 28304, 2 },
	[41391] = { 28304, 3 },
	[41394] = { 28304, 4 },
	[41397] = { 38268, 2 },
	[41398] = { 38268, 3 },
	[41403] = { 38268, 4 },
	[41406] = { 38264, 2 },
	[41410] = { 38264, 3 },
	[41414] = { 38264, 4 },
	[41429] = { 28365, 2 },
	[41432] = { 28365, 3 },
	[41435] = { 28365, 4 },
	[41438] = { 38455, 2 },
	[41443] = { 38455, 3 },
	[41448] = { 38455, 4 },
	[41453] = { 38452, 2 },
	[41456] = { 38452, 3 },
	[41459] = { 38452, 4 },
	[41473] = { 28306, 2 },
	[41475] = { 28306, 3 },
	[41477] = { 28306, 4 },
	[41479] = { 38256, 2 },
	[41483] = { 38256, 3 },
	[41487] = { 38256, 4 },
	[41491] = { 38250, 2 },
	[41494] = { 38250, 3 },
	[41497] = { 38250, 4 },
	[41506] = { 28719, 2 },
	[41509] = { 28719, 3 },
	[41512] = { 28719, 4 },
	[41518] = { 38401, 2 },
	[41522] = { 38401, 3 },
	[41526] = { 38401, 4 },
	[41530] = { 38405, 2 },
	[41534] = { 38405, 3 },
	[41538] = { 38405, 4 },
	[41544] = { 29173, 2 },
	[41546] = { 29173, 3 },
	[41548] = { 29173, 4 },
	[41550] = { 39089, 2 },
	[41553] = { 39089, 3 },
	[41556] = { 39089, 4 },
	[41559] = { 39095, 2 },
	[41563] = { 39095, 3 },
	[41567] = { 39095, 4 },
	[41627] = { 28858, 2 },
	[41642] = { 28858, 3 },
	[41658] = { 28858, 4 },
	[41673] = { 39052, 2 },
	[41691] = { 39052, 3 },
	[41711] = { 39052, 4 },
	[41738] = { 39011, 2 },
	[41754] = { 39011, 3 },
	[41769] = { 39011, 4 },
	[41807] = { 32986, 2 },
	[41808] = { 32986, 3 },
	[41809] = { 32986, 4 },
	[41813] = { 41815, 3 },
	[41814] = { 41815, 4 },
	[41815] = { 41815, 1 },
	[41822] = { 41824, 3 },
	[41823] = { 41824, 4 },
	[41824] = { 41824, 1 },
	[41864] = { 32893, 2 },
	[41865] = { 32893, 3 },
	[41866] = { 32893, 4 },
	[41879] = { 41881, 3 },
	[41880] = { 41881, 4 },
	[41881] = { 41881, 1 },
	[41900] = { 41902, 3 },
	[41901] = { 41902, 4 },
	[41902] = { 41902, 1 },
	[41918] = { 32624, 2 },
	[41919] = { 32624, 3 },
	[41920] = { 32624, 4 },
	[41924] = { 41926, 3 },
	[41925] = { 41926, 4 },
	[41926] = { 41926, 1 },
	[41933] = { 41937, 3 },
	[41936] = { 41937, 4 },
	[41937] = { 41937, 1 },
	[41958] = { 41958, 1 },
	[41967] = { 41967, 1 },
	[41990] = { 41990, 1 },
	[42012] = { 42012, 1 },
	[42028] = { 42028, 1 },
	[42038] = { 42038, 1 },
	[42056] = { 42056, 1 },
	[42060] = { 42060, 1 },
	[42108] = { 32632, 2 },
	[42109] = { 32632, 3 },
	[42110] = { 32632, 4 },
	[42117] = { 42119, 3 },
	[42118] = { 42119, 4 },
	[42119] = { 42119, 1 },
	[42126] = { 42128, 3 },
	[42127] = { 42128, 4 },
	[42128] = { 42128, 1 },
	[42138] = { 42138, 1 },
	[42143] = { 32633, 2 },
	[42144] = { 32633, 3 },
	[42145] = { 32633, 4 },
	[42155] = { 42157, 3 },
	[42156] = { 42157, 4 },
	[42157] = { 42157, 1 },
	[42176] = { 42176, 1 },
	[42177] = { 42179, 3 },
	[42178] = { 42179, 4 },
	[42179] = { 42179, 1 },
	[42199] = { 28567, 2 },
	[42203] = { 28567, 3 },
	[42207] = { 28567, 4 },
	[42212] = { 40457, 2 },
	[42218] = { 40457, 3 },
	[42224] = { 40457, 4 },
	[42230] = { 40452, 2 },
	[42235] = { 40452, 3 },
	[42240] = { 40452, 4 },
	[42247] = { 31642, 2 },
	[42249] = { 31642, 3 },
	[42251] = { 31642, 4 },
	[42253] = { 40445, 2 },
	[42258] = { 40445, 3 },
	[42263] = { 40445, 4 },
	[42268] = { 40441, 2 },
	[42273] = { 40441, 3 },
	[42278] = { 40441, 4 },
	[42293] = { 31632, 2 },
	[42299] = { 31632, 3 },
	[42305] = { 31632, 4 },
	[42311] = { 40470, 2 },
	[42319] = { 40470, 3 },
	[42327] = { 40470, 4 },
	[42335] = { 40465, 2 },
	[42342] = { 40465, 3 },
	[42349] = { 40465, 4 },
	[42356] = { 32455, 2 },
	[42357] = { 32455, 3 },
	[42358] = { 32455, 4 },
	[42365] = { 39075, 2 },
	[42366] = { 39075, 3 },
	[42367] = { 39075, 4 },
	[42377] = { 39076, 1 },
	[42378] = { 39076, 2 },
	[42379] = { 39076, 3 },
	[42410] = { 30920, 2 },
	[42414] = { 30920, 3 },
	[42418] = { 30920, 4 },
	[42422] = { 40478, 2 },
	[42426] = { 40478, 3 },
	[42430] = { 40478, 4 },
	[42443] = { 40483, 2 },
	[42449] = { 40483, 3 },
	[42455] = { 40483, 4 },
	[42461] = { 16536, 2 },
	[42464] = { 16536, 3 },
	[42467] = { 16536, 4 },
	[42470] = { 40489, 2 },
	[42474] = { 40489, 3 },
	[42478] = { 40489, 4 },
	[42482] = { 40493, 2 },
	[42487] = { 40493, 3 },
	[42492] = { 40493, 4 },
	[42501] = { 35737, 2 },
	[42505] = { 35737, 3 },
	[42509] = { 35737, 4 },
	[42515] = { 40181, 2 },
	[42522] = { 40181, 3 },
	[42529] = { 40181, 4 },
	[42536] = { 40169, 2 },
	[42542] = { 40169, 3 },
	[42548] = { 40169, 4 },
	[42554] = { 35713, 2 },
	[42560] = { 35713, 3 },
	[42566] = { 35713, 4 },
	[42575] = { 40161, 2 },
	[42581] = { 40161, 3 },
	[42586] = { 40161, 4 },
	[42592] = { 40158, 2 },
	[42595] = { 40158, 3 },
	[42598] = { 40158, 4 },
	[42602] = { 35762, 2 },
	[42606] = { 35762, 3 },
	[42610] = { 35762, 4 },
	[42614] = { 40194, 2 },
	[42619] = { 40194, 3 },
	[42624] = { 40194, 4 },
	[42629] = { 40195, 2 },
	[42635] = { 40195, 3 },
	[42641] = { 40195, 4 },
	[42647] = { 35721, 2 },
	[42651] = { 35721, 3 },
	[42655] = { 35721, 4 },
	[42659] = { 40300, 2 },
	[42665] = { 40300, 3 },
	[42671] = { 40300, 4 },
	[42677] = { 40336, 2 },
	[42687] = { 40336, 3 },
	[42696] = { 40336, 4 },
	[42706] = { 35750, 2 },
	[42713] = { 35750, 3 },
	[42720] = { 35750, 4 },
	[42727] = { 40382, 2 },
	[42737] = { 40382, 3 },
	[42747] = { 40382, 4 },
	[42757] = { 40372, 2 },
	[42764] = { 40372, 3 },
	[42771] = { 40372, 4 },
	[42949] = { 28800, 2 },
	[42953] = { 28800, 3 },
	[42957] = { 28800, 4 },
	[42961] = { 39143, 2 },
	[42968] = { 39143, 3 },
	[42975] = { 39143, 4 },
	[42982] = { 39161, 2 },
	[42989] = { 39161, 3 },
	[42996] = { 39161, 4 },
	[43050] = { 26768, 2 },
	[43053] = { 26768, 3 },
	[43056] = { 26768, 4 },
	[43059] = { 40328, 2 },
	[43063] = { 40328, 3 },
	[43067] = { 40328, 4 },
	[43071] = { 40317, 2 },
	[43077] = { 40317, 3 },
	[43083] = { 40317, 4 },
	[43089] = { 39270, 2 },
	[43091] = { 39270, 3 },
	[43093] = { 39270, 4 },
	[43095] = { 40420, 2 },
	[43097] = { 40420, 3 },
	[43099] = { 40420, 4 },
	[43101] = { 40414, 2 },
	[43105] = { 40414, 3 },
	[43109] = { 40414, 4 },
	[43241] = { 39489, 2 },
	[43246] = { 39489, 3 },
	[43251] = { 39489, 4 },
	[43256] = { 41967, 2 },
	[43261] = { 41967, 3 },
	[43266] = { 41967, 4 },
	[43271] = { 41958, 2 },
	[43277] = { 41958, 3 },
	[43287] = { 41958, 4 },
	[43304] = { 39369, 2 },
	[43307] = { 39369, 3 },
	[43310] = { 39369, 4 },
	[43313] = { 42138, 2 },
	[43318] = { 42138, 3 },
	[43323] = { 42138, 4 },
	[43328] = { 42176, 2 },
	[43331] = { 42176, 3 },
	[43334] = { 42176, 4 },
	[43353] = { 39475, 2 },
	[43358] = { 39475, 3 },
	[43363] = { 39475, 4 },
	[43368] = { 42056, 2 },
	[43373] = { 42056, 3 },
	[43378] = { 42056, 4 },
	[43383] = { 42060, 2 },
	[43388] = { 42060, 3 },
	[43393] = { 42060, 4 },
	[43400] = { 39298, 2 },
	[43403] = { 39298, 3 },
	[43406] = { 39298, 4 },
	[43409] = { 42028, 2 },
	[43412] = { 42028, 3 },
	[43415] = { 42028, 4 },
	[43439] = { 42038, 2 },
	[43443] = { 42038, 3 },
	[43447] = { 42038, 4 },
	[43469] = { 42012, 2 },
	[43473] = { 42012, 3 },
	[43477] = { 42012, 4 },
	[43481] = { 41990, 2 },
	[43485] = { 41990, 3 },
	[43489] = { 41990, 4 },
	[43533] = { 39425, 2 },
	[43537] = { 39425, 3 },
	[43541] = { 39425, 4 },
	[43714] = { 43714, 1 },
	[46324] = { 46324, 1 },
	[46331] = { 46331, 1 },
	[46340] = { 46340, 1 },
	[46348] = { 46348, 1 },
	[46356] = { 46356, 1 },
	[46363] = { 33376, 2 },
	[46374] = { 33376, 3 },
	[46385] = { 33376, 4 },
	[46396] = { 40255, 2 },
	[46408] = { 40255, 3 },
	[46420] = { 40255, 4 },
	[46440] = { 40242, 2 },
	[46453] = { 40242, 3 },
	[46466] = { 40242, 4 },
	[46484] = { 38566, 2 },
	[46488] = { 38566, 3 },
	[46492] = { 38566, 4 },
	[46497] = { 40211, 2 },
	[46501] = { 40211, 3 },
	[46505] = { 40211, 4 },
	[46509] = { 40215, 2 },
	[46514] = { 40215, 3 },
	[46519] = { 40215, 4 },
	[46525] = { 38563, 2 },
	[46527] = { 38563, 3 },
	[46529] = { 38563, 4 },
	[46531] = { 40223, 2 },
	[46534] = { 40223, 3 },
	[46537] = { 40223, 4 },
	[46540] = { 40220, 2 },
	[46543] = { 40220, 3 },
	[46546] = { 40220, 4 },
	[46607] = { 38573, 2 },
	[46608] = { 38573, 3 },
	[46609] = { 38573, 4 },
	[46610] = { 40237, 2 },
	[46612] = { 40237, 3 },
	[46614] = { 40237, 4 },
	[46616] = { 40239, 2 },
	[46619] = { 40239, 3 },
	[46622] = { 40239, 4 },
	[46626] = { 38571, 2 },
	[46628] = { 38571, 3 },
	[46630] = { 38571, 4 },
	[46632] = { 40232, 2 },
	[46634] = { 40232, 3 },
	[46636] = { 40232, 4 },
	[46638] = { 40234, 2 },
	[46641] = { 40234, 3 },
	[46644] = { 40234, 4 },
	[46649] = { 38570, 2 },
	[46651] = { 38570, 3 },
	[46653] = { 38570, 4 },
	[46655] = { 40229, 2 },
	[46658] = { 40229, 3 },
	[46661] = { 40229, 4 },
	[46664] = { 40226, 2 },
	[46667] = { 40226, 3 },
	[46670] = { 40226, 4 },
	[47548] = { 43714, 2 },
	[47550] = { 43714, 3 },
	[47552] = { 43714, 4 },
	[47554] = { 46331, 2 },
	[47557] = { 46331, 3 },
	[47560] = { 46331, 4 },
	[47565] = { 46324, 2 },
	[47567] = { 46324, 3 },
	[47569] = { 46324, 4 },
	[48950] = { 46340, 2 },
	[48953] = { 46340, 3 },
	[48956] = { 46340, 4 },
	[48959] = { 46348, 2 },
	[48965] = { 46348, 3 },
	[48971] = { 46348, 4 },
	[48977] = { 46356, 2 },
	[48984] = { 46356, 3 },
	[48991] = { 46356, 4 },
	[58310] = { 58310, 1 },
	[58314] = { 58310, 2 },
	[58315] = { 58310, 3 },
	[58316] = { 58310, 4 },
	[58317] = { 58323, 2 },
	[58319] = { 58323, 3 },
	[58321] = { 58323, 4 },
	[58323] = { 58323, 1 },
	[58325] = { 58334, 2 },
	[58329] = { 58334, 3 },
	[58332] = { 58334, 4 },
	[58334] = { 58334, 1 },
	[58405] = { 58405, 1 },
	[58736] = { 58405, 2 },
	[58738] = { 58405, 3 },
	[58740] = { 58405, 4 },
	[58742] = { 58794, 2 },
	[58786] = { 58794, 3 },
	[58790] = { 58794, 4 },
	[58794] = { 58794, 1 },
	[58798] = { 58808, 2 },
	[58802] = { 58808, 3 },
	[58805] = { 58808, 4 },
	[58808] = { 58808, 1 },
	[58855] = { 58855, 1 },
	[58857] = { 58855, 2 },
	[58859] = { 58855, 3 },
	[58862] = { 58855, 4 },
	[58864] = { 58876, 2 },
	[58870] = { 58876, 3 },
	[58873] = { 58876, 4 },
	[58876] = { 58876, 1 },
	[58879] = { 58907, 2 },
	[58901] = { 58907, 3 },
	[58904] = { 58907, 4 },
	[58907] = { 58907, 1 },
	[61487] = { 61487, 1 },
	[61489] = { 61489, 1 },
	[61491] = { 61491, 1 },
	[61500] = { 61500, 1 },
	[61503] = { 61503, 1 },
	[61505] = { 61505, 1 },
	[61507] = { 61507, 1 },
	[61511] = { 61511, 1 },
	[61519] = { 61519, 1 },
	[61524] = { 61524, 1 },
	[61529] = { 61529, 1 },
	[61536] = { 61536, 1 },
	[61902] = { 61902, 1 },
	[61919] = { 61919, 1 },
	[61927] = { 61927, 1 },
	[62090] = { 61902, 2 },
	[62096] = { 61902, 4 },
	[62099] = { 61927, 2 },
	[62103] = { 61927, 3 },
	[62107] = { 61927, 4 },
	[62111] = { 61919, 2 },
	[62114] = { 61919, 3 },
	[62117] = { 61919, 4 },
	[63029] = { 63029, 1 },
	[63044] = { 63044, 1 },
	[63046] = { 63046, 1 },
	[63054] = { 63029, 2 },
	[63056] = { 63029, 3 },
	[63058] = { 63029, 4 },
	[63060] = { 63044, 2 },
	[63063] = { 63044, 3 },
	[63066] = { 63044, 4 },
	[63069] = { 63046, 2 },
	[63072] = { 63046, 3 },
	[63075] = { 63046, 4 },
	[63236] = { 61503, 2 },
	[63238] = { 61503, 3 },
	[63240] = { 61503, 4 },
	[63243] = { 61505, 2 },
	[63245] = { 61505, 3 },
	[63247] = { 61505, 4 },
	[63249] = { 61507, 2 },
	[63252] = { 61507, 3 },
	[63255] = { 61507, 4 },
	[63278] = { 61487, 2 },
	[63281] = { 61487, 3 },
	[63284] = { 61487, 4 },
	[63287] = { 61491, 2 },
	[63290] = { 61491, 3 },
	[63293] = { 61491, 4 },
	[63296] = { 61500, 2 },
	[63299] = { 61500, 3 },
	[63302] = { 61500, 4 },
	[63308] = { 61511, 2 },
	[63313] = { 61511, 3 },
	[63318] = { 61511, 4 },
	[63323] = { 61536, 2 },
	[63329] = { 61536, 3 },
	[63335] = { 61536, 4 },
	[63341] = { 61529, 2 },
	[63346] = { 61529, 3 },
	[63351] = { 61529, 4 },
	[63356] = { 61489, 2 },
	[63363] = { 61489, 3 },
	[63370] = { 61489, 4 },
	[63377] = { 61519, 2 },
	[63384] = { 61519, 3 },
	[63391] = { 61519, 4 },
	[63399] = { 61524, 2 },
	[63407] = { 61524, 3 },
	[63415] = { 61524, 4 },
	[64176] = { 61902, 3 },
	[83216] = { 83216, 1 },
	[83229] = { 83229, 1 },
	[83238] = { 83238, 1 },
	[83272] = { 83272, 1 },
	[83292] = { 83292, 1 },
	[83310] = { 83310, 1 },
	[83465] = { 83465, 1 },
	[83552] = { 83552, 1 },
	[83600] = { 83600, 1 },
	[83619] = { 83619, 1 },
	[83642] = { 83642, 1 },
	[83850] = { 83850, 1 },
	[84434] = { 84434, 1 },
	[85132] = { 85132, 1 },
	[85179] = { 85179, 1 },
	[85187] = { 85187, 1 },
	[85257] = { 85257, 1 },
	[85451] = { 85451, 1 },
	[85532] = { 85532, 1 },
	[85536] = { 85536, 1 },
	[85539] = { 85539, 1 },
	[85552] = { 85552, 1 },
	[85564] = { 85564, 1 },
	[85578] = { 85578, 1 },
	[85804] = { 85804, 1 },
	[85807] = { 85807, 1 },
	[85840] = { 85840, 1 },
	[85845] = { 85845, 1 },
	[85850] = { 85850, 1 },
	[85851] = { 85851, 1 },
	[85854] = { 85854, 1 },
	[85855] = { 85855, 1 },
	[85858] = { 85858, 1 },
	[85859] = { 85859, 1 },
	[85862] = { 85862, 1 },
	[85863] = { 85863, 1 },
	[85982] = { 85982, 1 },
	[85983] = { 85982, 2 },
	[85984] = { 85982, 3 },
	[85985] = { 85982, 4 },
	[85986] = { 85986, 1 },
	[85987] = { 85986, 2 },
	[85988] = { 85986, 3 },
	[85989] = { 85986, 4 },
	[85990] = { 85990, 1 },
	[85991] = { 85990, 2 },
	[85992] = { 85990, 3 },
	[85993] = { 85990, 4 },
	[85995] = { 85995, 1 },
	[85996] = { 85995, 2 },
	[85997] = { 85995, 3 },
	[85998] = { 85995, 4 },
	[85999] = { 85999, 1 },
	[86000] = { 85999, 2 },
	[86001] = { 85999, 3 },
	[86002] = { 85999, 4 },
	[86003] = { 86003, 1 },
	[86004] = { 86003, 2 },
	[86005] = { 86003, 3 },
	[86006] = { 86003, 4 },
	[86009] = { 86009, 1 },
	[86012] = { 86009, 2 },
	[86013] = { 86009, 3 },
	[86015] = { 86015, 1 },
	[86016] = { 86015, 2 },
	[86017] = { 86015, 3 },
	[86019] = { 86019, 1 },
	[86020] = { 86019, 2 },
	[86021] = { 86019, 3 },
	[86023] = { 86023, 1 },
	[86024] = { 86023, 2 },
	[86025] = { 86023, 3 },
	[86026] = { 86023, 4 },
	[86027] = { 86027, 1 },
	[86028] = { 86027, 2 },
	[86029] = { 86027, 3 },
	[86030] = { 86027, 4 },
	[86031] = { 86031, 1 },
	[86032] = { 86031, 2 },
	[86033] = { 86031, 3 },
	[86034] = { 86031, 4 },
	[86037] = { 86037, 1 },
	[86038] = { 86037, 2 },
	[86039] = { 86037, 3 },
	[86040] = { 86037, 4 },
	[86041] = { 86041, 1 },
	[86042] = { 86041, 2 },
	[86043] = { 86041, 3 },
	[86044] = { 86041, 4 },
	[86045] = { 86045, 1 },
	[86046] = { 86045, 2 },
	[86047] = { 86045, 3 },
	[86048] = { 86045, 4 },
	[86050] = { 86050, 1 },
	[86051] = { 86050, 2 },
	[86052] = { 86050, 3 },
	[86053] = { 86050, 4 },
	[86054] = { 86054, 1 },
	[86055] = { 86054, 2 },
	[86056] = { 86054, 3 },
	[86057] = { 86054, 4 },
	[86058] = { 86058, 1 },
	[86059] = { 86058, 2 },
	[86060] = { 86058, 3 },
	[86061] = { 86058, 4 },
	[86109] = { 86109, 1 },
	[86110] = { 86109, 2 },
	[86111] = { 86109, 3 },
	[86112] = { 86109, 4 },
	[86113] = { 86113, 1 },
	[86114] = { 86113, 2 },
	[86115] = { 86113, 3 },
	[86116] = { 86113, 4 },
	[86117] = { 86117, 1 },
	[86118] = { 86117, 2 },
	[86119] = { 86117, 3 },
	[86120] = { 86117, 4 },
	[86122] = { 86122, 1 },
	[86123] = { 86122, 2 },
	[86124] = { 86122, 3 },
	[86125] = { 86122, 4 },
	[86126] = { 86126, 1 },
	[86127] = { 86126, 2 },
	[86128] = { 86126, 3 },
	[86129] = { 86126, 4 },
	[86130] = { 86130, 1 },
	[86131] = { 86130, 2 },
	[86132] = { 86130, 3 },
	[86133] = { 86130, 4 },
	[86135] = { 86135, 1 },
	[86136] = { 86135, 2 },
	[86137] = { 86135, 3 },
	[86138] = { 86135, 4 },
	[86139] = { 86139, 1 },
	[86140] = { 86139, 2 },
	[86141] = { 86139, 3 },
	[86142] = { 86139, 4 },
	[86143] = { 86143, 1 },
	[86144] = { 86143, 2 },
	[86145] = { 86143, 3 },
	[86146] = { 86143, 4 },
	[86148] = { 86148, 1 },
	[86149] = { 86148, 2 },
	[86150] = { 86148, 3 },
	[86151] = { 86148, 4 },
	[86152] = { 86152, 1 },
	[86153] = { 86152, 2 },
	[86154] = { 86152, 3 },
	[86155] = { 86152, 4 },
	[86156] = { 86156, 1 },
	[86157] = { 86156, 2 },
	[86158] = { 86156, 3 },
	[86159] = { 86156, 4 },
	[86161] = { 86161, 1 },
	[86162] = { 86161, 2 },
	[86163] = { 86161, 3 },
	[86164] = { 86161, 4 },
	[86165] = { 86165, 1 },
	[86166] = { 86165, 2 },
	[86167] = { 86165, 3 },
	[86168] = { 86165, 4 },
	[86169] = { 86169, 1 },
	[86170] = { 86169, 2 },
	[86171] = { 86169, 3 },
	[86172] = { 86169, 4 },
	[86175] = { 86175, 1 },
	[86176] = { 86175, 2 },
	[86177] = { 86175, 3 },
	[86178] = { 86175, 4 },
	[86179] = { 86179, 1 },
	[86180] = { 86179, 2 },
	[86181] = { 86179, 3 },
	[86182] = { 86179, 4 },
	[86183] = { 86183, 1 },
	[86184] = { 86183, 2 },
	[86185] = { 86183, 3 },
	[86186] = { 86183, 4 },
	[86269] = { 83216, 2 },
	[86272] = { 83216, 3 },
	[86275] = { 83216, 4 },
	[86278] = { 83229, 2 },
	[86281] = { 83229, 3 },
	[86284] = { 83229, 4 },
	[86287] = { 83238, 2 },
	[86291] = { 83238, 3 },
	[86295] = { 83238, 4 },
	[86316] = { 83272, 2 },
	[86319] = { 83272, 3 },
	[86322] = { 83272, 4 },
	[86325] = { 83292, 2 },
	[86329] = { 83292, 3 },
	[86333] = { 83292, 4 },
	[86337] = { 83310, 2 },
	[86341] = { 83310, 3 },
	[86345] = { 83310, 4 },
	[86360] = { 83600, 2 },
	[86365] = { 83600, 3 },
	[86370] = { 83600, 4 },
	[86383] = { 85187, 2 },
	[86388] = { 85187, 3 },
	[86393] = { 85187, 4 },
	[86398] = { 85179, 2 },
	[86404] = { 85179, 3 },
	[86410] = { 85179, 4 },
	[86421] = { 83552, 2 },
	[86423] = { 83552, 3 },
	[86425] = { 83552, 4 },
	[86428] = { 83850, 2 },
	[86441] = { 83850, 3 },
	[86454] = { 83850, 4 },
	[86467] = { 85132, 2 },
	[86471] = { 85132, 3 },
	[86475] = { 85132, 4 },
	[86481] = { 83619, 2 },
	[86483] = { 83619, 3 },
	[86485] = { 83619, 4 },
	[86506] = { 84434, 2 },
	[86508] = { 84434, 3 },
	[86510] = { 84434, 4 },
	[86530] = { 83642, 2 },
	[86532] = { 83642, 3 },
	[86534] = { 83642, 4 },
	[86582] = { 83465, 2 },
	[86584] = { 83465, 3 },
	[86586] = { 83465, 4 },
	[86597] = { 85257, 2 },
	[86600] = { 85257, 3 },
	[86603] = { 85257, 4 },
	[86614] = { 85451, 2 },
	[86617] = { 85451, 3 },
	[86620] = { 85451, 4 },
	[93593] = { 86009, 4 },
	[93769] = { 85536, 2 },
	[93770] = { 85536, 3 },
	[93771] = { 85536, 4 },
	[93772] = { 85862, 2 },
	[93773] = { 85862, 3 },
	[93774] = { 85862, 4 },
	[93775] = { 85863, 2 },
	[93776] = { 85863, 3 },
	[93777] = { 85863, 4 },
	[93778] = { 86015, 4 },
	[93791] = { 86019, 4 },
	[93802] = { 85578, 2 },
	[93803] = { 85578, 3 },
	[93804] = { 85578, 4 },
	[93805] = { 85840, 2 },
	[93806] = { 85840, 3 },
	[93807] = { 85840, 4 },
	[93808] = { 85845, 2 },
	[93809] = { 85845, 3 },
	[93810] = { 85845, 4 },
	[93875] = { 85552, 2 },
	[93876] = { 85552, 3 },
	[93877] = { 85552, 4 },
	[93878] = { 85850, 2 },
	[93879] = { 85850, 3 },
	[93880] = { 85850, 4 },
	[93881] = { 85851, 2 },
	[93882] = { 85851, 3 },
	[93883] = { 85851, 4 },
	[93906] = { 85539, 2 },
	[93907] = { 85539, 3 },
	[93908] = { 85539, 4 },
	[93909] = { 85854, 2 },
	[93910] = { 85854, 3 },
	[93911] = { 85854, 4 },
	[93912] = { 85855, 2 },
	[93913] = { 85855, 3 },
	[93914] = { 85855, 4 },
	[93932] = { 85564, 2 },
	[93933] = { 85564, 3 },
	[93934] = { 85564, 4 },
	[93935] = { 85859, 2 },
	[93936] = { 85859, 3 },
	[93937] = { 85859, 4 },
	[93938] = { 85858, 2 },
	[93939] = { 85858, 3 },
	[93940] = { 85858, 4 },
	[93966] = { 85532, 2 },
	[93967] = { 85532, 3 },
	[93968] = { 85532, 4 },
	[93969] = { 85804, 2 },
	[93970] = { 85804, 3 },
	[93971] = { 85804, 4 },
	[93972] = { 85807, 2 },
	[93973] = { 85807, 3 },
	[93974] = { 85807, 4 },
	[39012] = { 39012, 1 },
	[41739] = { 39012, 2 },
	[41755] = { 39012, 3 },
	[41770] = { 39012, 4 },
	[39018] = { 39018, 1 },
	[41748] = { 39018, 2 },
	[41757] = { 39018, 3 },
	[41772] = { 39018, 4 },
	[39028] = { 39028, 1 },
	[41743] = { 39028, 2 },
	[41756] = { 39028, 3 },
	[41771] = { 39028, 4 },
	[29073] = { 29073, 1 },
	[40948] = { 29073, 2 },
	[40957] = { 29073, 3 },
	[40965] = { 29073, 4 },
	[29089] = { 29089, 1 },
	[40953] = { 29089, 2 },
	[40962] = { 29089, 3 },
	[40970] = { 29089, 4 },
	[29078] = { 29078, 1 },
	[40950] = { 29078, 2 },
	[40959] = { 29078, 3 },
	[40967] = { 29078, 4 },
	[38944] = { 38944, 1 },
	[41030] = { 38944, 2 },
	[41039] = { 38944, 3 },
	[41048] = { 38944, 4 },
	[38978] = { 38978, 1 },
	[41036] = { 38978, 2 },
	[41045] = { 38978, 3 },
	[41054] = { 38978, 4 },
	[38970] = { 38970, 1 },
	[41033] = { 38970, 2 },
	[41042] = { 38970, 3 },
	[41051] = { 38970, 4 },
	[38985] = { 38985, 1 },
	[40984] = { 38985, 2 },
	[40996] = { 38985, 3 },
	[41009] = { 38985, 4 },
	[38993] = { 38993, 1 },
	[40991] = { 38993, 2 },
	[41003] = { 38993, 3 },
	[41016] = { 38993, 4 },
	[38989] = { 38989, 1 },
	[40988] = { 38989, 2 },
	[41000] = { 38989, 3 },
	[41013] = { 38989, 4 },
	[28794] = { 28794, 1 },
	[42950] = { 28794, 2 },
	[42954] = { 28794, 3 },
	[42958] = { 28794, 4 },
	[28799] = { 28799, 1 },
	[42952] = { 28799, 2 },
	[42956] = { 28799, 3 },
	[42960] = { 28799, 4 },
	[28798] = { 28798, 1 },
	[42951] = { 28798, 2 },
	[42955] = { 28798, 3 },
	[42959] = { 28798, 4 },
	[28807] = { 28807, 1 },
	[41628] = { 28807, 2 },
	[41643] = { 28807, 3 },
	[41659] = { 28807, 4 },
	[28849] = { 28849, 1 },
	[41637] = { 28849, 2 },
	[41652] = { 28849, 3 },
	[41668] = { 28849, 4 },
	[28854] = { 28854, 1 },
	[41632] = { 28854, 2 },
	[41647] = { 28854, 3 },
	[41663] = { 28854, 4 },
	[39053] = { 39053, 1 },
	[41674] = { 39053, 2 },
	[41692] = { 39053, 3 },
	[41712] = { 39053, 4 },
	[39073] = { 39073, 1 },
	[41685] = { 39073, 2 },
	[41705] = { 39073, 3 },
	[41723] = { 39073, 4 },
	[39067] = { 39067, 1 },
	[41679] = { 39067, 2 },
	[41697] = { 39067, 3 },
	[41717] = { 39067, 4 },
	[39145] = { 39145, 1 },
	[42962] = { 39145, 2 },
	[42969] = { 39145, 3 },
	[42976] = { 39145, 4 },
	[39147] = { 39147, 1 },
	[42966] = { 39147, 2 },
	[42973] = { 39147, 3 },
	[42980] = { 39147, 4 },
	[39146] = { 39146, 1 },
	[42964] = { 39146, 2 },
	[42971] = { 39146, 3 },
	[42978] = { 39146, 4 },
	[39162] = { 39162, 1 },
	[42983] = { 39162, 2 },
	[42990] = { 39162, 3 },
	[42997] = { 39162, 4 },
	[39167] = { 39167, 1 },
	[42987] = { 39167, 2 },
	[42994] = { 39167, 3 },
	[43001] = { 39167, 4 },
	[39163] = { 39163, 1 },
	[42985] = { 39163, 2 },
	[42992] = { 39163, 3 },
	[42999] = { 39163, 4 },
	[83625] = { 83625, 1 },
	[86488] = { 83625, 2 },
	[86490] = { 83625, 3 },
	[86492] = { 83625, 4 },
	[83630] = { 83630, 1 },
	[86500] = { 83630, 2 },
	[86502] = { 83630, 3 },
	[86504] = { 83630, 4 },
	[83628] = { 83628, 1 },
	[86494] = { 83628, 2 },
	[86495] = { 83628, 3 },
	[86496] = { 83628, 4 },
	[85126] = { 85126, 1 },
	[86512] = { 85126, 2 },
	[86513] = { 85126, 3 },
	[86515] = { 85126, 4 },
	[85130] = { 85130, 1 },
	[86524] = { 85130, 2 },
	[86526] = { 85130, 3 },
	[86528] = { 85130, 4 },
	[85128] = { 85128, 1 },
	[86518] = { 85128, 2 },
	[86520] = { 85128, 3 },
	[86522] = { 85128, 4 },
	[83682] = { 83682, 1 },
	[86536] = { 83682, 2 },
	[86538] = { 83682, 3 },
	[86540] = { 83682, 4 },
	[83686] = { 83686, 1 },
	[86548] = { 83686, 2 },
	[86550] = { 83686, 3 },
	[86552] = { 83686, 4 },
	[83684] = { 83684, 1 },
	[86542] = { 83684, 2 },
	[86544] = { 83684, 3 },
	[86546] = { 83684, 4 },
	[38932] = { 38932, 1 },
	[41924] = { 38932, 2 },
	[41925] = { 38932, 3 },
	[41926] = { 38932, 4 },
	[38931] = { 38931, 1 },
	[41933] = { 38931, 2 },
	[41936] = { 38931, 3 },
	[41937] = { 38931, 4 },
	[38949] = { 38949, 1 },
	[41900] = { 38949, 2 },
	[41901] = { 38949, 3 },
	[41902] = { 38949, 4 },
	[38956] = { 38956, 1 },
	[41879] = { 38956, 2 },
	[41880] = { 38956, 3 },
	[41881] = { 38956, 4 },
	[38963] = { 38963, 1 },
	[41813] = { 38963, 2 },
	[41814] = { 38963, 3 },
	[41815] = { 38963, 4 },
	[38965] = { 38965, 1 },
	[41822] = { 38965, 2 },
	[41823] = { 38965, 3 },
	[41824] = { 38965, 4 },
	[58864] = { 58864, 1 },
	[58870] = { 58864, 2 },
	[58873] = { 58864, 3 },
	[58876] = { 58864, 4 },
	[58879] = { 58879, 1 },
	[58901] = { 58879, 2 },
	[58904] = { 58879, 3 },
	[58907] = { 58879, 4 },
	[39105] = { 39105, 1 },
	[42117] = { 39105, 2 },
	[42118] = { 39105, 3 },
	[42119] = { 39105, 4 },
	[39104] = { 39104, 1 },
	[42126] = { 39104, 2 },
	[42127] = { 39104, 3 },
	[42128] = { 39104, 4 },
	[39113] = { 39113, 1 },
	[42155] = { 39113, 2 },
	[42156] = { 39113, 3 },
	[42157] = { 39113, 4 },
	[39114] = { 39114, 1 },
	[42177] = { 39114, 2 },
	[42178] = { 39114, 3 },
	[42179] = { 39114, 4 },
	[58317] = { 58317, 1 },
	[58319] = { 58317, 2 },
	[58321] = { 58317, 3 },
	[58323] = { 58317, 4 },
	[58325] = { 58325, 1 },
	[58329] = { 58325, 2 },
	[58332] = { 58325, 3 },
	[58334] = { 58325, 4 },
	[58742] = { 58742, 1 },
	[58786] = { 58742, 2 },
	[58790] = { 58742, 3 },
	[58794] = { 58742, 4 },
	[58798] = { 58798, 1 },
	[58802] = { 58798, 2 },
	[58805] = { 58798, 3 },
	[58808] = { 58798, 4 },
}                        


SLASH_COMMANDS["/uespskillcoef"] = function(cmd)
	local cmds, cmd1 = uespLog.SplitCommands(cmd)
	local result
	
	if (cmd1 == "save") then
	
		if (not uespLog.IsSafetoSaveSkillCoef()) then
			uespLog.Msg("Error: Can't save skill data. Wait a few more seconds and try again.")
			return false
		end
		
		uespLog.CaptureSkillCoefData()
		
	elseif (cmd1 == "calc" or cmd1 == "compute") then
		result = uespLog.ComputeSkillCoef()
		
		if (result) then
			uespLog.Msg("Skill data calculated! Found "..tostring(uespLog.SkillCoefNumValidCoefCount).." skill variables with valid coefficients.")
			uespLog.Msg(".       Failed to compute coefficients for "..tostring(uespLog.SkillCoefNumBadCoefCount).." skill variables.")
		else
			uespLog.Msg("Error: Failed to calculate skill coefficients!")
		end
		
	elseif (cmd1 == "coef" or cmd1 == "show") then
		local skillName = uespLog.implodeOrder(cmds, " ", 2)
		uespLog.ShowSkillCoef(skillName)
	elseif (cmd1 == "savetemp") then
		local skillName = uespLog.implodeOrder(cmds, " ", 2)
		uespLog.SaveTempSkillCoef(skillName)
	elseif (cmd1 == "showdata") then
		local skillName = uespLog.implodeOrder(cmds, " ", 2)
		uespLog.ShowDataSkillCoef(skillName)
	elseif (cmd1 == "status") then
		local calcStatus = "not "
		
		if (uespLog.SkillCoefDataIsCalculated) then
			calcStatus = ""
		end
		
		uespLog.Msg("There are "..tostring(uespLog.SkillCoefAbilityCount).." skills with "..tostring(uespLog.SkillCoefDataPointCount).." data points for calculating skill coefficients.")
		uespLog.Msg("Skill data is "..calcStatus.."calculated with "..tostring(uespLog.SkillCoefNumValidCoefCount).." skill variables with valid coefficients.")
		uespLog.Msg(".       Failed to compute coefficients for "..tostring(uespLog.SkillCoefNumBadCoefCount).." skill variables.")
		
	elseif (cmd1 == "clear" or cmd1 == "reset") then
		uespLog.ClearSkillCoefData()
		uespLog.Msg("Cleared all skill coefficient data.")
	elseif (cmd1 == "clearsaved" or cmd1 == "resetsaved") then
		uespLog.ClearSavedSkillCoefData()
		uespLog.Msg("Cleared any saved skill coefficient statistic data.")
	elseif (cmd1 == "listbad" or cmd1 == "showbad") then
		uespLog.ShowSkillCoefBadData()
	elseif (cmd1 == "listbadfit" or cmd1 == "showbadfit") then
		uespLog.ShowSkillCoefBadFitData(cmds[2])
	elseif (cmd1 == "addskill" or cmd1 == "add") then
		uespLog.SkillCoefAddSkill(cmds[2])
	elseif (cmd1 == "addcharskills") then
		uespLog.SkillCoefAddCharSkills()
	elseif (cmd1 == "addlist") then
		uespLog.SkillCoefAddList(cmds)
	elseif (cmd1 == "addmissing") then
		uespLog.SkillCoefAddMissingSkills()
	elseif (cmd1 == "addall") then
		uespLog.SkillCoefAddAllSkills()
	elseif (cmd1 == "savelist") then
		uespLog.SkillCoefSaveSkillList()
	elseif (cmd1 == "loadlist") then
		uespLog.SkillCoefLoadSkillList()
	elseif (cmd1 == "resetlist") then
		uespLog.SkillCoefResetSkillList()
	elseif (cmd1 == "resetdesc") then
		uespLog.ResetSkillCoefDesc()
	elseif (cmd1 == "savedesc" or cmd1 == "savebase") then
		uespLog.SaveBaseSkillCoefDesc()
	elseif (cmd1 == "checkcost") then
		uespLog.CheckSkillCoefCost("misc")
	elseif (cmd1 == "checkdesc") then
		local cmd2 = string.lower(cmds[2] or "")
		
		if (cmd2 == "hot") then
			uespLog.StartCheckSkillCoefDesc("hot")
		elseif (cmd2 == "dot") then
			uespLog.StartCheckSkillCoefDesc("dot")
		elseif (cmd2 == "direct") then
			uespLog.StartCheckSkillCoefDesc("direct")
		elseif (cmd2 == "aoedmg") then
			uespLog.StartCheckSkillCoefDesc("aoedmg")
		elseif (cmd2 == "aoeheal") then
			uespLog.StartCheckSkillCoefDesc("aoeheal")
		elseif (cmd2 == "stdmg") then
			uespLog.StartCheckSkillCoefDesc("stdmg")
		elseif (cmd2 == "stheal") then
			uespLog.StartCheckSkillCoefDesc("stheal")
		elseif (cmd2 == "heal") then
			uespLog.StartCheckSkillCoefDesc("heal")
		elseif (cmd2 == "ds") then
			uespLog.StartCheckSkillCoefDesc("ds")
			uespLog.StartCheckSkillCoefDuration("ds")
		elseif (cmd2 == "flameaoe") then
			uespLog.StartCheckSkillCoefDesc("flameaoe")
		elseif (cmd2 == "elfbane") then
			uespLog.StartCheckSkillCoefDuration("elfbane")
		elseif (cmd2 == "melee") then
			uespLog.StartCheckSkillCoefDesc("melee")
		elseif (cmd2 == "misc") then
			uespLog.StartCheckSkillCoefDesc("misc")
		elseif (cmd2 == "miscdur") then
			uespLog.StartCheckSkillCoefDuration("misc")
		else
			uespLog.Msg("Expecting check type as second parameter: aoedmg, aoeheal, dot, direct, hot, stdmg, stheal, ds, heal, flameaoe, melee, elfbane, misc, miscdur")
		end
		
	else
		uespLog.Msg("Saves and calculates coefficients for all skills the character knows. Note that the saved skill data is *not* saved when you /reloadui or logout.")
		uespLog.Msg("To use use the 'save' command with at least 3 different sets of character stat (spell damage/magicka or weapon damage/stamina) and then use the 'calc' command.")
		uespLog.Msg(".     /uespsavecoef ...       Normal command form")
		uespLog.Msg(".     /usc ...                       Short form")
		uespLog.Msg(".     /usc save                   Save current skill data")
		uespLog.Msg(".     /usc calc                   Calculate coefficients using saved data")
		uespLog.Msg(".     /usc coef [name]       Shows the coefficients for the given skill name")
		uespLog.Msg(".     /usc coef [id]             Shows the coefficients for the given skill ID")
		uespLog.Msg(".     /usc status                 Current status of saved skill data")
		uespLog.Msg(".     /usc reset                  Resets the saved skill data")
		uespLog.Msg(".     /usc resetsaved         Clears all saved data points from")
		uespLog.Msg(".     /usc savetemp [id]           Saves skill data to the tempData section")
		uespLog.Msg(".     /usc savetemp [name]")
		uespLog.Msg(".     /usc showdata [id]           Output raw data for a skill")
		uespLog.Msg(".     /usc showdata [name]")
		uespLog.Msg(".     /usc showbad                  Lists all any coefficients that are 'bad'")
		uespLog.Msg(".     /usc showbadfit [R2]        Lists all any coefficients with poor fits")
		uespLog.Msg(".     /usc addskill [id] [rank]    Adds the given skill to track when saving")
		uespLog.Msg(".     /usc addcharskills           Adds all character skills to track when saving")
		uespLog.Msg(".     /usc addmissing              Adds all currently defined missing skills")
		uespLog.Msg(".     /usc addlist [id] ...     Adds the listed skills")
		uespLog.Msg(".     /usc savedesc              Saves skill descriptions for later checking")
		uespLog.Msg(".     /usc checkdesc [type]      Checks skill descriptions for changes since save")
		uespLog.Msg(".     /usc checkcost             Checks skill costs for changes since save")
	end

end

SLASH_COMMANDS["/usc"] = SLASH_COMMANDS["/uespskillcoef"]


function uespLog.SkillCoefSaveSkillList()
	local data
	local count = 0
	data = {}
	
	for abilityId, abilityData in pairs(uespLog.SkillCoefAbilityData) do
		count = count + 1
		data[#data + 1] = { id = abilityId, rank = abilityData['rank'] }
	end
	
	if (uespLog.savedVars.skillCoefAbilityList == nil) then
		uespLog.savedVars.skillCoefAbilityList = uespLog.DEFAULT_DATA
	end
	
	uespLog.savedVars.skillCoefAbilityList.data = data
	uespLog.Msg("Saved "..tostring(count).." abilities to the skillCoefAbilityList section.")
end


function uespLog.SkillCoefLoadSkillList()
	local data
	local count = 0
	local newCount = 0
	
	if (uespLog.isSkillCoefSaving) then
		uespLog.Msg("Skill coeffiecient is busy saving data!")
		return
	end
	
	if (uespLog.savedVars.skillCoefAbilityList == nil) then
		uespLog.Msg("No skills found in skillCoefAbilityList section!")
		return
	end
	
	data = uespLog.savedVars.skillCoefAbilityList.data
	
	for _, abilityData in ipairs(data) do
		local _, isNew = uespLog.InitSkillCoefData(abilityData['id'], abilityData['rank'])
		
		if (isNew) then
			newCount = newCount + 1
		end
		
		count = count + 1
	end
	
	uespLog.Msg("Loaded "..tostring(newCount).." of "..tostring(count).." abilities from the skillCoefAbilityList section.")
end


function uespLog.SkillCoefResetSkillList()

	if (uespLog.savedVars.skillCoefAbilityList == nil) then
		uespLog.savedVars.skillCoefAbilityList = uespLog.DEFAULT_DATA
	end
	
	uespLog.savedVars.skillCoefAbilityList.data = {}
	uespLog.Msg("Reset the skillCoefAbilityList section.")
end


function uespLog.ShowSkillCoefBadData()

	if (uespLog.SkillCoefNumBadCoefCount == 0) then
		uespLog.Msg("No bad skill coefficient data found!")
		return
	end
	
	uespLog.Msg("Found "..tostring(#uespLog.SkillCoefBadData).." bad coefficient data...")
	
	for i,badSkill in ipairs(uespLog.SkillCoefBadData) do
		local abilityData = uespLog.SkillCoefAbilityData[badSkill.id]
		
		if (abilityData == nil) then
			uespLog.Msg(".      "..tostring(i)..": Unknown abilityId "..tostring(badSkill.id).."!")
		else
			uespLog.Msg(".      "..tostring(i)..": "..tostring(abilityData.name).." ("..tostring(badSkill.id)..") number #"..tostring(badSkill.numberIndex))
		end
	end

end


function uespLog.ShowSkillCoefBadFitData(maxR2)
	local count = 0
	local totalCount = 0

	if (maxR2 == nil or maxR2 == "") then
		maxR2 = uespLog.SKILLCOEF_BADFIT_MINR2
	else
		maxR2 = tonumber(maxR2)
	end
	
	uespLog.Msg("Listing all fits with R2 less than "..tostring(maxR2).."...")
	
	for id,coefData in pairs(uespLog.SkillCoefAbilityData) do
		local calcData = uespLog.SkillCoefCalcData[id]
		local hasOutputName = false
		
		if (calcData ~= nil and calcData.isValid) then
		
			for i,result in ipairs(calcData.result) do
				local doesVary = calcData.numbersVary[i]
								
				if (doesVary and result.R2 < maxR2) then
					local a  = string.format("%.7f", result.a)
					local b  = string.format("%.7f", result.b)
					local c  = string.format("%.7f", result.c)
					local R2 = string.format("%.7f", result.R2)
					local index = calcData.numbersIndex[i]
					local rank = tostring(coefData.rank)
					local typeName = uespLog.GetSkillMechanicName(result.type)
					
					if (not hasOutputName) then
						uespLog.Msg(""..tostring(coefData.name).." "..rank.." ("..tostring(coefData.id).."):")
						hasOutputName = true
					end
					
					count = count + 1
					totalCount = totalCount + 1
					uespLog.Msg(".     $"..tostring(index)..": "..a..", "..b..", "..c..", "..R2.."  ("..typeName..")")
				elseif (doesVary) then
					totalCount = totalCount + 1
				end
			end	
		end
	end
	
	uespLog.Msg("Found "..count.." of "..totalCount.." variables with poor fits.")
end


function uespLog.LogSkillCoefData()
	local logData = {}
	local rowData = {}
	
	uespLog.ClearSavedVarSection("tempData")
	
	table.insert(rowData, "Skill Name")
	table.insert(rowData, "ID")
	table.insert(rowData, "Level")
	table.insert(rowData, "Mechanic")
	table.insert(rowData, "Cost")
	table.insert(rowData, "NumVars")
	table.insert(rowData, "Description")
	table.insert(rowData, "mech1")
	table.insert(rowData, "a1")
	table.insert(rowData, "b1")
	table.insert(rowData, "c1")
	table.insert(rowData, "R1")
	table.insert(rowData, "mech2")
	table.insert(rowData, "a2")
	table.insert(rowData, "b2")
	table.insert(rowData, "c2")
	table.insert(rowData, "R2")
	table.insert(rowData, "mech3")
	table.insert(rowData, "a3")
	table.insert(rowData, "b3")
	table.insert(rowData, "c3")
	table.insert(rowData, "R3")
	table.insert(rowData, "mech4")
	table.insert(rowData, "a4")
	table.insert(rowData, "b4")
	table.insert(rowData, "c4")
	table.insert(rowData, "R4")
	table.insert(rowData, "mech5")
	table.insert(rowData, "a5")
	table.insert(rowData, "b5")
	table.insert(rowData, "c5")
	table.insert(rowData, "R5")
	table.insert(rowData, "mech6")
	table.insert(rowData, "a6")
	table.insert(rowData, "b6")
	table.insert(rowData, "c6")
	table.insert(rowData, "R6")
	
	local data = uespLog.savedVars.tempData.data
	data[#data+1] = uespLog.implode(rowData, ", ")
	
	logData.event = "SkillCoef::Start"
	logData.numSkills = uespLog.SkillCoefAbilityCount
	logData.numPoints = uespLog.SkillCoefDataPointCount
	uespLog.AppendDataToLog("all", logData, uespLog.GetTimeData())
	
	for abilityId, abilityData in pairs(uespLog.SkillCoefAbilityData) do
		local calcData = uespLog.SkillCoefCalcData[abilityId]
		
		if (calcData ~= nil) then
			uespLog.LogSkillCoefDataSkill(abilityData, calcData)
			uespLog.LogSkillCoefDataSkillCsv(abilityData, calcData)
		end
	end
	
	logData.event = "SkillCoef::End"
	uespLog.AppendDataToLog("all", logData)
end


function uespLog.LogSkillCoefDataSkill(abilityData, calcData)
	local logData = {}
	
	if (not calcData.isValid or calcData.result == nil or #(calcData.result) == 0) then
		return
	end
	
	logData.event = "SkillCoef"
	logData.desc = abilityData.newDesc
	logData.numVars = abilityData.numVars
	logData.name = abilityData.name
	logData.passive = 0
	logData.cost = abilityData.cost
	logData.rank = abilityData.rank
	logData.abilityId = abilityData.id
				
	if (abilityData.passive) then
		logData.passive = 1
	end
	
	for i,result in ipairs(calcData.result) do
		local doesVary = calcData.numbersVary[i]
		local a  = string.format("%.7f", result.a)
		local b  = string.format("%.7f", result.b)
		local c  = string.format("%.7f", result.c)
		local R2 = string.format("%.7f", result.R2)
		local avg = string.format("%.7f", result.avg)
		local index = calcData.numbersIndex[i]
		
		if (doesVary) then
			logData['a'..tostring(index)] = a
			logData['b'..tostring(index)] = b
			logData['c'..tostring(index)] = c
			logData['R'..tostring(index)] = R2
			logData['avg'..tostring(index)] = avg
			logData['type'..tostring(index)] = result.type
		end
	end	
	
	uespLog.AppendDataToLog("all", logData)
end


function uespLog.LogSkillCoefDataSkillCsv(abilityData, calcData)
	local rowData = {}
	
	if (not calcData.isValid or calcData.result == nil or #(calcData.result) == 0) then
		return
	end
	
	table.insert(rowData, "'"..abilityData.name.."'")
	table.insert(rowData, abilityData.id)
	table.insert(rowData, abilityData.rank)
	table.insert(rowData, abilityData.type)
	table.insert(rowData, abilityData.cost)
	table.insert(rowData, abilityData.numVars)
	table.insert(rowData, "'"..abilityData.newDesc.."'")
	
	for i,result in ipairs(calcData.result) do
		local doesVary = calcData.numbersVary[i]
		local a  = string.format("%.7f", result.a)
		local b  = string.format("%.7f", result.b)
		local c  = string.format("%.7f", result.c)
		local R2 = string.format("%.7f", result.R2)
		local index = calcData.numbersIndex[i]
		
		if (doesVary) then
			table.insert(rowData, result.type)
			table.insert(rowData, a)
			table.insert(rowData, b)
			table.insert(rowData, c)
			table.insert(rowData, R2)
		end
	end	
	
	local data = uespLog.savedVars.tempData.data
	data[#data+1] = uespLog.implode(rowData, ", ")
end


function uespLog.SkillCoefAddMissingSkills()
	local newSkills = 0
	
	if (uespLog.isSkillCoefSaving) then
		uespLog.Msg("Skill coeffiecient is busy saving data!")
		return
	end
	
	for k, skillData in ipairs(uespLog.MISSING_SKILL_DATA) do
		local abilityId = skillData[2]
		
		local result, isNew = uespLog.InitSkillCoefData(abilityId, 0)
		if (isNew) then newSkills = newSkills + 1 end
	end
	
	for k, abilityId in ipairs(uespLog.OTHER_MISSING_SKILL_DATA) do
		local result, isNew = uespLog.InitSkillCoefData(abilityId, 0)
		if (isNew) then newSkills = newSkills + 1 end
	end
	
	uespLog.Msg("Added "..newSkills.." missing skills to tracked data!")
		
end


function uespLog.InitPlayerSkill(abilityId)
	local newSkills = 0
	local rankData = uespLog.BASESKILL_RANKDATA[abilityId]
	local result, isNew
						
	if (rankData) then
		result, isNew = uespLog.InitSkillCoefData(abilityId, 1)
		if (isNew) then newSkills = newSkills + 1 end
		
		result, isNew = uespLog.InitSkillCoefData(rankData[2], 2)
		if (isNew) then newSkills = newSkills + 1 end
		
		result, isNew = uespLog.InitSkillCoefData(rankData[3], 3)
		if (isNew) then newSkills = newSkills + 1 end
		
		result, isNew = uespLog.InitSkillCoefData(rankData[4], 4)
		if (isNew) then newSkills = newSkills + 1 end
	else
		result, isNew = uespLog.InitSkillCoefData(abilityId, 1)
		if (isNew) then newSkills = newSkills + 1 end
		
		result, isNew = uespLog.InitSkillCoefData(abilityId + 20000000, 2)
		if (isNew) then newSkills = newSkills + 1 end
		
		result, isNew = uespLog.InitSkillCoefData(abilityId + 30000000, 3)
		if (isNew) then newSkills = newSkills + 1 end
		
		result, isNew = uespLog.InitSkillCoefData(abilityId + 40000000, 4)
		if (isNew) then newSkills = newSkills + 1 end
	end
	
	return newSkills
end


function uespLog.SkillCoefAddAllSkills()
		
	if (uespLog.isSkillCoefSaving) then
		uespLog.Msg("Skill coeffiecient is busy saving data!")
		return
	end
	
	uespLog.Msg("Checking all skills for coefficient tracking...")
	uespLog.SkillCoefAddAllValidCount = 0
	uespLog.SkillCoefAddAllNewCount = 0
	uespLog.isSkillCoefSaving = true
	uespLog.SkillCoefAddStartAbilityIndex = 1
	
	uespLog.SkillCoefAddAllSkills_Next()	
end


function uespLog.SkillCoefAddAllSkills_Next()
	local abilityId
	local logData = { }
	local startIndex = uespLog.SkillCoefAddStartAbilityIndex
	local endIndex = startIndex + uespLog.SKILLCOEF_ADDALL_MAXABILITYCOUNT

	if (not uespLog.isSkillCoefSaving) then
		return
	end
	
	if (endIndex > uespLog.SKILLCOEF_ADDALL_MAXABILITYID) then
		endIndex = uespLog.SKILLCOEF_ADDALL_MAXABILITYID
	end
	
	uespLog.Msg("Add skill coefficients for skills from "..tostring(startIndex).."-"..tostring(endIndex).."...")

	for abilityId = startIndex, endIndex do
		local specialType = uespLog.SKILLCOEF_SPECIALTYPES[abilityId]
		
		if (specialType == uespLog.UESP_POWERTYPE_IGNORE) then
			-- Do nothing
		elseif (DoesAbilityExist(abilityId)) then
			uespLog.SkillCoefAddAllValidCount = uespLog.SkillCoefAddAllValidCount + 1
			local desc = GetAbilityDescription(abilityId)
			
			if (desc ~= "") then
				local matchResult = desc:match("%d")

				if (matchResult ~= nil) then
					local skillType, skillIndex, abilityIndex, morph = GetSpecificSkillAbilityKeysByAbilityId(abilityId)
					local rankData = uespLog.BASESKILL_RANKDATA[abilityId]
					
					if (skillType > 0 or rankData ~= nil) then
						uespLog.SkillCoefAddAllNewCount = uespLog.SkillCoefAddAllNewCount + uespLog.InitPlayerSkill(abilityId)						
					else
						local result, isNew = uespLog.InitSkillCoefData(abilityId, 0)
						if (isNew) then uespLog.SkillCoefAddAllNewCount = uespLog.SkillCoefAddAllNewCount + 1 end
					end
				end
			end

		end
	end
	
	if (endIndex < uespLog.SKILLCOEF_ADDALL_MAXABILITYID) then
		uespLog.SkillCoefAddStartAbilityIndex = endIndex + 1
		zo_callLater(uespLog.SkillCoefAddAllSkills_Next, uespLog.SKILLCOEF_ADDALL_DELAY)
	else
		uespLog.SkillCoefAddAllSkills_End()
	end
	
end


function uespLog.SkillCoefAddAllSkills_End()
	uespLog.Msg("Added "..tostring(uespLog.SkillCoefAddAllNewCount).." skills out of "..tostring(uespLog.SkillCoefAddAllValidCount).." possible skills to tracked data!")
	
	uespLog.isSkillCoefSaving = false
end


function uespLog.SkillCoefAddList(cmds)
	local newSkills = 0
	local i
	
	if (uespLog.isSkillCoefSaving) then
		uespLog.Msg("Skill coeffiecient is busy saving data!")
		return
	end
	
	uespLog.Msg("Adding "..(#cmds-1).." skills to tracked skill list...")

	for i = 2, #cmds do
		local abilityId = tonumber(cmds[i])
		
		local result = uespLog.SkillCoefAddSkill(abilityId, -1)
		
		if (result) then
			newSkills = newSkills + 1
		end
		
	end
	
	uespLog.Msg("Added "..newSkills.." skills to tracked data!")
	return true
end


function uespLog.SkillCoefAddCharSkills()
	local newSkills = 0
	local numSkillTypes = GetNumSkillTypes()
	local skillType
	local skillIndex
	local abilityIndex
	local result, isNew
	
	if (uespLog.isSkillCoefSaving) then
		uespLog.Msg("Skill coeffiecient is busy saving data!")
		return
	end
	
	uespLog.Msg("Adding all available character skills to tracked skill list...")
	
	for skillType = 1, numSkillTypes do
		local numSkillLines = GetNumSkillLines(skillType)
		local skillTypeName = uespLog.GetSkillTypeName(skillType)
		
		for skillIndex = 1, numSkillLines do
			local numSkillAbilities = GetNumSkillAbilities(skillType, skillIndex)
					
			for abilityIndex = 1, numSkillAbilities do
				local name, _, rank, passive, ultimate, purchase, progressionIndex = GetSkillAbilityInfo(skillType, skillIndex, abilityIndex)
				local level, maxLevel = GetSkillAbilityUpgradeInfo(skillType, skillIndex, abilityIndex)
				local ability1 = GetSkillAbilityId(skillType, skillIndex, abilityIndex, false)
				local ability2 = GetSkillAbilityId(skillType, skillIndex, abilityIndex, true)
				
				if (level == 0 or level == nil) then 
					level = 1
				end
				
				if (progressionIndex ~= nil and progressionIndex > 0) then
					newSkills = newSkills + uespLog.InitPlayerSkill(GetAbilityProgressionAbilityId(progressionIndex, 0, 1))						
					newSkills = newSkills + uespLog.InitPlayerSkill(GetAbilityProgressionAbilityId(progressionIndex, 1, 1))						
					newSkills = newSkills + uespLog.InitPlayerSkill(GetAbilityProgressionAbilityId(progressionIndex, 2, 1))						
				else
					newSkills = newSkills + uespLog.InitPlayerSkill(ability1)
					newSkills = newSkills + uespLog.InitPlayerSkill(ability2)
				end
			
			end
		end
	end
	
	uespLog.Msg("Found "..tostring(newSkills).." new skills to track.")
	uespLog.SkillCoefAddCPPassives()
end


function uespLog.SkillCoefAddCPPassives()
	local numDisc = GetNumChampionDisciplines()
	local newSkills = 0
	
	for disciplineIndex = 1, numDisc do
		local numSkills = GetNumChampionDisciplineSkills(disciplineIndex)	
		
		for skillIndex = 1, numSkills do
			local unlockLevel = GetChampionSkillUnlockLevel(disciplineIndex, skillIndex)
			local abilityId = GetChampionAbilityId(disciplineIndex, skillIndex)
			
			if (unlockLevel ~= nil and unlockLevel > 0) then
				local result, isNew = uespLog.InitSkillCoefData(abilityId, 0)
				if (isNew) then newSkills = newSkills + 1 end
			end
		end
	end
	
	uespLog.Msg("Found "..tostring(newSkills).." new CP skills to track.")
end


function uespLog.SkillCoefAddSkill(abilityId, rank)
	local abilityId = tonumber(abilityId)
	local rank = tonumber(rank) or -1
	
	if (uespLog.isSkillCoefSaving) then
		uespLog.Msg("Skill coeffiecient is busy saving data!")
		return false
	end
	
	if (abilityId == nil or abilityId == "") then
		uespLog.Msg("Missing required abilityId!")
		return false
	end
	
	if (uespLog.SkillCoefAbilityData[abilityId] ~= nil) then
		uespLog.Msg("Skill "..tostring(abilityId).." is already being tracked...")
		return true
	end
	
	if (not uespLog.DoesSkillCoefAbilityExist(abilityId) or uespLog.GetSkillCoefAbilityName(abilityId) == "") then
		uespLog.Msg("Error: Skill "..tostring(abilityId).." is not valid!")
		return false
	end
	
	if (not uespLog.InitSkillCoefData(abilityId, rank)) then
		uespLog.Msg("Error: Failed to add skill "..tostring(abilityId).." to tracked skill list!")
		return false
	end
	
	uespLog.Msg("Now tracking skill "..tostring(abilityId).." when saving statistic data!")
	return true
end


function uespLog.SaveTempSkillCoef(name)
	local abilityId = tonumber(name)
	local coefData = nil
	local skillData = nil
	local calcData = nil
	
	if (name == nil or name == "") then
		uespLog.Msg("Missing required skill name or abilityId!")
		return false
	end
	
	if (abilityId ~= nil) then
		coefData = uespLog.SkillCoefAbilityData[abilityId]
		skillData = uespLog.SkillCoefData[abilityId]
		calcData = uespLog.SkillCoefCalcData[abilityId]
	else
		coefData, skillData, abilityId = uespLog.FindSkillAbilityData(name)
	end
	
	if (coefData == nil or skillData == nil or calcData == nil) then
		uespLog.Msg("Skill "..tostring(name).." does not exist in coefficient data!")
		return false
	end
	
	local tempData = uespLog.savedVars.tempData.data
	tempData[#tempData+1] = "Raw Skill Coefficient Data for "..tostring(coefData.name).." ("..tostring(abilityId).."), "..tostring(#skillData).." data points"
	local headerData = {}
	
	table.insert(headerData, "Magic")
	table.insert(headerData, "Stamina")
	table.insert(headerData, "Health")
	table.insert(headerData, "SpellDmg")
	table.insert(headerData, "WeaponDmg")
	table.insert(headerData, "WeaponPwr")
	table.insert(headerData, "Light")
	table.insert(headerData, "Medium")
	table.insert(headerData, "Heavy")
	table.insert(headerData, "Description")
	table.insert(headerData, "Value1")
	table.insert(headerData, "Value2")
	table.insert(headerData, "Value3")
	table.insert(headerData, "Value4")
	table.insert(headerData, "Value5")
	table.insert(headerData, "Value6")
	tempData[#tempData+1] = uespLog.implode(headerData, ", ")
		
	for i, data in ipairs(skillData) do
		local rowData = {}
		
		table.insert(rowData, data.mag)
		table.insert(rowData, data.sta)
		table.insert(rowData, data.hea)
		table.insert(rowData, data.sd)
		table.insert(rowData, data.wd)
		table.insert(rowData, data.wp)
		table.insert(rowData, data.la)
		table.insert(rowData, data.ma)
		table.insert(rowData, data.ha)
		table.insert(rowData, "'"..data.desc.."'")
		
		for j, number in ipairs(data.numbers) do
			table.insert(rowData, number)
		end
				
		tempData[#tempData+1] = uespLog.implode(rowData, ", ")
	end
	
	uespLog.Msg("Saved raw skill coefficient data for "..tostring(coefData.name).." ("..tostring(abilityId).."), "..tostring(#skillData).." data points")
	return true
end


function uespLog.ShowDataSkillCoef(name)
	local abilityId = tonumber(name)
	local coefData = nil
	local skillData = nil
	local calcData = nil
	
	if (name == nil or name == "") then
		uespLog.Msg("Missing required skill name or abilityId!")
		return false
	end
	
	if (abilityId ~= nil) then
		coefData = uespLog.SkillCoefAbilityData[abilityId]
		skillData = uespLog.SkillCoefData[abilityId]
		calcData = uespLog.SkillCoefCalcData[abilityId]
	else
		coefData, skillData, abilityId = uespLog.FindSkillAbilityData(name)
	end
	
	if (coefData == nil or skillData == nil or calcData == nil) then
		uespLog.Msg("Skill "..tostring(name).." does not exist in coefficient data!")
		return false
	end
	
	local tempData = uespLog.savedVars.tempData.data
	uespLog.Msg("Raw Skill Coefficient Data for "..tostring(coefData.name).." ("..tostring(abilityId).."), "..tostring(#skillData).." data points")
	local headerData = {}
	
	table.insert(headerData, "Mag")
	table.insert(headerData, "Sta")
	table.insert(headerData, "Hea")
	table.insert(headerData, "Spell")
	table.insert(headerData, "Weap")
	table.insert(headerData, "WP")
	table.insert(headerData, "LA")
	table.insert(headerData, "MA")
	table.insert(headerData, "HA")
	table.insert(headerData, "Values...")
	uespLog.Msg(uespLog.implode(headerData, ", "))
		
	for i, data in ipairs(skillData) do
		local rowData = {}
		
		table.insert(rowData, data.mag)
		table.insert(rowData, data.sta)
		table.insert(rowData, data.hea)
		table.insert(rowData, data.sd)
		table.insert(rowData, data.wd)
		table.insert(rowData, data.wp)
		table.insert(rowData, data.la)
		table.insert(rowData, data.ma)
		table.insert(rowData, data.ha)
		
		for j, number in ipairs(data.numbers) do
			table.insert(rowData, number)
		end
				
		uespLog.Msg(uespLog.implode(rowData, ", "))
	end
	
	return true
end
	

function uespLog.ShowSkillCoef(name)
	local abilityId = tonumber(name)
	local coefData = nil
	local calcData = nil

	if (name == nil or name == "") then
		uespLog.Msg("Missing required skill name or abilityId!")
		return false
	end
	
	if (abilityId ~= nil) then
		coefData = uespLog.SkillCoefAbilityData[abilityId]
	else
		coefData, _, abilityId = uespLog.FindSkillAbilityData(name)
	end
	
	calcData = uespLog.SkillCoefCalcData[abilityId]
	
	if (coefData == nil or calcData == nil) then
		uespLog.Msg("Skill "..tostring(name).." does not exist in coefficient data!")
		return false
	end
	
	if (not calcData.isValid or calcData.result == nil) then
		uespLog.Msg("Coefficient data for skill "..tostring(name).." is not valid!")
		return false
	end
	
	local rank = tostring(coefData.rank)
	uespLog.Msg(""..tostring(coefData.name).." "..rank.." ("..tostring(coefData.id)..") has coefficient data for "..tostring(coefData.numVars).." variable(s):")
	
	for i,result in ipairs(calcData.result) do
		local doesVary = calcData.numbersVary[i]
		local a  = string.format("%.5f", result.a)
		local b  = string.format("%.5f", result.b)
		local c  = string.format("%.5f", result.c)
		local R2 = string.format("%.5f", result.R2)
		local index = calcData.numbersIndex[i]
		local typeName = uespLog.GetSkillMechanicName(result.type)
		
		if (doesVary) then
			uespLog.Msg(".     $"..tostring(index)..": "..a..", "..b..", "..c..", "..R2.."  ("..typeName..", values "..tostring(result.min).."-"..tostring(result.max)..")")
		end
	end	
	
	uespLog.Msg(tostring(coefData.newDesc))
	return true
end


function uespLog.FindSkillAbilityData(name)
	name = string.lower(name)
	
	for abilityId, abilityData in pairs(uespLog.SkillCoefAbilityData) do
		if (string.lower(abilityData.name) == name) then
			return abilityData, uespLog.SkillCoefData[abilityId], abilityId
		end
	end
	
	return nil, nil, nil
end


function uespLog.ClearSavedSkillCoefData()

	uespLog.savedVars.skillCoef.data.coefData = {}
	uespLog.SkillCoefData = uespLog.savedVars.skillCoef.data.coefData
	
	uespLog.SkillCoefSavedIds = {}
	uespLog.SkillCoefCalcData = {}
	uespLog.SkillCoefDataPointCount = 0
	uespLog.SkillCoefNumValidCoefCount = 0
	uespLog.SkillCoefNumBadCoefCount = 0
	uespLog.SkillCoefBadData = {}
	uespLog.SkillCoefDataIsCalculated = false
end


function uespLog.ClearSkillCoefData()

	uespLog.savedVars.skillCoef.data.coefData = {}
	uespLog.savedVars.skillCoef.data.abilityData = {}
	
	uespLog.SkillCoefData = uespLog.savedVars.skillCoef.data.coefData
	uespLog.SkillCoefAbilityData = uespLog.savedVars.skillCoef.data.abilityData
	
	uespLog.SkillCoefSavedIds = {}
	uespLog.SkillCoefCalcData = {}
	uespLog.SkillCoefAbilityCount = 0
	uespLog.SkillCoefDataPointCount = 0
	uespLog.SkillCoefNumValidCoefCount = 0
	uespLog.SkillCoefNumBadCoefCount = 0
	uespLog.SkillCoefBadData = {}
	uespLog.SkillCoefDataIsCalculated = false
end


uespLog.SKILLCOEF_MAXSAVECOUNT = 1000
uespLog.lastSkillCoefSaveAbilityId = nil
uespLog.isSkillCoefSaving = false
uespLog.SkillCoefSaveSkillCount = 0
uespLog.SKILLCOEF_SAVESKILL_DELAY = 500


function uespLog.CaptureSkillCoefData()
	local numSkillTypes = GetNumSkillTypes()
	local skillType
	local skillIndex
	local abilityIndex
	local skillCount = 0
	local result
	
	if (uespLog.isSkillCoefSaving) then
		uespLog.Msg("Skill coeffiecient is busy saving data!")
		return
	end
		
	uespLog.Msg("Saving current skill data for character (don't change anything until done)...")
	
	uespLog.SkillCoefArmorCountLA = uespLog.CountEquippedArmor(ARMORTYPE_LIGHT)
	uespLog.SkillCoefArmorCountMA = uespLog.CountEquippedArmor(ARMORTYPE_MEDIUM)
	uespLog.SkillCoefArmorCountHA = uespLog.CountEquippedArmor(ARMORTYPE_HEAVY)
	uespLog.SkillCoefArmorTypeCount = uespLog.CountEquippedArmorTypes()
	uespLog.SkillCoefWeaponCountDagger = uespLog.CountEquippedWeapons(WEAPONTYPE_DAGGER)
	
	uespLog.lastSkillCoefSaveAbilityId = nil
	uespLog.isSkillCoefSaving = true
	uespLog.SkillCoefSaveSkillCount = 0
	
	uespLog.CaptureSkillCoefData_Next()
end


function uespLog.CaptureSkillCoefData_Next()
	local skillCount = 0
	
	uespLog.Msg(".   Saving data for up to "..tostring(uespLog.SKILLCOEF_MAXSAVECOUNT).." skills...")
	
	while (skillCount < uespLog.SKILLCOEF_MAXSAVECOUNT) do
		local abilityId, abilityData = next(uespLog.SkillCoefAbilityData, uespLog.lastSkillCoefSaveAbilityId)
		uespLog.lastSkillCoefSaveAbilityId = abilityId
		
		if (abilityId == nil) then
			uespLog.CaptureSkillCoefData_End()
			return
		end
		
		uespLog.SaveSkillCoefData(abilityId, abilityData['rank'])
		
		skillCount = skillCount + 1
		uespLog.SkillCoefSaveSkillCount = uespLog.SkillCoefSaveSkillCount + 1
	end
		
	zo_callLater(uespLog.CaptureSkillCoefData_Next, uespLog.SKILLCOEF_SAVESKILL_DELAY)
end


function uespLog.CaptureSkillCoefData_End()
	uespLog.Msg("Saved skill coef data for "..tostring(uespLog.SkillCoefSaveSkillCount).." skills!")
	uespLog.SkillCoefDataPointCount = uespLog.SkillCoefDataPointCount + 1
	
	uespLog.lastSkillCoefSaveAbilityId = nil
	uespLog.isSkillCoefSaving = false
end


function uespLog.CaptureMissingSkillCoefData()
	skillCount = 0
	
	for abilityId, abilityData in pairs(uespLog.SkillCoefAbilityData) do
	
		if (uespLog.SkillCoefSavedIds[abilityId] == nil) then
			uespLog.SaveSkillCoefData(abilityId)
			skillCount = skillCount + 1
		end
		
	end
	
	return skillCount
end


-- After equipping/unequipping items it can take several seconds until skill values 'reset'.
-- To check if the skill values have reset properly we check the value of a known skill to
-- see if it matches the expected value.
function uespLog.IsSafetoSaveSkillCoef()
	local description = GetAbilityDescription(uespLog.SKILLCOEF_CHECK_ABILITYID)
	 
	if (description == nil or description == "") then
		return true
	end
	
	local iter = string.gmatch(description, "%d+[.]?%d*")
	local i = 1
		
	for number in iter do
	
		if (i == uespLog.SKILLCOEF_CHECK_INDEX) then
			local value = tonumber(number)
			
			if (value ~= uespLog.SKILLCOEF_CHECK_VALUE) then
				uespLog.DebugExtraMsg("Error: Skill value of "..tostring(value).." does not match expected value of "..tostring(uespLog.SKILLCOEF_CHECK_VALUE).."!")
				return false
			end
		end
		
		i = i + 1
	end		
	
	return true
end


function uespLog.InitSkillCoefData(abilityId, rank)

	if (rank ~= nil or rank < 0) then
		rank = uespLog.GetSkillCoefAbilityRank(abilityId)
	end
	
	local name = uespLog.GetSkillCoefAbilityName(abilityId)
	local description = uespLog.GetSkillCoefAbilityDescription(abilityId, rank)
	local isNew = false
		
	if (abilityId <= 0 or name == "" or description == "") then
		return false, false
	end
	
	if (uespLog.SkillCoefData[abilityId] == nil) then
		uespLog.SkillCoefData[abilityId] = {}
	end
	
	local cost, mechanic = uespLog.GetSkillCoefAbilityCost(abilityId, rank)
	local passive = IsAbilityPassive(abilityId)
	
	if (uespLog.SkillCoefAbilityData[abilityId] == nil) then
		isNew = true
		
		uespLog.SkillCoefAbilityData[abilityId] = 
		{
			["name"] = name,
			["rank"] = rank,
			["passive"] = passive,
			["cost"] = cost,
			["id"]   = abilityId,
			["desc"] = description,
			["type"] = mechanic,
			["data"] = {},
			["numVars"] = -1,
			["numbersVary"] = {},
			["numbersIndex"] = {},
		}
		
		uespLog.SkillCoefAbilityCount = uespLog.SkillCoefAbilityCount + 1
	elseif (uespLog.SkillCoefAbilityData[abilityId].rank <= 0 and rank > 0) then
		uespLog.SkillCoefAbilityData[abilityId].rank = rank
	end

	return true, isNew
end


function uespLog.GetSkillCoefAbilityCost(abilityId, rank)
	local cost, mechanic
	local baseRankData = uespLog.SKILL_RANKDATA[abilityId]
	
	if (abilityId > 20000000) then
		cost, mechanic = uespLog.GetAbilityCost(abilityId % 10000000, nil, rank)
	elseif (baseRankData ~= nil) then
		cost, mechanic = uespLog.GetAbilityCost(baseRankData[1], nil, rank)
	else
		cost, mechanic = uespLog.GetAbilityCost(abilityId, nil, rank)
	end	

	return cost, mechanic
end


function uespLog.DoesSkillCoefAbilityExist(abilityId)

	if (abilityId > 20000000) then
		return DoesAbilityExist(abilityId % 10000000)
	end
	
	local baseRankData = uespLog.SKILL_RANKDATA[abilityId]
	
	if (baseRankData ~= nil) then
		return DoesAbilityExist(baseRankData[1])
	end
	
	return DoesAbilityExist(abilityId)
end


function uespLog.GetSkillCoefAbilityName(abilityId)

	if (abilityId > 20000000) then
		return GetAbilityName(abilityId % 10000000)
	end
	
	local baseRankData = uespLog.SKILL_RANKDATA[abilityId]
	
	if (baseRankData ~= nil) then
		return GetAbilityName(baseRankData[1])
	end
	
	return GetAbilityName(abilityId)
end


function uespLog.GetSkillCoefAbilityRank(abilityId)

	if (abilityId > 20000000) then
		return math.floor(abilityId / 10000000)
	end
	
	local baseRankData = uespLog.SKILL_RANKDATA[abilityId]
		
	if (baseRankData ~= nil) then
		return baseRankData[2]
	end
	
	return -1
end


function uespLog.GetSkillCoefAbilityDescription(abilityId, rank)
	local baseRankData = uespLog.SKILL_RANKDATA[abilityId]
	local descHeader = ""
	local desc = ""
	
	if (abilityId > 20000000) then
		desc = GetAbilityDescription(abilityId % 10000000, rank)
		descHeader = tostring(GetAbilityDescriptionHeader(abilityId % 10000000))
	elseif (baseRankData ~= nil) then
		desc = GetAbilityDescription(baseRankData[1], rank)
		descHeader = tostring(GetAbilityDescriptionHeader(baseRankData[1]))
	else
		desc = GetAbilityDescription(abilityId, rank)
		descHeader = tostring(GetAbilityDescriptionHeader(abilityId))
	end
	
	if (descHeader ~= "") then
		desc = "|cffffff" .. descHeader .."|r\n".. desc
	end
	
	return desc
end


function uespLog.SaveSkillCoefData(abilityId, rank)
	--POWERTYPE_MAGICKA == 0
	--POWERTYPE_STAMINA == 6
	--POWERTYPE_ULTIMATE == 10
	
	if (not uespLog.InitSkillCoefData(abilityId, rank)) then
		return false
	end
	
	uespLog.SkillCoefSavedIds[abilityId] = true
	
	local i = #(uespLog.SkillCoefData[abilityId])
	local description = uespLog.GetSkillCoefAbilityDescription(abilityId, rank)
	
	uespLog.SkillCoefData[abilityId][i+1] = 
	{
		["mag"]  = GetPlayerStat(STAT_MAGICKA_MAX),
		["sta"]  = GetPlayerStat(STAT_STAMINA_MAX),
		["hea"]  = GetPlayerStat(STAT_HEALTH_MAX),
		["sd"] 	 = GetPlayerStat(STAT_SPELL_POWER),
		["wd"]   = GetPlayerStat(STAT_POWER),
		["wp"]   = GetPlayerStat(STAT_WEAPON_POWER),
		["la"]   = uespLog.SkillCoefArmorCountLA,
		["ma"]   = uespLog.SkillCoefArmorCountMA,
		["ha"]   = uespLog.SkillCoefArmorCountHA,
		["dagger"] = uespLog.SkillCoefWeaponCountDagger,
		["armortypes"] = uespLog.SkillCoefArmorTypeCount,
		["sr"]  = GetPlayerStat(STAT_SPELL_RESIST),
		["pr"]  = GetPlayerStat(STAT_PHYSICAL_RESIST),
		["desc"] = description,
	}
	
	uespLog.CheckSaveSkillCoefData(uespLog.SkillCoefData[abilityId], i+1, abilityId)
	
	return true
end


function uespLog.CheckSaveSkillCoefData(skillCoefData, lastCount, abilityId)

	if (lastCount <= 1) then
		return true
	end
	
	local desc = skillCoefData[lastCount].desc
	local lastdesc = skillCoefData[lastCount - 1].desc
	local s1, numberMatches = string.gsub(desc, "%d+[.]?%d*", "")
	local s2, lastNumberMatches = string.gsub(lastdesc, "%d+[.]?%d*", "")
	
	if (numberMatches ~= lastNumberMatches) then
		local name = GetAbilityName(abilityId)
		desc = skillCoefData[lastCount].desc
		lastdesc = skillCoefData[lastCount - 1].desc
		
		uespLog.Msg("Skill coef number mismatch for ability "..tostring(name).." ("..tostring(abilityId).."):")
		uespLog.Msg(".     "..tostring(lastNumberMatches)..": "..tostring(lastdesc))
		uespLog.Msg(".     "..tostring(numberMatches)..": "..tostring(desc))
		return false
	end
	
	return true
end


function uespLog.CountEquippedArmor(armorType)
	local numItems = GetBagSize(BAG_WORN)
	local armorCount = 0
	
	for i = 0, numItems do
		if (armorType == GetItemArmorType(BAG_WORN, i)) then
			armorCount = armorCount + 1
		end
	end
		
	return armorCount
end


function uespLog.CountEquippedArmorTypes()
	local numItems = GetBagSize(BAG_WORN)
	local laCount = 0
	local maCount = 0
	local haCount = 0
	local armorCount = 0
	
	for i = 0, numItems do
		armorType = GetItemArmorType(BAG_WORN, i)
		
		if (armorType == ARMORTYPE_LIGHT) then
			laCount = laCount + 1
		elseif (armorType == ARMORTYPE_MEDIUM) then
			maCount = maCount + 1			
		elseif (armorType == ARMORTYPE_HEAVY) then
			haCount = haCount + 1			
		end
	end
	
	if (laCount > 0) then
		armorCount = armorCount + 1
	end
	
	if (maCount > 0) then
		armorCount = armorCount + 1
	end
	
	if (haCount > 0) then
		armorCount = armorCount + 1
	end	
		
	return armorCount
end


function uespLog.CountEquippedWeapons(weaponType)
	-- Bar 1: 4/5
    -- Bar 2: 20/21
	local numItems = GetBagSize(BAG_WORN)
	local weaponCount = 0
	local activeBar = GetActiveWeaponPairInfo()
	
	if (activeBar == 1) then
	
		if (weaponType == GetItemWeaponType(BAG_WORN, 4)) then
			weaponCount = weaponCount + 1
		end
		
		if (weaponType == GetItemWeaponType(BAG_WORN, 5)) then
			weaponCount = weaponCount + 1
		end
	else
	
		if (weaponType == GetItemWeaponType(BAG_WORN, 20)) then
			weaponCount = weaponCount + 1
		end
		
		if (weaponType == GetItemWeaponType(BAG_WORN, 21)) then
			weaponCount = weaponCount + 1
		end
	end
		
	return weaponCount
end


function uespLog.ParseSkillCoefData()

	for abilityId, skillsData in pairs(uespLog.SkillCoefData) do
		uespLog.ParseSkillCoefDataSkill(abilityId, skillsData)
	end
	
	return true
end


function uespLog.ParseSkillCoefDataSkill(abilityId, skillsData)

	for i,data in ipairs(skillsData) do
		local iter = string.gmatch(data['desc'], "%d+[.]?%d*")
		data['numbers'] = {}
		
		for number in iter do
			table.insert(data['numbers'], tonumber(number))
		end
		
	end
	
end


function uespLog.ComputeSkillCoef()
	uespLog.ParseSkillCoefData()
	
	if (uespLog.SkillCoefDataPointCount < 3) then
		uespLog.Msg("Error: You need a minimum of 3 data points to compute skill coefficients.")
		return false
	end
	
	uespLog.SkillCoefNumValidCoefCount = 0
	uespLog.SkillCoefNumBadCoefCount = 0
	
	for abilityId, skillsData in pairs(uespLog.SkillCoefData) do
	
		if (uespLog.CheckSkillCoef(abilityId, skillsData)) then
			uespLog.ComputeSkillCoefSkill(abilityId, skillsData)
		end
		
	end
	
	if (uespLog.SkillCoefTryRecalculateTypes) then
		uespLog.TryRecalcAllBadSkillCoefs()
	end
	
	uespLog.ReplaceSkillDescriptions()
	uespLog.LogSkillCoefData()
	
	uespLog.SkillCoefDataIsCalculated = true
	return true
end


function uespLog.CheckSkillCoef(abilityId, skillsData)
	local numbersCheck = {}
	local abilityData = uespLog.SkillCoefAbilityData[abilityId]
	local calcData = uespLog.SkillCoefCalcData[abilityId]
	
	if (calcData == nil) then
		uespLog.SkillCoefCalcData[abilityId] = { }
		calcData = uespLog.SkillCoefCalcData[abilityId]
	end
	
	abilityData.numVars = 0
	calcData.numVars = 0
	calcData.numbersVary = {}
	calcData.numbersIndex = {}
	
	if (#skillsData == 0) then
		return false
	end
	
	for i,number in ipairs(skillsData[1].numbers) do
		table.insert(numbersCheck, number)
		table.insert(calcData.numbersVary, false)
	end
	
	for i = 2, #skillsData do
		for j,number in ipairs(skillsData[i].numbers) do
			if (number ~= numbersCheck[j]) then
				calcData.numbersVary[j] = true
			end
		end
	end
	
	local index = 1
	
	for i,number in ipairs(calcData.numbersVary) do
		if (calcData.numbersVary[i]) then
			abilityData.numVars = abilityData.numVars + 1
			calcData.numVars    = calcData.numVars + 1
			table.insert(calcData.numbersIndex, index)
			index = index + 1
		else
			table.insert(calcData.numbersIndex, 0)
		end
	end
	
	return (abilityData.numVars > 0)
end


function uespLog.ComputeSkillCoefSkill(abilityId, skillsData)
    -- z = ax + by + c
	-- x = Mag/Sta
	-- y = SD/WD
	-- z = Tooltip value
	-- X = [ a, b, c ]
	-- A X = B
	-- X = Ainv B	
	local abilityData = uespLog.SkillCoefAbilityData[abilityId]
	local calcData = uespLog.SkillCoefCalcData[abilityId]
	
	calcData.data = {}
	calcData.numPoints = #skillsData
	
	if (calcData.numPoints < 3) then
		return false
	end
	
	local numberCount = #(skillsData[1].numbers)
	
	if (numberCount < 0) then
		return false
	end
	
	local coefData = {}
	local allInvalid = true
	coefData.A = {}
	coefData.Ainv = {}
	coefData.Adet = {}
	coefData.isValid = true
	coefData.AisValid = { }
	coefData.B = {}
	coefData.result = {}
	
	for i = 1, numberCount do
		local numberType = uespLog.GetSkillCoefNumberMechanic(abilityData, i)
	
		if (calcData.numbersVary[i]) then
			local A = uespLog.SkillCoefComputeAMatrix(skillsData, abilityData, i)
			local Ainv, AisValid, Adet = uespLog.SkillCoefComputeAMatrixInv(A)
			local B = uespLog.SkillCoefComputeBMatrix(skillsData, abilityData, i)
			
			table.insert(coefData.A, A)
			table.insert(coefData.Adet, Adet)
			table.insert(coefData.Ainv, Ainv)
			table.insert(coefData.AisValid, AisValid)
			table.insert(coefData.B, B)
			
			if (AisValid) then
				local result = uespLog.SkillCoefComputeMatrixMultAB(Ainv, B)
				result.R2 = uespLog.SkillCoefComputeR2(result, skillsData, abilityData, i)
				result.min, result.max, result.avg = uespLog.SkillCoefComputeMinMaxAvgNumbers(skillsData, i)
				result.type = numberType
				table.insert(coefData.result, result)
				
				if (not uespLog.isFinite(result.a) or not uespLog.isFinite(result.b) or not uespLog.isFinite(result.c) or not uespLog.isFinite(result.R2)) then
				
					if (uespLog.SKILL_COEF_DEBUG) then
						uespLog.DebugMsg("" .. tostring(abilityId) .. ":" .. tostring(i) .. ": Bad Coefficient Data!")
						
						if (not uespLog.isFinite(result.a)) then
							uespLog.DebugMsg("A matrix is not finite!")
						end
						if (not uespLog.isFinite(result.b)) then
							uespLog.DebugMsg("B matrix is not finite!")
						end

						if (not uespLog.isFinite(result.c)) then
							uespLog.DebugMsg("C matrix is not finite!")
						end
						
						if (not uespLog.isFinite(result.R2)) then
							uespLog.DebugMsg("R2 matrix is not finite!")
						end
					end
					
					uespLog.SkillCoefNumBadCoefCount = uespLog.SkillCoefNumBadCoefCount + 1
					
					local badResult = { ['id'] = abilityId, ['numberIndex'] = i, 
						['a'] = uespLog.isFinite(result.a), ['b'] =  uespLog.isFinite(result.b), ['c'] =  uespLog.isFinite(result.c), ['r2'] =  uespLog.isFinite(result.R2) }
						
					if (uespLog.SKILL_COEF_DEBUG) then
						badResult.A = A
						badResult.B = B
						badResult.result = result
					end
						
					table.insert(uespLog.SkillCoefBadData, badResult)
				else
					allInvalid = false
					uespLog.SkillCoefNumValidCoefCount = uespLog.SkillCoefNumValidCoefCount + 1
					
					local mechanic = uespLog.GetSkillCoefNumberMechanic(abilityData, i)
					
					if (mechanic == uespLog.UESP_POWERTYPE_MAGICHEALTHCAP) then
						result.b = uespLog.GetSkillCoefMagicHealthCapValue(abilityData)						
					end
				end
			else
				table.insert(coefData.result, { } )
			end
			
		else
			local value = skillsData[1].numbers[i]
			table.insert(coefData.result, { ['a']=0, ['b']=0, ['c']=value, ['R2']=1, ['min']=value, ['max']=value, ['avg']=value, ['type']=numberType } )
		end
		
	end
	
	calcData.data = coefData
	calcData.result = coefData.result
	calcData.isValid = not allInvalid
	return true
end


function uespLog.GetSkillCoefNumberMechanic(abilityData, numberIndex)
	local mechanic = abilityData.type
	local specialTypes = uespLog.SKILLCOEF_SPECIALTYPES[abilityData.id]
	
	if (specialTypes ~= nil) then
	
		if (type(specialTypes) == "table") then
		
			if (specialTypes[numberIndex] ~= nil) then
				mechanic = specialTypes[numberIndex]
			end
			
		else
			mechanic = specialTypes
		end
	end
	
	return mechanic	
end


function uespLog.GetSkillCoefXY(skill, abilityData, numberIndex)
	local x = skill.mag
	local y = skill.sd
	local z = skill.numbers[numberIndex]
	local valid = true
	local mechanic = uespLog.GetSkillCoefNumberMechanic(abilityData, numberIndex)
			
	if (mechanic == uespLog.UESP_POWERTYPE_SOULTETHER) then
		x = math.max(skill.mag, skill.sta)
		y = skill.sd
	elseif (mechanic == uespLog.UESP_POWERTYPE_LIGHTARMOR) then
		x = skill.la
		y = 0
	elseif (mechanic == uespLog.UESP_POWERTYPE_MEDIUMARMOR) then
		x = skill.ma
		y = 0
	elseif (mechanic == uespLog.UESP_POWERTYPE_HEAVYARMOR) then
		x = skill.ha
		y = 0		
	elseif (mechanic == uespLog.UESP_POWERTYPE_ARMORTYPE) then
		x = skill.armortypes
		y = 0		
	elseif (mechanic == uespLog.UESP_POWERTYPE_WEAPONDAGGER) then
		x = skill.dagger
		y = 0
	elseif (mechanic == uespLog.UESP_POWERTYPE_DAMAGE or mechanic == 4) then
		x = skill.sd
		y = skill.wd
	elseif (mechanic == POWERTYPE_ULTIMATE) then
		x = math.max(skill.mag, skill.sta)
		y = math.max(skill.sd, skill.wd)
	elseif (mechanic == POWERTYPE_STAMINA) then
		x = skill.sta
		y = skill.wd
	elseif (mechanic == POWERTYPE_HEALTH) then
		x = skill.hea
		y = 0
	elseif (mechanic == uespLog.UESP_POWERTYPE_ASSASSINATION) then
		x = 0	-- TODO - Actually count skills
		y = 0		
	elseif (mechanic == uespLog.UESP_POWERTYPE_FIGHTERSGUILD) then
		x = 0	-- TODO - Actually count skills
		y = 0		
	elseif (mechanic == uespLog.UESP_POWERTYPE_BONETYRANT) then
		x = 0	-- TODO - Actually count skills
		y = 0		
	elseif (mechanic == uespLog.UESP_POWERTYPE_GRAVELORD) then
		x = 0	-- TODO - Actually count skills
		y = 0
	elseif (mechanic == uespLog.UESP_POWERTYPE_SHADOW) then
		x = 0	-- TODO - Actually count skills
		y = 0
	elseif (mechanic == uespLog.UESP_POWERTYPE_SPELLDAMAGECAPPED) then
		x = skill.sd
		y = 0
	elseif (mechanic == uespLog.UESP_POWERTYPE_MAGICKACAPPED) then
		x = skill.mag
		y = skill.sd
	elseif (mechanic == uespLog.UESP_POWERTYPE_WEAPONPOWER) then
		x = skill.wp
		y = 0
	elseif (mechanic == uespLog.UESP_POWERTYPE_HEALTHORSPELLDAMAGE) then
		x = skill.sd
		y = skill.hea
	elseif (mechanic == uespLog.UESP_POWERTYPE_RESISTANCE) then
		x = math.max(skill.sr, skill.pr)
		y = 0
	elseif (mechanic == uespLog.UESP_POWERTYPE_MAGICLIGHTARMOR) then
		x = skill.mag
		y = skill.la
	elseif (mechanic == uespLog.UESP_POWERTYPE_MAGICKAWITHWD) then
		x = skill.mag
		y = skill.wd
	elseif (mechanic == uespLog.UESP_POWERTYPE_MAGICHEALTHCAP) then
		x = skill.mag
		y = 0
		
		local capValue = uespLog.GetSkillCoefMagicHealthCapValue(abilityData)
		
		if (capValue > 0 and z >= math.floor(skill.hea * capValue)) then
			valid = false
		end
		
	end
	
	return x, y, valid
end


function uespLog.GetSkillCoefMagicHealthCapValue(abilityData)
	local capMatch, capEnd = string.find(abilityData.desc, "capped at .* of your Max Health")
	local capValue = -1
	
	if (capMatch) then
		local text = string.sub(abilityData.desc, capMatch, capEnd)
		
		for number in string.gmatch(text, "%d+[.]?%d*") do
			capValue = tonumber(number) / 100
		end
	end
	
	return capValue
end


function uespLog.SkillCoefComputeR2(coef, skillsData, abilityData, numberIndex)
	local R2 = 0
	local count = #skillsData
	local averageZ = 0
	local SSres = 0
	local SStot = 0
	local x = 0
	local y = 0
	local valid
	local validCount = 0
	
	if (count == 0 or coef.a == nil ) then
		return R2
	end
	
	for i,skill in ipairs(skillsData) do
		local z = skill.numbers[numberIndex]
		averageZ = averageZ + z
	end
	
	averageZ = averageZ / count
	
	for i, skill in ipairs(skillsData) do
		x, y, valid = uespLog.GetSkillCoefXY(skill, abilityData, numberIndex)
		
		if (valid) then
			local z = skill.numbers[numberIndex]
			local f = x * coef.a + y * coef.b + coef.c
			local e = z - f
			local d = z - averageZ
		
			SStot = SStot + d * d
			SSres = SSres + e * e
			validCount = validCount + 1
		end
	end
	
	if (SStot == 0) then
		return R2, validCount
	end

	R2 = 1 - SSres / SStot
	return R2, validCount
end


function uespLog.SkillCoefComputeMatrixMultAB(A, B)
	local result = {}
	
	if (A.size == 2) then
		result.a = A[11] * B[1] + A[13] * B[3]
		result.b = 0
		result.c = A[31] * B[1] + A[33] * B[3]
	else
		result.a = A[11] * B[1] + A[12] * B[2] + A[13] * B[3]
		result.b = A[21] * B[1] + A[22] * B[2] + A[23] * B[3]
		result.c = A[31] * B[1] + A[32] * B[2] + A[33] * B[3]
	end
	
	return result
end


function uespLog.SkillCoefComputeAMatrix(skillsData, abilityData, numberIndex)
	-- A =  sum_i x[i]*x[i],    sum_i x[i]*y[i],    sum_i x[i]
	--		sum_i x[i]*y[i],    sum_i y[i]*y[i],    sum_i y[i]
	--		sum_i x[i],         sum_i y[i],         sum_i 1
	
	local A = {}
	local x = 0
	local y = 0
	local valid
	local validCount = 0
	
	A[11] = 0
	A[12] = 0
	A[13] = 0
	A[21] = 0
	A[22] = 0
	A[23] = 0
	A[31] = 0
	A[32] = 0
	A[33] = 0
	A['size'] = 3
	
	for i,skill in ipairs(skillsData) do
		local z = skill.numbers[numberIndex]
		
		x, y, valid = uespLog.GetSkillCoefXY(skill, abilityData, numberIndex)
		
		if (valid) then
			A[11] = A[11] + x*x
			A[12] = A[12] + x*y
			A[13] = A[13] + x
			A[21] = A[21] + x*y
			A[22] = A[22] + y*y
			A[23] = A[23] + y
			A[31] = A[31] + x
			A[32] = A[32] + y
			A[33] = A[33] + 1
			validCount = validCount + 1
		end
	end
	
	if (A[12] == 0 and A[21] == 0 and A[22] == 0 and A[23] == 0 and A[32] == 0) then
		A['size'] = 2
	end
	
	return A, validCount
end


function uespLog.SkillCoefComputeMinMaxAvgNumbers(skillsData, numberIndex)
	local minValue = 0
	local maxValue = 0
	local sum = 0
	
	if (#skillsData < 1) then
		return minValue, maxValue, sum
	end
	
	minValue = skillsData[1].numbers[numberIndex]
	maxValue = minValue
	sum = minValue
	
	for i = 2, #skillsData do
		skill = skillsData[i]
		value = skill.numbers[numberIndex]
		sum = sum + minValue
		
		if (minValue > value) then
			minValue = value
		end
		
		if (maxValue < value) then
			maxValue = value
		end
	end
	
	return minValue, maxValue, sum / #skillsData
end


function uespLog.SkillCoefComputeBMatrix(skillsData, abilityData, numberIndex)
	-- B =  sum_i x[i]*z[i],    sum_i y[i]*z[i],    sum_i z[i]
	
	local B = {}
	local x = 0
	local y = 0
	local z = 0
	local valid
	local validCount = 0
	
	B[1] = 0
	B[2] = 0
	B[3] = 0
	
	for i, skill in ipairs(skillsData) do
		z = skill.numbers[numberIndex]
		x, y, valid = uespLog.GetSkillCoefXY(skill, abilityData, numberIndex)
		
		if (valid) then
			B[1] = B[1] + x*z
			B[2] = B[2] + y*z
			B[3] = B[3] + z
			validCount = validCount + 1
		end
	end
	
	return B, validCount
end


function uespLog.SkillCoefComputeAMatrixInv(A)
	local Adet = uespLog.SkillCoefComputeAMatrixDet(A)
	local Ainv = {}
		
	if (det == 0) then
		Ainv['size'] = A['size']
		Ainv[11] = 0
		Ainv[12] = 0
		Ainv[13] = 0
		Ainv[21] = 0
		Ainv[22] = 0
		Ainv[23] = 0
		Ainv[31] = 0
		Ainv[32] = 0
		Ainv[33] = 0

		return Ainv, false, 0
	end
	
	if (A.size == 2) then
		Ainv[11] = A[33] / Adet
		Ainv[12] = 0
		Ainv[13] = -A[13] / Adet
		Ainv[21] = 0
		Ainv[22] = 0
		Ainv[23] = 0
		Ainv[31] = -A[31] / Adet
		Ainv[32] = 0
		Ainv[33] = A[11] / Adet
	else
		Ainv[11] = (A[22]*A[33] - A[32]*A[23]) / Adet
		Ainv[12] = (A[13]*A[32] - A[33]*A[12]) / Adet
		Ainv[13] = (A[12]*A[23] - A[22]*A[13]) / Adet
		Ainv[21] = (A[23]*A[31] - A[33]*A[21]) / Adet
		Ainv[22] = (A[11]*A[33] - A[31]*A[13]) / Adet
		Ainv[23] = (A[13]*A[21] - A[23]*A[11]) / Adet
		Ainv[31] = (A[21]*A[32] - A[31]*A[22]) / Adet
		Ainv[32] = (A[12]*A[31] - A[32]*A[11]) / Adet
		Ainv[33] = (A[11]*A[22] - A[21]*A[12]) / Adet
	end
	
	Ainv['size'] = A['size']
	return Ainv, true, Adet
end	


function uespLog.SkillCoefComputeAMatrixDet(A)
	local Adet = 0
	
	if (A.size == 2) then
		Adet = A[11]*A[33] - A[31]*A[13]
	else
		Adet = A[11]*A[22]*A[33] + A[12]*A[23]*A[31] + A[13]*A[21]*A[32] - A[31]*A[22]*A[13] - A[32]*A[23]*A[11] - A[33]*A[21]*A[12]
	end
	
	return Adet
end


function uespLog.SkillCoefNumber_Average(numbers)
	local sum = 0
	local count = #numbers
	local average = 0
	
	for i,number in ipairs(numbers) do
		sum = sum + number
	end
	
	if (count ~= 0) then
		average = sum / count
	end
	
	return average, sum
end


function uespLog.SkillCoefNumber_AverageDiff(numbers, value)
	local sum = 0
	local count = #numbers
	local average = 0
	
	for i,number in ipairs(numbers) do
		sum = sum + number - value
	end
	
	if (count ~= 0) then
		average = sum / count
	end
	
	return average, sum
end


function uespLog.ReplaceSkillDescriptions()
	
	for abilityId, abilityData in pairs(uespLog.SkillCoefAbilityData) do
		uespLog.ReplaceSkillDescriptionAbility(abilityData)
	end
	
end


function uespLog.ReplaceSkillDescriptionAbility(abilityData)
	local i = 0
	local calcData = uespLog.SkillCoefCalcData[abilityData.id]
	
	if (calcData == nil) then
		return abilityData.desc
	end
    
	local newDesc = string.gsub(abilityData.desc, "%d+[.]?%d*", function (number)
		i = i + 1
	
		if (calcData.numbersVary[i]) then
			return "$" .. tostring(calcData.numbersIndex[i])
		end
		
    end)
	
	abilityData.newDesc = newDesc
	return newDesc
end


function uespLog.isFinite(number)
	return number > -math.huge and number < math.huge 
end


function uespLog.GetSkillMechanicName(mechanic)
	local name = uespLog.SKILLCOEF_MECHANIC_NAMES[mechanic]
	
	if (name == nil) then
		name = tostring(mechanic)
	end
	
	return name
end


function uespLog.UpdateSkillCoefCounts()
	local lastAbilityId = 0
	
	uespLog.SkillCoefAbilityCount = 0
	uespLog.SkillCoefNumValidCoefCount = 0
	uespLog.SkillCoefNumBadCoefCount = 0
	uespLog.SkillCoefDataPointCount = 0
	
	for k, v in pairs(uespLog.SkillCoefAbilityData) do
		uespLog.SkillCoefAbilityCount = uespLog.SkillCoefAbilityCount + 1
		lastAbilityId = k
	end
	
	if (uespLog.SkillCoefData[lastAbilityId] ~= nil) then
		uespLog.SkillCoefDataPointCount = #uespLog.SkillCoefData[lastAbilityId]
	end
	
end


uespLog.SkillDiff = {}


function uespLog.FindSkillDiffSavePlayer()
	local abilityId
	local endId = uespLog.SkillDump_lastAbilityId
	local validAbilityCount = 0
	local newSkills = 0
	
	uespLog.Msg("Saving all skills for diff...")
	
	uespLog.SkillDiff = {}
	
	for abilityId = 1, endId do
	
		if (DoesAbilityExist(abilityId)) then
			local skillType, skillIndex, abilityIndex, morph = GetSpecificSkillAbilityKeysByAbilityId(abilityId)
			local rankData = uespLog.BASESKILL_RANKDATA[abilityId]
			validAbilityCount = validAbilityCount + 1
			
			if (skillType > 0 or rankData ~= nil) then
				local desc = GetAbilityDescription(abilityId)
				
				if (desc ~= "") then
					local newDiff = {}
					newDiff.desc = desc;
					newDiff.cost = uespLog.GetAbilityCost(abilityId)
					newDiff.duration = GetAbilityDuration(abilityId)
					newDiff.minRange, newDiff.maxRange = GetAbilityRange(abilityId)
					uespLog.SkillDiff[abilityId] = newDiff;
					newSkills = newSkills + 1
				end
			end

		end
	end

	uespLog.Msg("Added "..newSkills.." skills out of "..tostring(validAbilityCount).." possible skills to diff data!")
end


function uespLog.FindSkillDiffCountDesc()
	local abilityId
	local endId = uespLog.SkillDump_lastAbilityId
	local validAbilityCount = 0
	local newSkills = 0
	local data = uespLog.savedVars.tempData.data
	
	uespLog.Msg("Finding all skills with numbers in description...")
	data[#data+1] = "Valid Description Skills"	
	
	for abilityId = 1, endId do
		if (DoesAbilityExist(abilityId)) then
			validAbilityCount = validAbilityCount + 1
			local desc = GetAbilityDescription(abilityId)
			
			if (desc ~= "") then
				desc = desc:gsub("|c%x%x%x%x%x%x", "")
				local matchResult = desc:match("%d")
				
				if (matchResult ~= nil) then
					newSkills = newSkills + 1
					local name = GetAbilityName(abilityId)
					data[#data+1] = tostring(name).." ("..tostring(abilityId)..")"
				end
			end

		end
	end

	uespLog.Msg("Found "..newSkills.." skills out of "..tostring(validAbilityCount).." possible skills with valid descriptions!")
end


function uespLog.FindSkillDiffSaveAll()
	local abilityId
	local endId = uespLog.SkillDump_lastAbilityId
	local validAbilityCount = 0
	local newSkills = 0
	
	uespLog.Msg("Saving all skills for diff...")
	
	uespLog.SkillDiff = {}
	
	for abilityId = 1, endId do
		if (DoesAbilityExist(abilityId)) then
			validAbilityCount = validAbilityCount + 1
			local desc = GetAbilityDescription(abilityId)
			
			if (desc ~= "") then
				--local matchResult = desc:match("%d")
				local newDiff = {}
				local index = 0
				local number
				
				newDiff.desc = desc;
				newDiff.cost = uespLog.GetAbilityCost(abilityId)
				newDiff.duration = GetAbilityDuration(abilityId)
				newDiff.minRange, newDiff.maxRange = GetAbilityRange(abilityId)
				newDiff.numbers = {}
				
				desc = desc:gsub("|c%x%x%x%x%x%x", "")
				
				for number in desc:gmatch("%d+[.]?%d*") do
					newDiff.numbers[index] = number
					index = index + 1
				end

				if (index > 0 or newDiff.cost > 0 or newDiff.duration > 0 or newDiff.minRange > 0 or newDiff.maxRange > 0) then
					uespLog.SkillDiff[abilityId] = newDiff
					newSkills = newSkills + 1
				end
			end

		end
	end

	uespLog.Msg("Added "..newSkills.." skills out of "..tostring(validAbilityCount).." possible skills to diff data!")
end


function uespLog.FindSkillDiff(note)
	local abilityId, origDesc
	local diffSkills = 0
	local data = uespLog.savedVars.tempData.data
	local diffData
	
	uespLog.Msg("Comparing skill diff...")
	
	if (note ~= nil) then
		data[#data+1] = note
	end
		
	for abilityId, diffData in pairs(uespLog.SkillDiff) do
		local desc = GetAbilityDescription(abilityId)
		local cost = uespLog.GetAbilityCost(abilityId)
		local duration = GetAbilityDuration(abilityId)
		local minRange, maxRange = GetAbilityRange(abilityId)
		
		origDesc = diffData.desc;
					
		if (desc ~= origDesc) then
			local name = GetAbilityName(abilityId)
			local buffer = "Desc, " .. tostring(abilityId) .. ", \"" .. tostring(name) .. "\""
			local number
			local index = 0
			
			desc = desc:gsub("|c%x%x%x%x%x%x", "")
			
			for number in desc:gmatch("%d+[.]?%d*") do
			
				if (diffData.numbers[index] ~= number) then
					buffer = buffer .. ", " .. index
				end
				
				index = index + 1
			end
			
			diffSkills = diffSkills + 1
			data[#data+1] = buffer
			uespLog.Msg(".    "..buffer)
		end
		
		if (diffData.cost ~= cost) then
			local name = GetAbilityName(abilityId)
			local buffer = "Cost, " .. tostring(abilityId) .. ", \"" .. tostring(name) .. "\", " .. tostring(cost)
			diffSkills = diffSkills + 1
			data[#data+1] = buffer
			uespLog.Msg(".    "..buffer)
		end
		
		if (diffData.duration ~= duration) then
			local name = GetAbilityName(abilityId)
			local buffer = "Duration, " .. tostring(abilityId) .. ", \"" .. tostring(name) .. "\", " .. tostring(duration)
			diffSkills = diffSkills + 1
			data[#data+1] = buffer
			uespLog.Msg(".    "..buffer)
		end
		
		if (diffData.minRange ~= minRange or diffData.maxRange ~= maxRange) then
			local name = GetAbilityName(abilityId)
			local buffer = "Range, " .. tostring(abilityId) .. ", \"" .. tostring(name) .. "\", " .. tostring(minRange) .. ", " .. tostring(maxRange)
			diffSkills = diffSkills + 1
			data[#data+1] = buffer
			uespLog.Msg(".    "..buffer)
		end
		
	end

	uespLog.Msg("Found "..diffSkills.." changed skills!")
end


uespLog.SkillCoefBaseDesc = {}
uespLog.SkillCoefBaseDescSize = 0
uespLog.SkillCoefDescCheckType = ""


function uespLog.ResetSkillCoefDesc()
	uespLog.Msg("Resetting the skill coefficient descriptions...")
	
	local logData = {}
	logData.event = "SkillCoef::Desc::Reset"
	uespLog.AppendDataToLog("all", logData, uespLog.GetTimeData())
end


function uespLog.SaveBaseSkillCoefDesc()
	local abilityId
	local endId = uespLog.SkillDump_lastAbilityId
	local validAbilityCount = 0
	local newSkills = 0
	local startSlotIndex, endSlotIndex = GetAssignableChampionBarStartAndEndSlots()
	local slotIndex
	
	for slotIndex = startSlotIndex, endSlotIndex do
		local skillId = GetSlotBoundId(slotIndex, HOTBAR_CATEGORY_CHAMPION)
		
		if (skillId > 0) then
			uespLog.Msg("Warning: CP slots should generally be empty when saving the base skill coefficient descriptions!")
			break
		end
	end
	
	uespLog.SkillCoefBaseDesc = {}
	uespLog.SkillCoefBaseDescSize = 0
	
	for abilityId = 1, endId do
		if (DoesAbilityExist(abilityId)) then
			validAbilityCount = validAbilityCount + 1
			local desc = GetAbilityDescription(abilityId)
			
			if (desc ~= "") then
				local newDiff = {}
				local index = 1
				local number
				
				newDiff.desc = desc
				newDiff.duration = GetAbilityDuration(abilityId)
				newDiff.cost = uespLog.GetAbilityCost(abilityId)
				newDiff.numbers = {}
				
				desc = desc:gsub("|c%x%x%x%x%x%x", "")
				
				for number in desc:gmatch("%d+[.]?%d*") do
					newDiff.numbers[index] = number
					index = index + 1
				end

				if (index > 1) then
					uespLog.SkillCoefBaseDesc[abilityId] = newDiff
					newSkills = newSkills + 1
					uespLog.SkillCoefBaseDescSize = uespLog.SkillCoefBaseDescSize + 1
				end
			end

		end
	end

	uespLog.DebugMsg("Added "..newSkills.." skills out of "..tostring(validAbilityCount).." possible skills to coefficient diff data!")
end


function uespLog.CheckSkillCoefDesc(note)
	local abilityId
	local diffSkills = 0
	local data = uespLog.savedVars.tempData.data
	local diffData
	local logData
	local timeData = uespLog.GetTimeData()
	
	if (note ~= nil) then
		data[#data+1] = "Checking skill coefficients descriptions for change: " .. tostring(note)
	end
		
	for abilityId, diffData in pairs(uespLog.SkillCoefBaseDesc) do
		local desc = GetAbilityDescription(abilityId)
		local origDesc = diffData.desc;
					
		if (desc ~= origDesc) then
			local name = GetAbilityName(abilityId)
			local buffer = tostring(note) .. ", " .. tostring(abilityId) .. ", \"" .. tostring(name) .. "\""
			local number
			local index = 1
			
			desc = desc:gsub("|c%x%x%x%x%x%x", "")
			
			for number in desc:gmatch("%d+[.]?%d*") do
			
				if (diffData.numbers[index] ~= number) then
					buffer = buffer .. ", " .. index
					
					logData = {}
					logData.event = "SkillCoef::Desc"
					logData.index = index
					logData.type = note
					logData.abilityId = abilityId
					uespLog.AppendDataToLog("all", logData, timeData)
				end
				
				index = index + 1
			end
			
			diffSkills = diffSkills + 1
			data[#data+1] = buffer
		end
		
	end

	uespLog.DebugMsg("Found "..diffSkills.." changed skill descriptions in coefficient data!")
end


function uespLog.CheckSkillCoefCost(note)
	local abilityId
	local diffSkills = 0
	local data = uespLog.savedVars.tempData.data
	local diffData
	local logData
	local costSkills = {}
	local i, row
	local timeData = uespLog.GetTimeData()
	
	if (note ~= nil) then
		data[#data+1] = "Checking skill coefficients costs for change: " .. tostring(note)
	end
		
	for abilityId, diffData in pairs(uespLog.SkillCoefBaseDesc) do
		local name = GetAbilityName(abilityId)
		local cost = uespLog.GetAbilityCost(abilityId)
		local origCost = diffData.cost
		local isDiff = false
		local skillType = GetSpecificSkillAbilityKeysByAbilityId(abilityId)
		
			-- Skip non-player
		if (skillType > 0) then
			cost = origCost
		end
					
		if (cost ~= origCost) then
			local rankData = uespLog.BASESKILL_RANKDATA[abilityId]
			
			if (rankData) then
			
				for i = 1, 4 do
					local rankId = rankData[i]
					
					logData = {}
					logData.event = "SkillCoef::Cost"
					logData.index = "cost"
					logData.type = note
					logData.rank = i
					logData.abilityId = rankId
					uespLog.AppendDataToLog("all", logData, timeData)
				
					data[#data+1] = tostring(note) .. ", " .. tostring(rankId) .. ", \"" .. tostring(name) .. " " .. i .. "\"" .. ", Cost"
					costSkills[#costSkills + 1] = tostring(abilityId) .. " => 0,  // " .. tostring(name) .. " " .. i
				end
			else
				logData = {}
				logData.event = "SkillCoef::Cost"
				logData.index = "cost"
				logData.type = note
				logData.abilityId = abilityId
				uespLog.AppendDataToLog("all", logData, timeData)
				
				data[#data+1] = tostring(note) .. ", " .. tostring(abilityId) .. ", \"" .. tostring(name) .. "\"" .. ", Cost"
				costSkills[#costSkills + 1] = tostring(abilityId) .. " => 0,  // " .. tostring(name)
			end
			
			if (not isDiff) then
				diffSkills = diffSkills + 1
			end
		end
	end
		
	for i, row in ipairs(costSkills) do
		data[#data+1] = row
	end
	
	uespLog.DebugMsg("Found "..diffSkills.." changed skill costs in coefficient data!")
end


function uespLog.CheckSkillCoefDuration(note)
	local abilityId
	local diffSkills = 0
	local data = uespLog.savedVars.tempData.data
	local diffData
	local logData
	local durationSkills = {}
	local i, row
	local timeData = uespLog.GetTimeData()
	
	if (note ~= nil) then
		data[#data+1] = "Checking skill coefficients durations for change: " .. tostring(note)
	end
		
	for abilityId, diffData in pairs(uespLog.SkillCoefBaseDesc) do
		local name = GetAbilityName(abilityId)
		local desc = GetAbilityDescription(abilityId)
		local duration = GetAbilityDuration(abilityId)
		local origDesc = diffData.desc;
		local isDiff = false
					
		if (desc ~= origDesc) then
			local buffer = tostring(note) .. ", " .. tostring(abilityId) .. ", \"" .. tostring(name) .. "\""
			local number
			local index = 1
			
			desc = desc:gsub("|c%x%x%x%x%x%x", "")
			
			for number in desc:gmatch("%d+[.]?%d*") do
			
				if (diffData.numbers[index] ~= number) then
					buffer = buffer .. ", " .. index
					
					logData = {}
					logData.event = "SkillCoef::Desc"
					logData.index = index
					logData.type = note
					logData.abilityId = abilityId
					uespLog.AppendDataToLog("all", logData, timeData)
				end
				
				index = index + 1
			end
			
			diffSkills = diffSkills + 1
			data[#data+1] = buffer
		end
		
		if (duration ~= diffData.duration) then
			local rankData = uespLog.BASESKILL_RANKDATA[abilityId]
			
			if (rankData) then
			
				for i = 1, 4 do
					local rankId = rankData[i]
					
					logData = {}
					logData.event = "SkillCoef::Duration"
					logData.index = "duration"
					logData.type = note
					logData.rank = i
					logData.abilityId = rankId
					uespLog.AppendDataToLog("all", logData, timeData)
				
					data[#data+1] = tostring(note) .. ", " .. tostring(rankId) .. ", \"" .. tostring(name) .. " " .. i .. "\"" .. ", Duration"
					durationSkills[#durationSkills + 1] = tostring(abilityId) .. " => 0,  // " .. tostring(name) .. " " .. i
				end
			else
				logData = {}
				logData.event = "SkillCoef::Duration"
				logData.index = "duration"
				logData.type = note
				logData.abilityId = abilityId
				uespLog.AppendDataToLog("all", logData, timeData)
				
				data[#data+1] = tostring(note) .. ", " .. tostring(abilityId) .. ", \"" .. tostring(name) .. "\"" .. ", Duration"
				durationSkills[#durationSkills + 1] = tostring(abilityId) .. " => 0,  // " .. tostring(name)
			end
			
			if (not isDiff) then
				diffSkills = diffSkills + 1
			end
		end
	end
		
	for i, row in ipairs(durationSkills) do
		data[#data+1] = row
	end
	
	uespLog.DebugMsg("Found "..diffSkills.." changed skill durations in coefficient data!")
end


uespLog.SKILLCOEF_CHECKDESC_TYPES = {
	["dot"] = 27,
	-- ["direct"] = ?,
	["aoedmg"] = 23,
	["stdmg"] = 25,
	["hot"] = 28,
	["aoeheal"] = 24,
	["stheal"] = 26,
}


function uespLog.StartCheckSkillCoefDesc(checkType)

		-- Disable auto purchase/slotting of CPs...works but is awkward
	uespLog.CheckSkillCoefDesc(checkType)
		
	if (true) then
		return
	end
	
	local cpSkillId = uespLog.SKILLCOEF_CHECKDESC_TYPES[checkType]
	
	if (cpSkillId == nil or cpSkillId <= 0) then
		return
	end
	
	if (uespLog.SkillCoefBaseDescSize == 0) then
		uespLog.Msg("Save skill descriptions first with: /usc savedesc")
		return
	end
	
	uespLog.Msg("Starting check of skill coefficient descriptions for '"..tostring(checkType).."'...(wait until finished)")
	uespLog.SkillCoefDescCheckType = checkType
	
	uespLog.SlotCPForCheckSkillCoefDesc(checkType)
end


function uespLog.StartCheckSkillCoefDuration(checkType)
	uespLog.CheckSkillCoefDuration(checkType)
end


function uespLog.SlotCPForCheckSkillCoefDesc(checkType)
	local cpSkillId = uespLog.SKILLCOEF_CHECKDESC_TYPES[checkType]
	
	if (cpSkillId == nil or cpSkillId <= 0) then
		return
	end
	
	uespLog.cpPurchaseErrorCallback = uespLog.CheckSkillCoefDescCPError
	uespLog.cpPurchaseSuccessCallback = uespLog.CheckSkillCoefDescCPSuccess
	uespLog.cpPurchaseCooldownCallback = uespLog.CheckSkillCoefDescCPCooldown
	
	PrepareChampionPurchaseRequest(false)
	
	for slotIndex = 1, 12 do
		AddHotbarSlotToChampionPurchaseRequest(slotIndex, nil)
	end
	
	AddHotbarSlotToChampionPurchaseRequest(5, cpSkillId)
	SendChampionPurchaseRequest()
end


function uespLog.CheckSkillCoefDescCPError(result)

	if (result == CHAMPION_PURCHASE_CHAMPION_BAR_ILLEGAL_SLOT) then
		uespLog.Msg("Waiting for CP slot cooldown to end for skill coefficient description check...")
	else
		uespLog.Msg("Error: Received error "..tostring(result).." when trying to slot CP for skill coefficient description check!")
	end
end


function uespLog.CheckSkillCoefDescCPSuccess()
	uespLog.cpPurchaseErrorCallback = nil
	uespLog.cpPurchaseSuccessCallback = nil
	uespLog.cpPurchaseCooldownCallback = nil
	
	uespLog.Msg("Successfully slotted CP for skill coefficient description check '"..tostring(uespLog.SkillCoefDescCheckType).."'!")
	uespLog.CheckSkillCoefDesc(uespLog.SkillCoefDescCheckType)
	
	uespLog.SkillCoefDescCheckType = ""
end


function uespLog.CheckSkillCoefDescCPCooldown()
	uespLog.SlotCPForCheckSkillCoefDesc(uespLog.SkillCoefDescCheckType)
end


function uespLog.RecalcSkillCoef(abilityId, numberIndex, resultData)
	local calcData = uespLog.SkillCoefCalcData[abilityId]
	local abilityData = uespLog.SkillCoefAbilityData[abilityId]
	local origCoefSpecialType = uespLog.SKILLCOEF_SPECIALTYPES[abilityId]
	local origCoefType = uespLog.GetSkillCoefNumberMechanic(abilityData, numberIndex)
	local skillsData = uespLog.SkillCoefData[abilityId]
	local recalcResults = {}
	local bestR2 = -1
	local bestCoefType = -1
	local bestResult = nil
		
	for j,coefType in pairs(uespLog.SKILLCOEF_RECALC_TYPES) do
	
		uespLog.SKILLCOEF_SPECIALTYPES[abilityId] = { [numberIndex] = coefType }
	
		local A = uespLog.SkillCoefComputeAMatrix(skillsData, abilityData, numberIndex)
		local Ainv, AisValid, Adet = uespLog.SkillCoefComputeAMatrixInv(A)
		local B = uespLog.SkillCoefComputeBMatrix(skillsData, abilityData, numberIndex)
		
		if (AisValid) then
			local result = uespLog.SkillCoefComputeMatrixMultAB(Ainv, B)
			result.R2 = uespLog.SkillCoefComputeR2(result, skillsData, abilityData, numberIndex)
			result.min, result.max, result.avg = uespLog.SkillCoefComputeMinMaxAvgNumbers(skillsData, numberIndex)
			result.type = coefType
			result.origCoefType = origCoefType
			result.id = abilityId
			result.numberIndex = numberIndex
						
			if (not uespLog.isFinite(result.a) or not uespLog.isFinite(result.b) or not uespLog.isFinite(result.c) or not uespLog.isFinite(result.R2)) then
				-- Do nothing....ignore
			else
				allInvalid = false
				uespLog.SkillCoefNumValidCoefCount = uespLog.SkillCoefNumValidCoefCount + 1
				
				local mechanic = uespLog.GetSkillCoefNumberMechanic(abilityData, numberIndex)
				
				if (mechanic == uespLog.UESP_POWERTYPE_MAGICHEALTHCAP) then
					result.b = uespLog.GetSkillCoefMagicHealthCapValue(abilityData)						
				end
				
				recalcResults[coefType] = result
				
				if (result.R2 > bestR2) then
					bestR2 = result.R2
					bestCoefType = coefType
					bestResult = result
				end
			end
		else
			-- Bad calc...ignore
		end
		
	end
	
	uespLog.SKILLCOEF_SPECIALTYPES[abilityId] = origCoefSpecialType
	
	recalcResults.bestCoefType = bestCoefType
	recalcResults.bestR2 = bestR2
	recalcResults.origCoefType = origCoefType
	
	return recalcResults, bestResult, bestCoefType, bestR2, origCoefType
end


function uespLog.TryRecalcAllBadSkillCoefs()
	local data = uespLog.savedVars.tempData.data
	local totalCount = 0
	local recalcCount = 0
	local recalcSuccessCount = 0
	
	data[#data+1] = "Skill Coefficient Recalculation"
	
	uespLog.Msg("Trying to recalculate all bad skill coefficients...")
	
	uespLog.SkillCoefRecalcData = {}
	
	for j, badCoefData in pairs(uespLog.SkillCoefBadData) do
		local id = badCoefData.id
		local calcData = uespLog.SkillCoefCalcData[id]
		local hasOutputName = false
		
		if (calcData ~= nil and not calcData.isValid) then
			uespLog.SkillCoefRecalcData[id] = {}
			
			for i,result in ipairs(calcData.result) do
				local doesVary = calcData.numbersVary[i]
				
				if (doesVary) then
					recalcCount = recalcCount + 1
					local recalcResults, bestResult, bestCoefType, bestR2, origCoefType = uespLog.RecalcSkillCoef(id, i, result)
					
					uespLog.SkillCoefRecalcData[id][i] = recalcResults
					
					if (bestR2 > 0.5) then
						data[#data+1] = "Coefficient " .. tostring(id) .. ":" .. tostring(i) .. " had best result of " .. tostring(bestR2) .. " with coef type " .. tostring(bestCoefType) .. " (original " .. tostring(origCoefType) .. ")"
						recalcSuccessCount = recalcSuccessCount + 1
						
						calcData.result[i] = bestResult
						calcData.isValid = true
					end
				end
			end
		end
		
		totalCount = totalCount + 1
	end
	
	uespLog.Msg("Tried to recalculate " .. recalcCount .. " out of " .. totalCount .. " bad coefficients with " .. recalcSuccessCount .. " better results!")
	totalCount = 0
	recalcCount = 0

	for id,coefData in pairs(uespLog.SkillCoefAbilityData) do
		local calcData = uespLog.SkillCoefCalcData[id]
		local hasOutputName = false
		
		totalCount = totalCount + 1
		
		if (calcData ~= nil and calcData.isValid) then
			uespLog.SkillCoefRecalcData[id] = {}
		
			for i,result in ipairs(calcData.result) do
				local doesVary = calcData.numbersVary[i]
								
				if (doesVary and result.R2 < uespLog.SKILLCOEF_RECALC_MINR2) then
					recalcCount = recalcCount + 1
					local recalcResults, bestResult, bestCoefType, bestR2, origCoefType = uespLog.RecalcSkillCoef(id, i, result)
					uespLog.SkillCoefRecalcData[id][i] = recalcResults
					
					if (bestR2 > result.R2) then
						data[#data+1] = "Coefficient " .. tostring(id) .. ":" .. tostring(i) .. " had best result of " .. tostring(bestR2) .. " with coef type " .. tostring(bestCoefType) .. " (original " .. tostring(origCoefType) .. ")"
						recalcSuccessCount = recalcSuccessCount + 1
						
						calcData.result[i] = bestResult
					end
				end
			end
		end
	end
	
	uespLog.Msg("Tried to recalculate " .. recalcCount .. " out of " .. totalCount .. " coefficients with " .. recalcSuccessCount .. " better results!")
end